<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */











if(file_exists('../start.cnf.php'))
	require '../start.cnf.php';
else
	die("Le fichier 'start.cnf.php' n'existe pas, vous n'avez peut-tre pas encor installer GreenSD (<a href='install/index.php'>Page d'installation de GreenSD</a>).");

require '../cnf.php';
require '../fnts/parcourrepindexnamefile.php';
require '../fnts/parcourrep.php';
require '../cls/checkform.class.php';
//// lang general
loadLang('ge','',true);
connectDb();
$configs = updateArray($configs,getGlobalDatasInDb());
createDefines();
createGlobalUrls();
banIp();
$s = new Session(SCRIPT_NAME.'_admin_'.$configs['install_time']);
$user = new User();

if($user->isAdmin())
{
	//// custom
	loadLang('cu','others',true);
	//// lang utiliser dans les fichiers comme begin.php
	loadLang('ef','others',true);
	//// lang utiliser dans les fichiers comme index.php
	loadLang('ad','others',true);
	
	$tpl->template_dir = PATH_SCR_ADMIN.'tpls/';
	$curUser=$user->getCurrentUser();//current user
	$ADMIN=$user->getCurrentAdmin();
	$GUEST=$user->getCurrentGuest();
	$tpl->assign_by_ref('USER',$curUser);
	$tpl->assign_by_ref('ADMIN',$ADMIN);
	$tpl->assign_by_ref('GUEST',$GUEST);
	
	$currentsection=isset($_GET["section_ad"])?$_GET["section_ad"]:'';
	if(in_array($currentsection,array('index')) || (in_array($currentsection,$ADMIN['switchsadmin']) && $ADMIN['typeadmin'] == 'administrator') || $ADMIN['typeadmin'] == 'superadministrator')
	{
		$tpl->assign('SECTION',$currentsection);
		$currentsectionArray=explode('-',$currentsection);
		if(count($currentsectionArray) == 1)
		{
			$currentsectionParent='general';
			$currentsectionphp=$currentsectionArray[0];
			$currentsectionLang = $currentsectionArray[0];
			$tpl->assign('SECTIONPARENT','');//pas de parent
			$tpl->assign('SECTIONPHP',$currentsectionArray[0]);
			$currentsectionphp=$currentsectionArray[0];
			if(file_exists(PATH_TPLS_ADMIN.$currentsectionArray[0].".tpl"))
				$admin_espace=$currentsectionArray[0].".tpl";
			else
				$admin_espace='404';
		}
		else if(count($currentsectionArray) == 2)
		{
			$currentsectionParent=$currentsectionArray[0];
			$currentsectionphp=$currentsectionArray[1];
			$currentsectionLang = $currentsectionArray[0];
			$tpl->assign_by_ref('SECTIONPARENT',$currentsectionParent);
			$tpl->assign_by_ref('SECTIONPHP',$currentsectionphp);
			switch($currentsectionParent)
			{
				case 'plugins' :
					if(file_exists(PATH_PLUGINS.$currentsectionphp."/".$currentsectionphp.".admin.php"))
						$admin_espace=PATH_PLUGINS.$currentsectionphp."/".$currentsectionphp.".admin.php";
					else
						$admin_espace='404';
					break;
				default :
					if(file_exists(PATH_TPLS_ADMIN.$currentsectionParent."/".$currentsectionphp.".tpl"))
						$admin_espace=$currentsectionParent."/".$currentsectionphp.".tpl";
					else
						$admin_espace='404';
				break;
			}
		}
		else
			$admin_espace='404';
	}
	else
		$admin_espace='404';

	if($admin_espace == '404')
	{
		$body=array();
		$headertpl="";
		$footertpl="";
		if(!in_array($currentsection,$ADMIN['switchsadmin']) && !defined('IN_GREENSD'))
		{
			//loadLang('ge','',true);
			exit(translate('access_denied'));
		}
	}
	else
	{
		define("BEGIN_ADMIN_GREENSD","BEGIN_ADMIN_GREENSD");
		//// lang menu
		loadLang('me','',true);
		//// lang section admin
		loadLang('ad',$currentsectionLang,true);
		//// lang section messages
		loadLang('mf',$currentsectionLang,true);
		//// lang section errors
		loadLang('ef',$currentsectionLang,true);

		////// message par get
		if(isset($_GET['msgs']) && !empty($_GET['msgs']))
			$msgs[] = translate($_GET['msgs']);
		if(isset($_GET['msgsw']) && !empty($_GET['msgsw']))
			$msgsw[] = translate($_GET['msgsw']);
			
		////// menu
		$orderrepstplsadmin=array('cats','links','users','tools','personalizations');
		$excluderepstplsadmin=array("others","imgs","models","ajax","helps");
		$admintpls=parcourRepIndexNameFile(PATH_TPLS_ADMIN,true,$excluderepstplsadmin,$orderrepstplsadmin);
		$adminMenuPlugins=parcourRepIndexNameFile(PATH_PLUGINS,true,array(),array());
		unset($orderrepstplsadmin,$excluderepstplsadmin);
		sort($admintpls['ssdir']);
		$tpl->assign_by_ref('ADMINTPLS',$admintpls);
		$tpl->assign_by_ref('MENUPLUGINS',$adminMenuPlugins);
		
		






		
		$body['open']="<table align='center' class='admin' cellpadding='0' cellspacing='10'><tr><td class='admin_l' rowspan='2'>";
		$body['body'][]=array('open'=> '<div align="center" style="margin-top: 5px;"><a href="'.SCRIPT_URL.'" target="_blank"><img src="'.$URLS['adminTplsImages'].'greensd.png" border="0" alt="" /></a></div>');
		$body['body'][]=array('file'=>'menu.tpl');
		$body['body'][]=array('close'=>'<center>&#169; <a href="'.SCRIPT_URL.'">'.SCRIPT_NAME.'</center>');
		$body['body'][]=array('open'=>'</td><td height="20px">');
		$body['body'][]=array('file'=>'topbar.tpl');
		$body['body'][]=array('open'=>'</td></tr><tr><td class="admin_r"><div id="zoneadminright">');
		$body['body'][]=array('file'=>'msgs.tpl');
		if($currentsectionParent == 'plugins')
			$body['body'][]=array('require'=>$admin_espace);
		else
			$body['body'][]=array('file'=>$admin_espace);
		$body['body'][]=array('open'=>'</div></td>');
		$body['close']="</tr></table>";
	}
	
	
	if(is_dir(PATH_SCRIPT.'/install/'))
	{
		$msgsw[] = translate('w_dir_install_exist');
	}
	//fichiers et repetoire obligatoires
	if(is_dir(PATH_BACKUP_DB))
	{
		if(!file_exists(PATH_BACKUP_DB.'.htaccess'))
			$msgsw[] = translate("w_file_htaccess_backupdb_no_exist");
	}
	else
		$msgsw[] = translate("w_dir_backupdb_no_exist");
	if(is_dir(PATH_CRONS))
	{
		if(!file_exists(PATH_CRONS.'.htaccess'))
			$msgsw[] = translate("w_file_htaccess_crons_no_exist");
	}
	else
		$msgsw[] = translate("w_dir_crons_no_exist");
	
	if(isset($_GET['msgs']) && $_GET['msgs'] == 'msg_clean_cache')
	{
		rmFilesInDir(PATH_CACHE,true,array('smarty'),array(),false);
		$tpl->assign('REDIRECTTAG',redirectPage(replaceInUrl(PROTOCOL_DOMAIN_SELF_REQ,'msgs',''),3,false));
	}
	//ajouter un lien au menu
	else if(isset($_POST['add_to_menu']))
	{
		if(count($ADMIN['menuadmin']) == 0)
		{
			$db->update("UPDATE `$tb_mmbrs` SET `menuadmin`='$currentsection' WHERE `id` = ".$ADMIN['id']." LIMIT 1;");
			$_SESSION[$s->sess_baseVars]['admin']['menuadmin'][] = $currentsection;//m--j
		}
		else if(!in_array($currentsection,$ADMIN['menuadmin']))
		{
			$db->update("UPDATE `$tb_mmbrs` SET `menuadmin`=CONCAT(`menuadmin`,'|','$currentsection') WHERE `id` = ".$ADMIN['id']." LIMIT 1;");
			$_SESSION[$s->sess_baseVars]['admin']['menuadmin'][] = $currentsection;//m--j
		}
		redirectPage(replaceInUrl(PROTOCOL_DOMAIN_SELF_REQ,'msgs',''),0,false);
	}
	else if(isset($_POST['add_to_menu_no']))
		redirectPage(replaceInUrl(PROTOCOL_DOMAIN_SELF_REQ,'msgs',''),0,false);
	//enlever un lien au menu
	else if(isset($_POST['delete_in_menu']))
	{
		if(count($ADMIN['menuadmin']) > 0 && in_array($currentsection,$ADMIN['menuadmin']))
		{
			$row = $db->getOneRow($tb_mmbrs,'`menuadmin`','`id`='.$ADMIN['id']);
			$db->update("UPDATE `$tb_mmbrs` SET `menuadmin`='".str_replace(array('|'.$currentsection,$currentsection.'|'),'',$row['menuadmin'])."' WHERE `id` = ".$ADMIN['id']." LIMIT 1;");
			unset($row);
		}
		$_SESSION[$s->sess_baseVars]['admin']['menuadmin'] = deleteInArray($_SESSION[$s->sess_baseVars]['admin']['menuadmin'],$currentsection);//m--j
		redirectPage(replaceInUrl(PROTOCOL_DOMAIN_SELF_REQ,'msgs',''),0,false);
	}
	else if(isset($_POST['delete_in_menu_no']))
		redirectPage(replaceInUrl(PROTOCOL_DOMAIN_SELF_REQ,'msgs',''),0,false);
}
else
{
	header("Location: login.php");
	echo "<meta http-equiv=\"refresh\" content=\"0;url=login.php\">";
	exit(0);
}
?>