<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require 'begin.php';
require '../fnts/pagination.php';

$currentForm=isset($_GET['selectform'])?$_GET['selectform']:'';
/*
 * Creation de champs
 */
$sbmnbrfields=isset($_POST['sbmnbrfields'])?$_POST['sbmnbrfields']:'';
$nbrfields=isset($_POST['nbrfields'])?stripslashes($_POST['nbrfields']):1;
$field_after=isset($_POST['field_after'])?stripslashes($_POST['field_after']):'';$tpl->assign_by_ref('FIELD_AFTER',$field_after);
$field_name=isset($_POST['field_name'])?stripslashes_array($_POST['field_name']):'';
$field_type=isset($_POST['field_type'])?stripslashes_array($_POST['field_type']):'';
$field_length=isset($_POST['field_length'])?stripslashes_array($_POST['field_length']):'';
$field_attribute=isset($_POST['field_attribute'])?stripslashes_array($_POST['field_attribute']):'';
$field_null=isset($_POST['field_null'])?stripslashes_array($_POST['field_null']):'';
$field_default=isset($_POST['field_default'])?stripslashes_array($_POST['field_default']):'';
$field_extra=isset($_POST['field_extra'])?stripslashes_array($_POST['field_extra']):'';
$field_key=isset($_POST['field_key'])?stripslashes_array($_POST['field_key']):'';
$field_fulltext=isset($_POST['field_fulltext'])?stripslashes_array($_POST['field_fulltext']):'';

switch($currentForm)
{
	case 'addCat' :
		$prfex = 'cc_';//custom
		break;
	case 'addLink' :
		$prfex = 'cl_';//custom
		break;
	case 'addUser' :
		$prfex = 'cm_';//custom
		break;
}
$tpl->assign_by_ref('PRFEX',$prfex);
$infosForCreateField['addCat'] = array('table'=>$tb_cats,'prfex'=>'addCat_');
$infosForCreateField['addLink'] = array('table'=>$tb_links,'prfex'=>'addLink_');
$infosForCreateField['addUser'] = array('table'=>$tb_mmbrs,'prfex'=>'addUser_');
$formsAccept = array('addCat','addLink','addUser');//formulaire ou l'on peut crer des champs
//les types de champs possible
$typesFields=array(
                        'VARCHAR','TINYINT','TEXT','DATE',
                        'SMALLINT','MEDIUMINT','INT','BIGINT',
                        'FLOAT','DOUBLE','DECIMAL','DATETIME',
                        'TIMESTAMP','TIME','YEAR','CHAR',
                        //'TINYBLOB',
                        'TINYTEXT',
                        //'BLOB',
                        //'MEDIUMBLOB',
                        'MEDIUMTEXT',
                        //'LONGBLOB',
                        'LONGTEXT','ENUM','SET','BINARY','VARBINARY'
);$tpl->assign_by_ref('TYPESFIELDS',$typesFields);
//tableau de champs envoyes( par defaut un champ vide sera afficher )
$NEWFIELDS=array();$tpl->assign_by_ref('NEWFIELDS',$NEWFIELDS);
if(!empty($currentForm))
{
    for($i=0;$i<$nbrfields;$i++)
    {
        if(isset($field_name[$i]))
        {
          $NEWFIELDS[]=array(
                'name'=>$field_name[$i],
                'type'=>$field_type[$i],
                'length'=>$field_length[$i],
                'attribute'=>$field_attribute[$i],
                'null'=>$field_null[$i],
                'default'=>$field_default[$i],
                'extra'=>$field_extra[$i],
                'key'=>$field_key[$i],
                'fulltext'=>$field_fulltext[$i]
                );
        }
        else
        {
          $NEWFIELDS[]=array(
                'name'=>'',
                'type'=>'',
                'length'=>'',
                'attribute'=>'',
                'null'=>'',
                'default'=>'',
                'extra'=>'',
                'key'=>'',
                'fulltext'=>''
                );
        }
    }
}
//gnration du code tpl
$codehtml = '';
$msgsErreursForms = '';
$tpl->assign_by_ref('MSGSERREURSFORMS',$msgsErreursForms);
$tpl->assign_by_ref('CODEHTML',$codehtml);
if((isset($_POST['sbmgenrcodehtml']) || isset($_POST['sbmnewfield'])) && in_array($currentForm,$formsAccept))
{
	$trTd = isset($_POST['codehtml_tr_td'])?true:false;
	for($i=0;$i<count($field_name);$i++)
	{
		if(isset($field_name[$i]) && !empty($field_name[$i]))
		{
			$msgsErreursForms .= htmlentities($currentForm.'_'.$prfex.$field_name[$i].'_label = "'.$field_name[$i].'"'."\n");
			$msgsErreursForms .= htmlentities($currentForm.'_'.$prfex.$field_name[$i].'_required = "Le champ '.$field_name[$i].' est obligatoire"'."\n");
			$msgsErreursForms .= htmlentities($currentForm.'_'.$prfex.$field_name[$i].'_maxCars = "Vous avez dpasser le nombre de caractre maximum autoriss dans le champ '.$field_name[$i].'"'."\n");
			$msgsErreursForms .= htmlentities($currentForm.'_'.$prfex.$field_name[$i].'_minCars = "Entrer plus de caractres pour le champ '.$field_name[$i].'"'."\n");
			$msgsErreursForms .= htmlentities($currentForm.'_'.$prfex.$field_name[$i].'_acceptCars = "Vrifier le champ '.$field_name[$i].', certains caractre ne sont peut-tre pas autoriss"'."\n\n");
	        
			if($trTd)
				$codehtml .= htmlentities('<tr>'."\n\t".'<td>'."\n\t\t");
			$codehtml .= htmlentities('{#'.$currentForm.'_'.$prfex.$field_name[$i].'_label#} : ');
			if($trTd)
				$codehtml .= htmlentities("\n\t".'</td>'."\n\t".'<td>'."\n\t\t");
			switch($field_type[$i])
	        {
	        	case 'MEDIUMTEXT' :
	        	case 'TINYTEXT' :
	        	case 'LONGTEXT' :
	        	case 'TEXT' : 
	        		$codehtml .= htmlentities('<textarea name="'.$infosForCreateField[$currentForm]['prfex'].$prfex.$field_name[$i].'"></textarea>'."\n");
	        		break;

				case 'ENUM' : 
					$tmpFieldLenghtArr=explode(',',$field_length[$i]);
					for($j=0;$j<count($tmpFieldLenghtArr);$j++)
					{
						$tmpFieldLenghtArr[$j] = str_replace("'",'',$tmpFieldLenghtArr[$j]);
						$codehtml .= htmlentities('<input name="'.$infosForCreateField[$currentForm]['prfex'].$prfex.$field_name[$i].'" type="radio" value="'.$tmpFieldLenghtArr[$j].'" />'."\n");
					}
					if($field_null[$i] == 'NULL')
						$codehtml .= htmlentities('<input name="'.$infosForCreateField[$currentForm]['prfex'].$prfex.$field_name[$i].'" type="radio" value="NULL" />'."\n");
					break;

				case 'SET' :
					$tmpFieldLenghtArr=explode(',',$field_length[$i]);
					$codehtml .= htmlentities('<select name="'.$infosForCreateField[$currentForm]['prfex'].$prfex.$field_name[$i].'" multiple="multiple">'."\n");
					for($j=0;$j<count($tmpFieldLenghtArr);$j++)
					{
						$tmpFieldLenghtArr[$j] = str_replace("'",'',$tmpFieldLenghtArr[$j]);
						$codehtml .= htmlentities('<option value="'.$tmpFieldLenghtArr[$j].'" />'.$tmpFieldLenghtArr[$j]."\n");
					}
					if($field_null[$i] == 'NULL')
						$codehtml .= htmlentities('<option value="NULL" />NULL'."\n");
					$codehtml .= htmlentities('</select>'."\n\r");
					break;

	        	case 'BINARY' :
				case 'VARBINARY' :
	        	case 'DATETIME' :
	        	case 'YEAR' :
	        	case 'CHAR' :
	        	case 'TIME' :
	        	case 'DECIMAL' :
	        	case 'DATE' :
	        	case 'FLOAT' :
	        	case 'TIMESTAMP' :
	        	case 'BIGINT' :
	        	case 'DOUBLE' :
	        	case 'TINYINT' : 
				case 'SMALLINT' :
				case 'MEDIUMINT' :
				case 'VARCHAR' :
				case 'INT' : 
				default :
					$codehtml .= htmlentities('<input name="'.$infosForCreateField[$currentForm]['prfex'].$prfex.$field_name[$i].'" type="text" />'."\n");
					break;
	        }
	        if($trTd)
				$codehtml .= htmlentities("\n\t".'</td>'."\n".'</tr>'."\n");
		}
    }
}
//on prpare le requete pour l'ajout des champs
if(isset($_POST['sbmnewfield']) && in_array($currentForm,$formsAccept))
{
    if(isset($infosForCreateField[$currentForm]['table']))
    {
        $SQLaddfields="ALTER TABLE `".$infosForCreateField[$currentForm]['table']."` ";//va contenur le requete a executer pour l'ajout de champ
        $arrayOtherSQL=array();
        // r ajout des champ
        for($i=0;$i<count($NEWFIELDS);$i++)
        {
            //type
            $SQLaddfields.="ADD `".$prfex.$NEWFIELDS[$i]['name']."` ".$NEWFIELDS[$i]['type'];
            //length
            if(!empty($NEWFIELDS[$i]['length']))
                $SQLaddfields.="(".$NEWFIELDS[$i]['length'].")";
            //attribute
            if(!empty($NEWFIELDS[$i]['attribute']))
                $SQLaddfields.= " ".$NEWFIELDS[$i]['attribute'];
            //default
            if(!empty($NEWFIELDS[$i]['default']))
                $SQLaddfields.=" DEFAULT '".$NEWFIELDS[$i]['default']."'";
            //null
            if($NEWFIELDS[$i]['null'] == 'NOT NULL')
                $SQLaddfields.=" ".$NEWFIELDS[$i]['null'];//si NULL on laisse vide
            //extra
            if(!empty($NEWFIELDS[$i]['extra']))
                $SQLaddfields.=" ".$NEWFIELDS[$i]['extra'];
            //key
            switch ($NEWFIELDS[$i]['key'])
            {
                case 'PRIMARY' : $SQLaddfields.=" ".$NEWFIELDS[$i]['key']." KEY";break;
                case 'UNIQUE' :  $arrayOtherSQL['UNIQUE'][]=$NEWFIELDS[$i]['name'];break;
                case 'INDEX' :   $arrayOtherSQL['INDEX'][]=$NEWFIELDS[$i]['name'];break;
            }
            //fulltext
              if(!empty($NEWFIELDS[$i]['FULLTEXT']))
                  $arrayOtherSQL['fulltext'][]=$NEWFIELDS[$i]['name'];
            //AFTER
            if(!empty($field_after))
                $SQLaddfields.=" AFTER `$field_after`";
            if($i < count($NEWFIELDS)-1)
                $SQLaddfields.=',';
        }
        $SQLaddfields.='; ';
        //la suite avec fulltext, unique ... qu on a stock dans $arrayOtherSQL
        foreach($arrayOtherSQL as $key => $item)
        {
            if(count($item) > 0)//debut de la construction de sql pour unique
            {
                $SQLaddfields .= "ALTER TABLE `$table` ADD $key (";
                for($i=0;$i<count($item);$i++)
                {
                    $SQLaddfields .= "`".$item[$i]."`";
                    if($i < count($item)-1)
                        $SQLaddfields.=',';
                }
                $SQLaddfields .= ");";
            }
        }
        if(count($NEWFIELDS) > 0)
        {
	        // on crer les champs demander
	        if(!mysql_query($SQLaddfields))
	            $msgsw[] = translate('db_error').' : '.mysql_error();
	        else
	        {
	            $msgs[] = translate('add_field_in_db');
	            //champs de vrification dans la table checkfields
	            for($i=0;$i<count($NEWFIELDS);$i++)
	            	$db->insertArr($tb_ckforms,array('field'=>$prfex.$NEWFIELDS[$i]['name'],'formName'=>$currentForm));
	            //on efface tous
	            $NEWFIELDS=array();
	            $nbrfields = 0;
	            $_POST['nbrfields'] = 0;
	        }
        }
        else
        	$msgsw[] = translate('enter_nbrfields');
    }
    else
    {
        $msgsw[] = translate('forms_form_addfield_select_no');
    }
}

/*
 * Controle de formulaire 
 */
////PAGINATION////PAGINATION////PAGINATION////PAGINATION////PAGINATION////PAGINATION
////PAGINATION////PAGINATION////PAGINATION////PAGINATION////PAGINATION////PAGINATION
$r = $db->query("SELECT * FROM `$tb_ckforms` WHERE `formName` = '$currentForm'"); /* une requete pour le nombre total */
$nbrtotal=mysql_num_rows($r);/* nombre de ligne */
$db->free($r);
$nomberbypage=15;
isset($_GET['start'])?$startpage=$_GET['start']:$startpage=0;
$tpl->assign('PAGE',pagination($startpage,$nomberbypage,$nbrtotal,'start',false));
$tpl->assign('PAGIN',$tpl->fetch('pagination.tpl'));/* pagination*/

//ORDER BY//ORDER BY//ORDER BY//ORDER BY//ORDER BY//ORDER BY//ORDER BY
//ORDER BY//ORDER BY//ORDER BY//ORDER BY//ORDER BY//ORDER BY//ORDER BY
isset($_GET['sort'])?$sort=$_GET['sort']:$sort='';$tpl->assign('SORT',$sort);
if(!empty($sort))
{
	$order=explode("-",$sort);
	if(count($order) == 2)
		$orderby="ORDER BY `".$order[0]."` ".$order[1];
		
}
else
	$orderby="";

////AFFICHAGE////AFFICHAGE////AFFICHAGE////AFFICHAGE////AFFICHAGE
////AFFICHAGE////AFFICHAGE////AFFICHAGE////AFFICHAGE////AFFICHAGE
$r = $db->query("SELECT * FROM `$tb_ckforms` WHERE `formName` = '$currentForm' $orderby  LIMIT $startpage , $nomberbypage");
$results=array();
$jsedit='$(function() {';
while($row=$db->getRow($r,"MYSQL_ASSOC"))/* on cherche les infos  */
{
	$jsedit.='$(".edit_maxCars_'.$row['id'].'").editable(
	"'.URL_ADMIN.'ajax.edit.php?action=forms",
	{
		indicator : "Saving...",
		tooltip   : "Doubleclick to edit...",
		submit    : "OK",
		cancel    : "Cancel",
		event     : "dblclick",
		submitdata: { id: "'.$row['id'].'",fieldname: "maxCars" }
	});
	';
	$jsedit.='$(".edit_minCars_'.$row['id'].'").editable(
	"'.URL_ADMIN.'ajax.edit.php?action=forms",
	{
		indicator : "Saving...",
		tooltip   : "Doubleclick to edit...",
		submit    : "OK",
		cancel    : "Cancel",
		event     : "dblclick",
		submitdata: { id: "'.$row['id'].'",fieldname: "minCars"}
	});
	';
	$jsedit.='$(".edit_acceptCars_'.$row['id'].'").editable(
	"'.URL_ADMIN.'ajax.edit.php?action=forms",
	{
		indicator : "Saving...",
		tooltip   : "Doubleclick to edit...",
		submit    : "OK",
		cancel    : "Cancel",
		event     : "dblclick",
		submitdata: { id: "'.$row['id'].'",fieldname: "acceptCars" }
	});
	';
	$jsedit.='$(".edit_required_'.$row['id'].'").editable(
	"'.URL_ADMIN.'ajax.edit.php?action=forms",
	{
		indicator : "Saving...",
		tooltip   : "Doubleclick to edit...",
		type      : "select",
		data      : "{\'no\':\'no\',\'yes\':\'yes\',\'selected\':\''.$row['required'].'\'}",
		submit    : "OK",
		cancel    : "Cancel",
		event     : "dblclick",
		submitdata: { id: "'.$row['id'].'",fieldname: "required" }
		
	});
	';
	$row['maxCars']='<div class="edit_maxCars_'.$row['id'].'">'.$row['maxCars'].'</div>';
	$row['minCars']='<div class="edit_minCars_'.$row['id'].'">'.$row['minCars'].'</div>';
	$row['required']='<div class="edit_required_'.$row['id'].'">'.$row['required'].'</div>';
	$row['acceptCars']='<div class="edit_acceptCars_'.$row['id'].'">'.$row['acceptCars'].'</div>';
	$results[]=$row;
}
$jsedit.='});';
$tpl->assign('JSFUNCTIONS',$jsedit);
$tpl->assign('CHECKFORMS',$results);

$db->free($r);

////LIST FORMS////LIST FORMS////LIST FORMS////LIST FORMS////LIST FORMS
////LIST FORMS////LIST FORMS////LIST FORMS////LIST FORMS////LIST FORMS
$r = $db->query("SELECT DISTINCT `formName` FROM `$tb_ckforms` GROUP BY `formName`");
$results=array();

while($row=$db->getRow($r,"MYSQL_ASSOC"))/* on cherche les infos  */
{
	$results[]=$row;
}
$tpl->assign('LSTFORMS',$results);
$db->free($r);

////LIST FIELDS////LIST FIELDS////LIST FIELDS////LIST FIELDS////LIST FIELDS
////LIST FIELDS////LIST FIELDS////LIST FIELDS////LIST FIELDS////LIST FIELDS
if(!empty($currentForm))
{
    $r = $db->query("SHOW COLUMNS FROM `".$infosForCreateField[$currentForm]['table']."`;");
    $tb_columns=array();
    $tpl->assign_by_ref('TBCOLUMNS',$tb_columns);
    while($row=$db->getRow($r,"MYSQL_NUM"))/* on cherche les infos  */
    {
    	$tb_columns[]=$row[0];
    }
}
require 'end.php' ;
?>