<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class Cache
{
	private $path_cache;
	private $cacheTime = TIME_CACHE;//en minites
	private $dir = '';
	function __construct($PATH_CACHE)
	{
		$this->path_cache = $PATH_CACHE;
		if(!is_dir($this->path_cache))
			mkdir($this->path_cache);//creation
	}
	function __destruct()
	{
		
	}
	function pathFile($id)
	{
		return $this->path_cache.$this->dir.'/'.md5($id);
	}
	function setDir($dir)
	{
		$this->dir = $dir;
		//creation
		$dirs=explode('/',$dir);
		$parents = '';
		for($i=0;$i<count($dirs);$i++)
		{
			if(!is_dir($this->path_cache.$parents.$dirs[$i].'/'))
				mkdir($this->path_cache.$parents.$dirs[$i].'/');
			$parents .= $dirs[$i].'/';
		}
	}
	function exist($id)
	{
		if(file_exists($this->pathFile($id)) && !is_dir($this->pathFile($id)))
			return true;
		else
			return false;
	}

	function checkTime($id,$time)
	{
		if(empty($time))
			$time = $this->cacheTime;
		if((filemtime($this->pathFile($id))+$time) < time())
			return true;//depassement
		else
			return false;
	}
	function create($id,$datas)
	{
		file_put_contents($this->pathFile($id),$datas);
	}
	function read($id)
	{
		return file_get_contents($this->pathFile($id));
	}
	function old($id,$create,$time)
	{//return false si la date de modification est depasser
		if($this->exist($id))
		{
			if($this->checkTime($id,$time))
			{
				//recreation pour chancher la date de la dernier modif
				if($create)
					$this->create($id,$this->read($id));
				return true;
			}
			else
				return false;
		}
		else if($create)
		{//on le ceer et on dit que qu'il ya un depassement de la date de validiter
			$this->create($id,'');
			return true;
		}
		else//depassement car le fichier n'existe pas
			return true;
			
	}
	
}
?>