<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class Cat
{
	private $js_edit = '';
	private $cats = array();
	private $cat_fields ='';
	private $customFields=array();
	function __construct()
	{
		global $tb_cats;
		$this->cat_fields = "
		`$tb_cats`.`id` AS `id`,
		`$tb_cats`.`type` AS `type`,
		`$tb_cats`.`name` AS `name`,
		`$tb_cats`.`description` AS `description`,
		`$tb_cats`.`tags` AS `tags`,
		`$tb_cats`.`parentid` AS `parentid`,
		`$tb_cats`.`parentsids` AS `parentsids`,
		`$tb_cats`.`parentname` AS `parentname`,
		`$tb_cats`.`parentsnames` AS `parentsnames`,
		`$tb_cats`.`subscat` AS `subscat`,
		`$tb_cats`.`nav` AS `nav`,
		`$tb_cats`.`stats` AS `stats`,
		`$tb_cats`.`icon` AS `icon`,
		`$tb_cats`.`hide` AS `hide`,
		`$tb_cats`.`delete` AS `delete`,
		`$tb_cats`.`valid` AS `valid`
		";

	}
	function __destruct()
	{

	}
	private function selectCostumFields()
	{
		if(count($this->customFields) == 0)
		{
			global $db,$tb_cats;
			$r=$db->query("SHOW COLUMNS FROM `".$tb_cats."` LIKE 'cc_%';");
			while ($row=$db->getRow($r,"MYSQL_ASSOC"))
			{
				$this->cat_fields .= ",`".$row['Field']."`";
				$this->customFields[] = $row['Field'];
			}
			$db->free($r);
		}
	}
	private function getCat($id,$fields=array())
	{//infos de la BD
		global $tb_cats,$db;
		if($id > 0)
		{
			if(count($fields) == 0)
				$SQLfields = '*';//tous les champs
			else
			{//selection de champs
				$SQLfields = '';
				for($i=0;$i < count($fields);$i++)
				{
					$SQLfields .= '`'.$fields[$i].'`';
					if($i < count($fields)-1)
						$SQLfields .= ',';
				}
			}
			$r=$db->query("SELECT $SQLfields FROM `$tb_cats` WHERE ".SQL_CATS_ALL." AND `id`=$id Limit 1;");
			$row = $db->getRow($r,'MYSQL_ASSOC');
			$db->free($r);
			return $row;
		}
		else
			return array();
	}
	function getCatForm($id)
	{//form de maj
		global $f;
		$update=$this->getCat($id);
		$return = array();
		$return[$f->form.'_parentid']      =isset($update['parentid'])      ?$update['parentid']      :'';
		$return[$f->form.'_name']      =isset($update['name'])      ?$update['name']      :'';
		$return[$f->form.'_icon']        =isset($update['icon'])        ?$update['icon']        :'';
		$return[$f->form.'_description']=isset($update['description'])?$update['description']:'';
		$return[$f->form.'_tags']=isset($update['tags'])?$update['tags']:'';
		//les champs personaliss
		$this->selectCostumFields();
		for($i=0;$i<count($this->customFields);$i++)
		{
			$return[$f->form.'_'.$this->customFields[$i]]=$update[$this->customFields[$i]];
		}
		return $return;
	}
	function addMultiCats($multi,$parentid,$level)
	{//
		global $db,$tb_cats,$f,$msgsw;
		$multicats=explode('[-'.$level.'-]',$multi);
		for($i=1;$i<count($multicats);$i++)//le 1er est vide [-0-]cat1[-0-]cat2
		{
			$ssmulticats=explode('[-'.($level+1).'-]',$multicats[$i]);
			$parentcat = $db->getOneRow($tb_cats,'`name`','`id`='.$parentid);
			$datas = array(
					'parentid'=>$parentid,
					//'parentsids'=>$this->parentsIdsCatCreateStruct($parentid,array(0)),
					//'parentsnames'=>trim(trim($this->parentsNamesCatCreateStruct($parentid,array(0)).']['.gpcToBd($ssmulticats[0]),'][')),
					'parentname'=>isset($parentcat['name'])?$parentcat['name']:'',
					//'subscat'=>$this->subsCatCreateStruct(gpcToBd($_POST[$f->form.'_parentid'])),
					//'nav'=>$this->navCatCreateStruct(gpcToBd($_POST[$f->form.'_parentid']),array(0)),
					//'stats'=>$this->statsCatCreateStruct(gpcToBd($_POST[$f->form.'_parentid'])),
					'name'=>gpcToBd($ssmulticats[0]),
					'description'=>gpcToBd($_POST[$f->form.'_description']),
					'tags'=>gpcToBd($_POST[$f->form.'_tags']),
					'icon'=>gpcToBd($_POST[$f->form.'_icon'])
				);
			//champs custom
			$this->selectCostumFields();
			for($j=0;$j<count($this->customFields);$j++)
				$datas[$this->customFields[$j]] = gpcToBd($_POST[$f->form.'_'.$this->customFields[$j]]);

			if(isset($_POST[$f->form.'_valid']))
				$datas['valid'] = '1';
			else
				$datas['valid'] = '0';
			
			if(!$catid = $db->insertArr($tb_cats, $datas))
				$msgsw[] = translate("db_error")." : ".$ssmulticats[0];
				
			if(count($ssmulticats) > 1)
				$this->addMultiCats($multicats[$i],$catid,($level+1));
				
			$this->statsCatUpdateStructCache($catid);//a la fin pour compter ces sous catgoroies
			$this->navCatUpdateStructCache($catid);//a la fin
			$this->subsCatUpdateStructCache($catid);//a la fin
			
		}
		return true;
	}
	function addCat($admin=false,$update=false,$catid='')
	{
		global $db,$tb_cats,$tb_mmbrs,$f,$stat,$configs;
		if(count($f->getErrors()) == 0)
		{
			$parentcat = $db->getOneRow($tb_cats,'`name`','`id`='.$_POST[$f->form.'_parentid']);
			$datas = array(
					'parentid'=>gpcToBd($_POST[$f->form.'_parentid']),
					//'parentsids'=>$this->parentsIdsCatCreateStruct(gpcToBd($_POST[$f->form.'_parentid']),array(0)),
					//'parentsnames'=>trim(trim($this->parentsNamesCatCreateStruct(gpcToBd($_POST[$f->form.'_parentid']),array(0)).']['.gpcToBd($_POST[$f->form.'_name']),'][')),
					'parentname'=>isset($parentcat['name'])?gpcToBd($parentcat['name']):'',
					'name'=>gpcToBd($_POST[$f->form.'_name']),
					'description'=>gpcToBd($_POST[$f->form.'_description']),
					'tags'=>gpcToBd($_POST[$f->form.'_tags']),
					'icon'=>gpcToBd($_POST[$f->form.'_icon'])
				);
			//champs custom
			$this->selectCostumFields();
			for($i=0;$i<count($this->customFields);$i++)
			{
				$_POST[$f->form.'_'.$this->customFields[$i]] = is_array($_POST[$f->form.'_'.$this->customFields[$i]])?implode(',',$_POST[$f->form.'_'.$this->customFields[$i]]):$_POST[$f->form.'_'.$this->customFields[$i]];
				$datas[$this->customFields[$i]] = gpcToBd($_POST[$f->form.'_'.$this->customFields[$i]]);
			}
			if($update)
			{////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J
				if($admin)
				{//maj par admin
					if($db->updateArr($tb_cats, $datas, "`id`=$catid"))
					{
						$stat->GreenSDGeneral(false);
						$this->statsCatUpdateStructCache($catid);
						$this->parentsNamesCatUpdateStruct($catid,array(0));
						$this->parentsIdsCatUpdateStruct($catid,array(0));
						return true;
					}
					else
						return false;
				}
			}
			else
			{////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT
				if($admin)
				{//ajout par admin
					if(isset($_POST[$f->form.'_valid']))
						$datas['valid']='1';
					else
						$datas['valid']='0';
					if($newcatid=$db->insertArr($tb_cats, $datas))
					{
						//mise  jour les statistiques
						$stat->GreenSDGeneral(false);
						$this->statsCatUpdateStructCache($newcatid);//initialisation du cache
						if(isset($_POST[$f->form.'_valid']))
						{
							//Le cache de la catgorie elle mme
							$this->navCatUpdateStructCache($newcatid);
							$this->subsCatUpdateStructCache($newcatid);
							if(isset($_POST[$f->form.'_valid']))
							{
								$this->parentsNamesCatUpdateStruct($newcatid,array(0));
								$this->parentsIdsCatUpdateStruct($newcatid,array(0));
							}
						}
						return true;
					}
					else
					{
						return false;
					}
				}
				else
				{//ajou par membre
					$datas['valid']='0';
					if($newcatid=$db->insertArr($tb_cats, $datas))
					{
						//incrment le compteur
						$f->antiRobotForm($configs['config_users_antirobot_tentative_max_addcat'],$configs['config_users_antirobot_tentative_wait_addcat']);
						//mise  jour des statistiques
						$this->statsCatUpdateStructCache($newcatid);//mise   jour des statistiques normalement toutes les statistiqutes  0, car c une nouvelle cat
						$stat->GreenSDGeneral(false);
						return true;
					}
					else
					{
						return false;
					}
				}
			}
		}
		else
			return false;
	}
	function checkFormDescription($update=false,$catid='')
	{
		global $f;
		return $f->checkField('description',$_POST[$f->form.'_description']);
	}
	function checkFormTags($update=false,$catid='')
	{
		global $f;
		return $f->checkField('tags',$_POST[$f->form.'_tags']);
	}
	function checkFormIcon($update=false,$catid='')
	{
		global $f;
		return $f->checkField('icon',$_POST[$f->form.'_icon']);
	}
	function checkFormName($update=false,$catid='')
	{
		global $f;
		return $f->checkField('name',trim($_POST[$f->form.'_name']));
	}
	function checkFormParentid($update=false,$catid='')
	{
		global $f,$tb_cats;
		if($f->checkField('parentid',array('ctype_digit',$_POST[$f->form.'_parentid'])))
		{
			if($_POST[$f->form.'_parentid'] > 0)
				return $f->checkField('id',array('no_exist',$tb_cats,$_POST[$f->form.'_parentid'],SQL_CATS_VALID));
			else
				return true;
		}
	}
	function checkFormMultiName($update=false,$catid='',$name,$level)
	{
		global $f;
		$multicats = explode('[-'.$level.'-]',$name);
		for($i=1;$i<count($multicats);$i++)//le 1er est vide on commence par 1 ([-0-]cat1[-0-]cat2)
		{
			$ssmulticat = explode('[-'.($level+1).'-]',$multicats[$i]);
			$f->checkField('name',trim($ssmulticat[0]));
			//si il a des ss cat on les virifiers
			if(count($ssmulticat) > 1)
				$this->checkFormMultiName($update,$catid,$multicats[$i],($level+1));
		}
		
	}
	function checkAddCat($admin=false,$update=false,$catid='')
	{
		global $f,$group,$configs;
		if($f->antiRobotForm($configs['config_users_antirobot_tentative_max_addcat'],$configs['config_users_antirobot_tentative_wait_addcat'],false))
		{
			$this->initFields();
			//verification
			$this->checkFormParentid($update,$catid);
			$this->checkFormIcon($update,$catid);
			$this->checkFormDescription($update,$catid);
			$this->checkFormTags($update,$catid);
			//peut-tre plusieurs catgories au meme temp
			if(count(explode('[-0-]',$_POST[$f->form.'_name'])) == 1 || !$admin)
				$this->checkFormName($update,$catid);
			else if(isset($_POST[$f->form.'_check_all_name']))
				$this->checkFormMultiName($update,$catid,$_POST[$f->form.'_name'],0);
			//vrification dans champs custom
			$this->selectCostumFields();
			for($i=0;$i<count($this->customFields);$i++)
			{
				$f->checkField($this->customFields[$i],$_POST[$f->form.'_'.$this->customFields[$i]]);
			}
			//captcha
			if(!$admin && $group->can('mustCaptcha'))
			{
				$f->checkField('captcha',array('captcha',$_POST['captcha']));
			}
		}
	}
	private function initFields()
	{//initialisation des champs du formulaire
		global $f;
		//initialisation
		$_POST[$f->form.'_name']=isset($_POST[$f->form.'_name'])?$_POST[$f->form.'_name']:'';
		$_POST[$f->form.'_parentid']=isset($_POST[$f->form.'_parentid'])?$_POST[$f->form.'_parentid']:'';
		$_POST[$f->form.'_icon']=isset($_POST[$f->form.'_icon'])?$_POST[$f->form.'_icon']:'';
		$_POST[$f->form.'_description']=isset($_POST[$f->form.'_description'])?$_POST[$f->form.'_description']:'';
		$_POST[$f->form.'_tags']=isset($_POST[$f->form.'_tags'])?$_POST[$f->form.'_tags']:'';
		//les champs personaliss
		$this->selectCostumFields();
		for($i=0;$i<count($this->customFields);$i++)
		{
			$_POST[$f->form.'_'.$this->customFields[$i]]=isset($_POST[$f->form.'_'.$this->customFields[$i]])?$_POST[$f->form.'_'.$this->customFields[$i]]:'';
		}
	}
	function statsCatGet($struct)
	{
		$stats = array();
		if(gettype($struct) == 'string')
		{
			$statsArray=explode(']||[',$struct);///id]|[name]|[parentsnames]||[id]|[name]|[parentsnames
			if(isset($statsArray[0]))
			{
				if(!empty($statsArray[0]))
				{
					for($i=0;$i<count($statsArray);$i++)
					{
						$statsArray[$i]=explode(']|[',$statsArray[$i]);
						$stats[$statsArray[$i][0]]=$statsArray[$i][1];
					}
				}
			}
		}
		else if (gettype($struct) == 'integer')
		{
			$struct = $this->statsCatCreateStruct($struct);
			$stats = $this->statsCatGet((string)$struct);
		}
		return $stats;
	}
	function statsCatUpdateStructConsultCache($id)
	{
		global $db,$tb_cats,$cache;
		$cache->setDir(DIR_CACHE_CATS_STATS);
		if($cache->old(CACHE_GENRS_STATSCAT_ID_.$id,false,''))
		{
			$stats = $this->statsCatCreateStruct($id);
			if($db->updateArr($tb_cats,array('stats'=>gpcToBd($stats)),"`id`=".$id))
			{
				$cache->setDir(DIR_CACHE_CATS_STATS);
				$cache->create(CACHE_GENRS_STATSCAT_ID_.$id,'');
				$cache->setDir('');
				return $stats;
			}
			else
				return $stats;
		}
		else
		{
			$cache->setDir('');
			return false;//on peut utiliser le cache sans faire de mise  jour
		}
	}
	function statsCatUpdateStruct($id)
	{
		global $db,$tb_cats;
		$stats = $this->statsCatCreateStruct($id);
		if($db->updateArr($tb_cats,array('stats'=>gpcToBd($stats)),"`id`=".$id))
			return $stats;
		else
			return false;
	}
	function statsCatCreateStruct($id)
	{
		global $stat;
		$stats ="";
		if(!is_object($stat))
		{
			require_once 'greensdstats.class.php';
			$stat = new GreenSDStats();
		}
		$statsArray = $stat->GreenSDCat($id);
		foreach($statsArray as $key=>$val)
		{
			$stats .= $key.']|['.$val.']||[';
		}
		$stats = rtrim($stats,']||[');
		return $stats;
	}
	function statsCatUpdateStructCache($id)
	{//update cache and db
		global $db,$tb_cats,$cache;
		$stats = $this->statsCatCreateStruct($id);
		if($db->updateArr($tb_cats,array('stats'=>gpcToBd($stats)),"`id`=".$id))
		{
			$cache->setDir(DIR_CACHE_CATS_STATS);
			$cache->create(CACHE_GENRS_STATSCAT_ID_.$id,'');
			$cache->setDir('');
			return $stats;
		}
		else
			return false;
	}
	function subsCatGetCache($struct)
	{//comme subsCatGet , mais permet de verifier le cache principale aussi
		global $cache;
		$subscat = array();
		if(gettype($struct) == 'string')
		{
			$subscat=$this->subsCatGet((string)$struct);
		}
		else if (gettype($struct) == 'integer')
		{
			(int)$catid=$struct;
			if((string)$struct=$this->subsCatUpdateStructConsultCache($catid))//maj avec conseltation du cache
			{
				$subscat=$this->subsCatGet((string)$struct);
			}
			else
			{
				$subscat=$this->subsCatGet((int)$catid);
			}
		}
		return $subscat;
	}
	function subsCatGet($struct)
	{//soit j'ai la structure avec les donnes : string   => on utilise le cache
	//soit j'ai l'id : int                                => on doit chercher tous dans DB
		$subscat = array();
		if(gettype($struct) == 'string')
		{
			$subscatArray=explode(']||[',$struct);///id]|[name]|[parentsnames]||[id]|[name]|[parentsnames
			if(isset($subscatArray[0]))
			{
				if(!empty($subscatArray[0]))
				{
					for($i=0;$i<count($subscatArray);$i++)
					{
						$subscatArray[$i]=explode(']|[',$subscatArray[$i]);
						$subscat[]=array(
							'id'=>$subscatArray[$i][0],
							'name'=>$subscatArray[$i][1],
							'parentsnames'=>$subscatArray[$i][2],
							'url'=>getUrl('link_cat',array($subscatArray[$i][2],$subscatArray[$i][0]),REWRITING)
						);
					}
				}
			}
		}
		else if (gettype($struct) == 'integer')
		{
			$struct = $this->subsCatCreateStruct($struct);
			$subscat = $this->navCatGet($struct);
		}
		return $subscat;
		
	}
	function subsCatUpdateStructConsultCache($id)
	{//update en consultant le cache
		global $db,$tb_cats,$cache;
		$cache->setDir(DIR_CACHE_CATS_SUBSCAT);
		if($cache->old(CACHE_GENRS_SUBSCAT_ID_.$id,false,''))
		{
			$subscat = $this->subsCatCreateStruct($id);
			if($db->updateArr($tb_cats,array('subscat'=>gpcToBd($subscat)),"`id`=".$id))
			{
				$cache->create(CACHE_GENRS_SUBSCAT_ID_.$id,'');
				$cache->setDir('');
				return $subscat;
			}
			else
				return $subscat;
		}
		else
		{
			$cache->setDir('');
			return false;//on peut utiliser le cache sans faire de mise  jour
		}
	}
	function subsCatUpdateStructCache($id)
	{//update cache and db
		global $db,$tb_cats,$cache;
		$subscat = $this->subsCatCreateStruct($id);
		if($db->updateArr($tb_cats,array('subscat'=>gpcToBd($subscat)),"`id`=".$id))
		{
			$cache->setDir(DIR_CACHE_CATS_SUBSCAT);
			$cache->create(CACHE_GENRS_SUBSCAT_ID_.$id,'');
			$cache->setDir('');
			return $subscat;
		}
		else
			return false;
	}
	function subsCatUpdateStruct($id)
	{//update db
		global $db,$tb_cats;
		$subscat = $this->subsCatCreateStruct($id);
		if($db->updateArr($tb_cats,array('subscat'=>gpcToBd($subscat)),"`id`=".$id))
			return $subscat;
		else
			return false;
	}
	function subsCatCreateStruct($id)
	{//cherche les sous catgories de la cat id=$id
		global $db,$tb_cats;
		$r=$db->query("SELECT `id`,`name`,`parentsnames` FROM `$tb_cats` WHERE ".SQL_CATS_VALID." AND `parentid`=".$id);
		$subscat="";

		while($row=$db->getRow($r,'MYSQL_ASSOC'))
		{
			$subscat .= $row['id'].']|['.$row['name'].']|['.$row['parentsnames'].']||[';
		}
		$subscat = rtrim($subscat,']||[');
		$db->free($r);
		return $subscat;
	}
	function parentsNamesCatUpdateStructCache($id)
	{//update cache and db
		global $db,$tb_cats,$cache;
		$parentsNames = $this->parentsNamesCatCreateStruct($id,array(0));
		
		if($db->updateArr($tb_cats,array('parentsnames'=>gpcToBd($parentsNames)),"`id`=".$id))
		{
			$cache->setDir(DIR_CACHE_CATS_PARENTSNAMES);
			$cache->create(CACHE_GENRS_PARENTSNAMESCAT_ID_.$id,'');
			$cache->setDir('');
			return $parentsNames;
		}
		else
			return false;
	}
	function parentsNamesCatUpdateStructConsultCache($id)
	{//update en consultant le cache
		global $db,$tb_cats,$cache;
		$cache->setDir(DIR_CACHE_CATS_PARENTSNAMES);
		if($cache->old(CACHE_GENRS_PARENTSNAMESCAT_ID_.$id,false,''))
		{
			$parentsNames = $this->parentsNamesCatCreateStruct($id,array(0));
			if($db->updateArr($tb_cats,array('parentsnames'=>gpcToBd($parentsNames)),"`id`=".$id))
			{
				$cache->create(CACHE_GENRS_PARENTSNAMESCAT_ID_.$id,'');
				$cache->setDir('');
				return $parentsNames;
			}
			else
				return $parentsNames;
		}
		else
		{
			$cache->setDir('');
			return false;//on peut utiliser le cache sans faire de mise  jour
		}
	}
	function parentsNamesCatGet($struct)
	{//soit j'ai la structure avec les donnes : string   => on utilise le cache
	//soit j'ai l'id : int                                => on doit chercher tous dans DB
		$parentsNames = array();
		if(gettype($struct) == 'string')
		{
			$parentsNamesArray=explode('][',$struct);///name][name][name][name][name][name]
			if(isset($parentsNamesArray[0]))
			{
				if(!empty($parentsNamesArray[0]))
				{
					for($i=0;$i<count($parentsNamesArray);$i++)
					{
						$parentsNames[]=array(
							'name'=>$parentsNamesArray[$i]
						);
					}
				}
			}
		}
		else if (gettype($struct) == 'integer')
		{
			$struct = $this->parentsNamesCatCreateStruct($struct,array(0));
			$parentsNames = $this->parentsNamesCatGet($struct);
		}
		return $parentsNames;
		
	}
	function parentsNamesCatUpdateStruct($id,$idsInParentsNames)
	{//mettre  jour la structure dans la db
		global $db,$tb_cats;
		$parentsNames=$this->parentsNamesCatCreateStruct($id,$idsInParentsNames);
		if($db->updateArr($tb_cats,array('parentsnames'=>gpcToBd($parentsNames)),"`id`=".$id))
			return $parentsNames;
		else
			return false;
	}
	function parentsNamesCatCreateStruct($id,$idsInParentsNames)
	{
		//$subcurrent: n du profondeur
		global $db,$tb_cats;
		$parentsNames = '';
		$r=$db->query("SELECT `id`,`name`,`parentid` FROM `$tb_cats` WHERE `id`=".$id." LIMIT 1;");
		if(mysql_num_rows($r) > 0)
		{
			$row=$db->getRow($r,'MYSQL_ASSOC');
			$idsInParentsNames[] = $row['id'];//ids deja dans la barre de navigation
			if(!in_array($row['parentid'],$idsInParentsNames))
			{
				$parentsNames .= $this->parentsNamesCatCreateStruct($row['parentid'],$idsInParentsNames);
			}
			$parentsNames .= ']['.$row['name'];
		}
		$db->free($r);
		$parentsNames = trim($parentsNames,'][');
		return $parentsNames;
	}
	//parentsIds
	function parentsIdsCatUpdateStruct($id,$idsInParentsNames)
	{//mettre  jour la structure dans la db
		global $db,$tb_cats;
		$parentsIds=$this->parentsIdsCatCreateStruct($id,$idsInParentsNames);
		if($db->updateArr($tb_cats,array('parentsids'=>gpcToBd($parentsIds)),"`id`=".$id))
			return $parentsIds;
		else
			return false;
	}
	function parentsIdsCatCreateStruct($id,$idsInParentsIds)
	{
		//$subcurrent: n du profondeur
		global $db,$tb_cats;
		$parentsIds = '';
		$r=$db->query("SELECT `id`,`name`,`parentid` FROM `$tb_cats` WHERE `id`=".$id." LIMIT 1;");
		if(mysql_num_rows($r) > 0)
		{
			$row=$db->getRow($r,'MYSQL_ASSOC');
			$idsInParentsIds[] = $row['id'];//ids deja dans la barre de navigation
			if(!in_array($row['parentid'],$idsInParentsIds))
			{
				$parentsIds .= $this->parentsIdsCatCreateStruct($row['parentid'],$idsInParentsIds);
			}
			$parentsIds .= ']['.$row['id'];
		}
		$db->free($r);
		$parentsIds = trim($parentsIds,'][');
		return $parentsIds;
	}
	//navCat
	function navCatUpdateStructCache($id)
	{//update cache and db
		global $db,$tb_cats,$cache;
		$nav = $this->navCatCreateStruct($id,array(0));
		if($db->updateArr($tb_cats,array('nav'=>gpcToBd($nav)),"`id`=".$id))
		{
			$cache->setDir(DIR_CACHE_CATS_NAV);
			$cache->create(CACHE_GENRS_NAVCAT_ID_.$id,'');
			$cache->setDir('');
			return $nav;
		}
		else
			return false;
	}
	function navCatUpdateStructConsultCache($id)
	{//update en consultant le cache
		global $db,$tb_cats,$cache;
		$cache->setDir(DIR_CACHE_CATS_NAV);
		if($cache->old(CACHE_GENRS_NAVCAT_ID_.$id,false,''))
		{
			$nav = $this->navCatCreateStruct($id,array(0));
			if($db->updateArr($tb_cats,array('nav'=>gpcToBd($nav)),"`id`=".$id))
			{
				$cache->create(CACHE_GENRS_NAVCAT_ID_.$id,'');
				$cache->setDir('');
				return $nav;
			}
			else
				return $nav;
		}
		else
		{
			$cache->setDir('');
			return false;//on peut utiliser le cache sans faire de mise  jour
		}
	}
	function navCatGet($struct)
	{//soit j'ai la structure avec les donnes : string   => on utilise le cache
	//soit j'ai l'id : int                                => on doit chercher tous dans DB
		$nav = array();
		if(gettype($struct) == 'string')
		{
			$navArray=explode(']||[',$struct);///id]|[name]|[parentsnames]||[id]|[name]|[parentsnames
			if(isset($navArray[0]))
			{
				if(!empty($navArray[0]))
				{
					for($i=0;$i<count($navArray);$i++)
					{
						$navArray[$i]=explode(']|[',$navArray[$i]);
						$nav[]=array(
							'id'=>$navArray[$i][0],
							'name'=>$navArray[$i][1],
							'parentsnames'=>$navArray[$i][2],
							'url'=>getUrl('link_cat',array($navArray[$i][2],$navArray[$i][0]),REWRITING)
						);
					}
				}
			}
		}
		else if (gettype($struct) == 'integer')
		{
			$struct = $this->navCatCreateStruct($struct,array(0));
			$nav = $this->navCatGet($struct);
		}
		return $nav;
		
	}
	function navCatUpdateStruct($id,$idsInNav)
	{
		global $db,$tb_cats;
		$nav=$this->navCatCreateStruct($id,$idsInNav);
		if($db->updateArr($tb_cats,array('nav'=>gpcToBd($nav)),"`id`=".$id))
			return $nav;
		else
			return false;
	}
	function navCatCreateStruct($id,$idsInNav)
	{//$subcurrent: n du profondeur
		global $db,$tb_cats;
		$nav = '';
		$r=$db->query("SELECT `id`,`name`,`parentsnames`,`parentid` FROM `$tb_cats` WHERE `id`=".$id." LIMIT 1;");
		if(mysql_num_rows($r) > 0)
		{
			$row=$db->getRow($r,'MYSQL_ASSOC');
			$idsInNav[] = $row['id'];//ids deja dans la barre de navigation
			if(!in_array($row['parentid'],$idsInNav))
			{
				$nav .= $this->navCatCreateStruct($row['parentid'],$idsInNav);
			}
			$nav .= ']||['.$row['id'].']|['.$row['name'].']|['.$row['parentsnames'];
		}
		$db->free($r);
		$nav = ltrim($nav,']||[');
		return $nav;
	}
	function showCats($condition,$order,$startpage,$nomberbypage,$nombersscats,$rewriting,$jsedit)
	{
		global $tb_cats,$db,$stat,$configs,$cache;
		$limit = '';//init
		if(!empty($startpage) && !empty($nomberbypage))
			$limit="LIMIT $startpage , $nomberbypage";
		else if(!empty($nomberbypage))
			$limit="LIMIT $nomberbypage";
		
		$this->selectCostumFields();
		$r = $db->query("SELECT ".$this->cat_fields." FROM `$tb_cats` WHERE $condition  $order $limit");
		$tabcats=array();
		$i=0;
		while ($row=$db->getRow($r, 'MYSQL_ASSOC')) 
		{
			//url
			$row['url'] = getUrl('link_cat',array($row['parentsnames'],$row['id']),$rewriting);
			$row['urls'] = array(
									'feed'=>getUrl('cat_feed',array($row['id']),$rewriting),
									'sitemap'=>getUrl('sitemap_cat',array($row['id']),$rewriting)
								);
			$row['feedCat'] = getUrl('cat_feed',array($row['id']),$rewriting);
			//nav
			if($configs['config_cats_nav_cache'] == 'yes')
				(array)$row['nav']=$this->navCatGet((string)$row['nav']);
			else
			{
				$navtmp=$this->navCatUpdateStructConsultCache($row['id']);
				if($navtmp)
				{//new cache
					(array)$row['nav']=$navtmp;
					unset($navtmp);
				}
				else
				{//le cache est encor utilisable
					(array)$row['nav']=$this->navCatGet((string)$row['nav']);//on peut utiliser le cache
				}
			}

			//icons
			if(file_exists(PATH_IMGS.$row['icon']) and !is_dir(PATH_IMGS.$row['icon']))
				$row['icon']=URL_IMGS.$row['icon'];
			else
				$row['icon']='';
			//stats
			if($configs['config_cats_stats_cache'] == 'yes')
				(array)$row['stats']=$this->statsCatGet((string)$row['stats']);
			else
			{
				$statstmp=$this->statsCatUpdateStructConsultCache($row['id']);
				if($statstmp)
				{//new cache
					(array)$row['stats']=$statstmp;
				}
				else
				{//le cache est encor utilisable
					
					(array)$row['stats']=$this->statsCatGet((string)$row['stats']);//on peut utiliser le cache
				}
				unset($statstmp);
			}

			$row['status']['delete']=$this->getsSatusCat('delete',$row['delete']);
			$row['status']['hide']=$this->getsSatusCat('hide',$row['hide']);
			$row['status']['pending']=$this->getsSatusCat('pending',array('valid'=>$row['valid'],'delete'=>$row['delete'],'hide'=>$row['hide']));
			//PRIORITY
			$row['priority'] = (string) $this->catPriority();
			//JSEdit
			if($jsedit)
			{
				$this->addJsEdit('edit','#edit_cat_name_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=cat','name',"catid:".$row['id'],'','','');
				$this->addJsEdit('edit','#edit_cat_description_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=cat','description',"catid:".$row['id'],'textarea','','');
				$this->addJsEdit('edit','#edit_cat_tags_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=cat','tags',"catid:".$row['id'],'','','');
				//JSEDIT cats
				if(ctype_digit($configs['stats_cat_total_cats_valid']) && $configs['stats_cat_total_cats_valid'] < 1000)
				{
					$this->getCats(SQL_CATS_VALID);
					$selectdatas = "0 : 'Top-->',";
					for($i = 0; $i < count($this->cats);$i++)
					{
						$selectdatas .= $this->cats[$i]['id']." : 'Top-->".str_replace('][','-->',$this->cats[$i]['parentsnames'])."',";
					}
					$selectdatas=rtrim($selectdatas,',');
					$this->addJsEdit('edit','#edit_cat_parentid_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=cat','parentid',"catid:".$row['id'],'select',$selectdatas,'');
				}
			}
			//SUB Cats
			if($nombersscats > 0)
			{
				if($configs['config_cats_subscat_cache'] == 'yes')
					(array)$row['subscat']=$this->subsCatGet((string)$row['subscat']);
				else
				{
					//$subcattmp=$this->subsCatGetConcultCache((int)$row['id']);
					$subcattmp=$this->subsCatUpdateStructConsultCache($row['id']);
					if($subcattmp)
					{//new cache
						(array)$row['subscat']=$subcattmp;
						unset($subcattmp);
					}
					else
					{//le cache est encor utilisable
						(array)$row['subscat']=$this->subsCatGet((string)$row['subscat']);//on peut utiliser le cache
					}
				}
			}
			else
				$row['subscat'] = array();

			$tabcats[]=$row;
		}
		$db->free($r);
		return $tabcats;
	}
	private function catPriority()
	{
		global $row,$configs;
		$p = 0.0;
		if(($configs['stats_cat_total_cats_valid']-$row['stats']['stats_cat_total_subcats_valid ']) > 10)//non ancien
			$p = $p + 0.2;
		else if(($configs['stats_cat_total_cats_valid']-$row['stats']['stats_cat_total_subcats_valid ']) > 0)
			$p = $p + 0.1;
			
		if(($configs['stats_link_total_links_valid']-$row['stats']['stats_cat_total_links_valid']) > 10)//non ancien
			$p = $p + 0.3;
		else if(($configs['stats_link_total_links_valid']-$row['stats']['stats_cat_total_links_valid']) > 5)
			$p = $p + 0.2;
		else if(($configs['stats_link_total_links_valid']-$row['stats']['stats_cat_total_links_valid']) > 0)
			$p = $p + 0.1;
			
		if(strlen($row['description']) > 20)
			$p = $p + 0.2;
		else if(strlen($row['description']) > 0)
			$p = $p + 0.1;
		
		if(count(explode('][',$row['parentsids'])) < 1)
			$p = $p + 0.3;
		else if(count(explode('][',$row['parentsids'])) < 2)
			$p = $p + 0.2;
		else if(count(explode('][',$row['parentsids'])) < 3)
			$p = $p + 0.1;
		
		return $p;
	}
	function getsSatusCat($type,$value)
	{//l'etat de la catgorie
		switch($type)
		{
			case 'delete' :
				if($value == '1')
					return true;
				else
					return false;
				break;
			case 'hide' :
				if($value == '1')
					return true;
				else
					return false;
				break;
			case 'pending' :
				if($value['valid'] == '0' && $value['delete'] == '0' && $value['hide'] == '0')
					return true;
				else
					return false;
				break;
		}
	}
	function getJsEdit()
	{
		return $this->js_edit;
	}
	function addJsEdit($js,$id,$url,$fieldname,$submitdata,$type,$data,$idaction)
	{//id est un tableau des id dans l'ordre ;)
		if($js == "edit")
		{
			$this->js_edit .= '$("'.$id.'").editable("'.$url.'",{'."\n";
			$this->js_edit .='indicator : "<img src=\"'.URL_IMGS_ADMIN.'loading3.gif\" alt=\"\" border=\"\" />",'."\n";
			$this->js_edit .='tooltip   : "Doubleclick to edit...",'."\n";
			if(!empty($type))
				$this->js_edit .='type      : "'.$type.'",'."\n";
			$this->js_edit .='submit    : "OK",'."\n";
			$this->js_edit .='cancel    : "Cancel",'."\n";
			$this->js_edit .='event     : "dblclick",'."\n";
			if(!empty($data))
			$this->js_edit .='data      : "{'.$data.'}",'."\n";
			//$this->js_edit .='cssclass  : "ajaxedit",'."\n";
			//$this->js_edit .='style     : "height: 150px",'."\n";
			//$this->js_edit .='select : true,'."\n";
			if(!empty($submitdata))
				$submitdata = ",".$submitdata;
			$this->js_edit .='submitdata: { fieldname: "'.$fieldname.'"'.$submitdata.' }'."\n";
			$this->js_edit .='});'."\n";
		}
		else if($js == 'post')
		{
			$this->js_edit .= '$("'.$idaction.'").click(function(){'."\n";
				$this->js_edit .= '$.ajax({'."\n";
				$this->js_edit .= 'type: "POST",'."\n";
				$this->js_edit .= 'url: "'.$url.'",'."\n";
				$this->js_edit .= ' data: "'.$submitdata.'",'."\n";
				$this->js_edit .= 'beforeSend: function(){'."\n";
				$this->js_edit .= '$("'.$id.'").html("<img src=\"'.URL_IMGS_ADMIN.'loading3.gif\" alt=\"\" border=\"\" />");'."\n";
				$this->js_edit .= '},'."\n";
				$this->js_edit .= 'success: function(check){'."\n";
				$this->js_edit .= '$("'.$id.'").html(check);'."\n";
				$this->js_edit .= '}'."\n";
				$this->js_edit .= '});'."\n";
			$this->js_edit .= '});'."\n";
		}
	}
	function getCats($condition)
	{
		if(count($this->cats) == 0)
		{
			global $db,$tb_cats;
			$r=$db->query("SELECT `id`,`parentsnames` FROM `$tb_cats` WHERE $condition ORDER BY `parentsnames`;");
			while($row=$db->getRow($r,'MYSQL_ASSOC'))
			{
				$this->cats[] = $row;
			}
			$db->free($r);
		}
		return $this->cats;
	}

}
?>