<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class GreenSDStats
{
	private $GreenSDStats;

	function __destruct() {
		
    }

	function __construct()
	{
		$this->GreenSDStats = array(
								'stats_cat_total_cats_valid'                  => ''          ,
								'stats_cat_total_cats_pend'                   => ''          ,
								'stats_cat_total_cats_hide'                   => ''          ,
								'stats_cat_total_cats_delete'                 => ''          ,
								'stats_cat_total_cats_all'                    => ''          ,
								'stats_cat_total_cats_recycle'                => ''          ,
		
								'stats_cat_total_subcats_valid'               => ''          ,
								'stats_cat_total_subcats_pend'                => ''          ,
								'stats_cat_total_subcats_hide'                => ''          ,
								'stats_cat_total_subcats_delete'              => ''          ,
								'stats_cat_total_links_valid'                 => ''          ,
								'stats_cat_total_links_pend'				  => ''			 ,
								
								'stats_link_total_links_all'                  => ''          ,
								'stats_link_total_links_valid'                => ''          ,
								'stats_link_total_links_pend'                 => ''          ,
								'stats_link_total_links_hide'                 => ''          ,
								'stats_link_total_links_delete'               => ''          ,
								'stats_link_total_links_update'               => ''          ,
								'stats_link_total_links_recip_valid'          => ''          ,
								'stats_link_total_links_dead'                 => ''          ,
								'stats_link_total_links_recycle'              => ''          ,
								'stats_link_total_links_report'               => ''          ,
		
								'stats_mmbr_total_links_valid'                => ''          ,
								'stats_mmbr_total_links_pend'                 => ''          ,
								'stats_mmbr_total_links_hide'                 => ''          ,
								'stats_mmbr_total_links_delete'               => ''          ,
								'stats_mmbr_total_links_no_check_email'       => ''          ,
		);
	}
	private function updateStatsGeneral($stats)
	{//mettre a jour les stats
		global $db,$tb_dt,$cache,$configs;
		$sql = "";
		foreach($stats as $key => $val)
		{
			$db->update("UPDATE `$tb_dt` SET `value`='$val' WHERE `name` = '$key' LIMIT 1;");
			$configs[$key] = $val;
		}
		$cache->setDir('');
		$cache->create(CACHE_GENRS_STATS_GENERAL,'');
	}
	public function incrStatsCacheGeneral($stats,$incr)
	{//incriment les stats ou dcriment les stats
		global $db,$tb_dt;
		foreach($stats as $val)
		{
			$db->update("UPDATE `$tb_dt` SET `value`=`value`+$incr WHERE `name` = '$val' LIMIT 1;");
		}
	}
	private function getAllStats()
	{
		return $this->GreenSDStats;
	}
	private function getStats()
	{
		//return tous les stats non vide
		$return =array();
		foreach($this->GreenSDStats as $key=>$val)
			if($this->GreenSDStats[$key] !== '')
				$return[$key]=$this->GreenSDStats[$key];
		return $return;
	}
	public function GreenSDGeneral($useCache)
	{//stats generale : cherche dans le cache si activ et si il existe
		global $db,$tb_cats,$tb_links,$tb_mmbrs,$tb_dt,$cache,$configs;
		//$cacheExiste=true;
		if($useCache)
		{
			foreach($configs as $key=>$val)
			{
				if(preg_match('#^stats_#',$key))
					$this->GreenSDStats[$key]=$val;
			}
		}
		else
		{
			$cache->setDir('');
			if($cache->old('CACHE_GENRS_STATS_GENERAL',true,0.5))
			{
				//toutes les cats
				$r                                                           = $db->query("SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_ALL);
				$this->GreenSDStats['stats_cat_total_cats_all']              = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_VALID);
				$this->GreenSDStats['stats_cat_total_cats_valid']            = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_PENDING);
				$this->GreenSDStats['stats_cat_total_cats_pend']             = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_HIDE);
				$this->GreenSDStats['stats_cat_total_cats_hide']             = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_DELETE);
				$this->GreenSDStats['stats_cat_total_cats_delete']           = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_RECYCLE);
				$this->GreenSDStats['stats_cat_total_cats_recycle']          = mysql_num_rows($r);
				$db->free($r);
				//tous les liens
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_ALL);
				$this->GreenSDStats['stats_link_total_links_all']            = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_VALID);
				$this->GreenSDStats['stats_link_total_links_valid']          = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_PENDING);
				$this->GreenSDStats['stats_link_total_links_pend']           = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_HIDE);
				$this->GreenSDStats['stats_link_total_links_hide']           = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_DELETE);
				$this->GreenSDStats['stats_link_total_links_delete']         = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_UPDATE);
				$this->GreenSDStats['stats_link_total_links_update']         = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_RECIP_VALID);
				$this->GreenSDStats['stats_link_total_links_recip_valid']    = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_DEAD);
				$this->GreenSDStats['stats_link_total_links_dead']           = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_RECYCLE);
				$this->GreenSDStats['stats_link_total_links_recycle']        = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_links` WHERE ".SQL_LINKS_REPORT);
				$this->GreenSDStats['stats_link_total_links_report']        = mysql_num_rows($r);
				$db->free($r);
				//tous les mmbres
				$r                                                           = $db->query("SELECT `id` FROM `$tb_mmbrs` WHERE ".SQL_MEMBERS_ALL);
				$this->GreenSDStats['stats_mmbr_total_mmbrs_all']            = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_mmbrs` WHERE ".SQL_MEMBERS_VALID);
				$this->GreenSDStats['stats_mmbr_total_mmbrs_valid']          = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_mmbrs` WHERE ".SQL_MEMBERS_PENDING);
				$this->GreenSDStats['stats_mmbr_total_mmbrs_pend']           = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_mmbrs` WHERE ".SQL_MEMBERS_DELETE);
				$this->GreenSDStats['stats_mmbr_total_mmbrs_delete']         = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_mmbrs` WHERE ".SQL_MEMBERS_RECYCLE);
				$this->GreenSDStats['stats_mmbr_total_mmbrs_recycle']        = mysql_num_rows($r);
				$db->free($r);
				$r                                                           = $db->query("SELECT `id` FROM `$tb_mmbrs` WHERE ".SQL_MEMBERS_NO_CHECK_EMAIL);
				$this->GreenSDStats['stats_mmbr_total_mmbrs_no_check_email'] =     mysql_num_rows($r);
				$db->free($r);
				//mise a j du cache all
				$this->updateStatsGeneral($this->GreenSDStats);
			}
			else
				$this->GreenSDGeneral(true);
		}
		
		return $this->getStats();
	}

	public function GreenSDCat($id)
	{//1 seul cat : cherche dans le cache si activ et si il existe
		global $db,$tb_cats,$tb_links;

			//nombre de sous catgories valides
			$r                                              = $db->query("SELECT `id` FROM `$tb_cats` WHERE (`parentid` = $id OR `parentsids` = '$id' OR `parentsids` LIKE '%][$id' OR `parentsids` LIKE '$id][%' OR `parentsids` LIKE '%][$id][%') AND ".SQL_CATS_VALID);
			$this->GreenSDStats['stats_cat_total_subcats_valid']  = mysql_num_rows($r)-1;//-1 pour catgorie elle mme
			if($this->GreenSDStats['stats_cat_total_subcats_valid'] < 0)
				$this->GreenSDStats['stats_cat_total_subcats_valid'] = 0;
			$db->free($r);
			
			//nombre de sous catgories attentes
			$r                                              = $db->query("SELECT `id` FROM `$tb_cats` WHERE (`parentid` = $id OR `parentsids` = '$id' OR `parentsids` LIKE '%][$id' OR `parentsids` LIKE '$id][%' OR `parentsids` LIKE '%][$id][%') AND ".SQL_CATS_PENDING);
			$this->GreenSDStats['stats_cat_total_subcats_pend']   = mysql_num_rows($r)-1;
			if($this->GreenSDStats['stats_cat_total_subcats_pend'] < 0)
				$this->GreenSDStats['stats_cat_total_subcats_pend'] = 0;
			$db->free($r);
			
			//nombre de sous catgories caches
			$r                                              = $db->query("SELECT `id` FROM `$tb_cats` WHERE (`parentid` = $id OR `parentsids` = '$id' OR `parentsids` LIKE '%][$id' OR `parentsids` LIKE '$id][%' OR `parentsids` LIKE '%][$id][%') AND ".SQL_CATS_HIDE);
			$this->GreenSDStats['stats_cat_total_subcats_hide']   = mysql_num_rows($r)-1;
			if($this->GreenSDStats['stats_cat_total_subcats_hide'] < 0)
				$this->GreenSDStats['stats_cat_total_subcats_hide'] = 0;
			$db->free($r);
			
			//nombre de sous catgories supprimer
			$r                                              = $db->query("SELECT `id` FROM `$tb_cats` WHERE (`parentid` = $id OR `parentsids` = '$id' OR `parentsids` LIKE '%][$id' OR `parentsids` LIKE '$id][%' OR `parentsids` LIKE '%][$id][%') AND ".SQL_CATS_DELETE);
			$this->GreenSDStats['stats_cat_total_subcats_delete'] = mysql_num_rows($r)-1;
			if($this->GreenSDStats['stats_cat_total_subcats_delete'] < 0)
				$this->GreenSDStats['stats_cat_total_subcats_delete'] = 0;
			$db->free($r);
			
			//nombre de liens valides dans la catgorie
			$r                                              = $db->query("SELECT `$tb_links`.`id` FROM `$tb_links`,`$tb_cats` WHERE `$tb_links`.`catid` = `$tb_cats`.`id` AND (`$tb_links`.`catid` = $id OR `$tb_cats`.`parentsids` = '$id' OR `$tb_cats`.`parentsids` LIKE '%][$id' OR `$tb_cats`.`parentsids` LIKE '$id][%' OR `$tb_cats`.`parentsids` LIKE '%][$id][%') AND ".SQL_LINKS_VALID);
			$this->GreenSDStats['stats_cat_total_links_valid']    = mysql_num_rows($r);
			if($this->GreenSDStats['stats_cat_total_links_valid'] < 0)
				$this->GreenSDStats['stats_cat_total_links_valid'] = 0;
			$db->free($r);
			
			//nombre de liens valides dans la catgorie
			$r                                              = $db->query("SELECT `$tb_links`.`id` FROM `$tb_links`,`$tb_cats` WHERE `$tb_links`.`catid` = `$tb_cats`.`id` AND (`$tb_links`.`catid` = $id OR `$tb_cats`.`parentsids` = '$id' OR `$tb_cats`.`parentsids` LIKE '%][$id' OR `$tb_cats`.`parentsids` LIKE '$id][%' OR `$tb_cats`.`parentsids` LIKE '%][$id][%') AND ".SQL_LINKS_PENDING);
			$this->GreenSDStats['stats_cat_total_links_pend']    = mysql_num_rows($r);
			if($this->GreenSDStats['stats_cat_total_links_valid'] < 0)
				$this->GreenSDStats['stats_cat_total_links_valid'] = 0;
			$db->free($r);
		return $this->getStats();
	}
	public function GreenSDMmbr($id)
	{
		global $db,$tb_links;

		$r                                                   = $db->query("SELECT `id` FROM `$tb_links` WHERE `userid` = $id AND ".SQL_LINKS_VALID);
		$this->GreenSDStats['stats_mmbr_total_links_valid']  = mysql_num_rows($r);
		$db->free($r);
		$r                                                   = $db->query("SELECT `id` FROM `$tb_links` WHERE `userid` = $id AND ".SQL_LINKS_PENDING);
		$this->GreenSDStats['stats_mmbr_total_links_pend']   = mysql_num_rows($r);
		$db->free($r);
		$r                                                   = $db->query("SELECT `id` FROM `$tb_links` WHERE `userid` = $id AND ".SQL_LINKS_HIDE);
		$this->GreenSDStats['stats_mmbr_total_links_hide']   = mysql_num_rows($r);
		$db->free($r);
		$r                                                   = $db->query("SELECT `id` FROM `$tb_links` WHERE `userid` = $id AND ".SQL_LINKS_DELETE);
		$this->GreenSDStats['stats_mmbr_total_links_delete'] = mysql_num_rows($r);
		$db->free($r);

		return $this->getStats();
	}
	private function initGraphStats($type,$nbrDays)
	{
		global $db,$tb_links;
		$stampDay = mktime(0, 0, 0, (int) date('m'), (int) date('d'), (int) date('Y'));//ajourd'huit
		$stamp1Day = 24*60*60;
		$stampnbrDays = $nbrDays*$stamp1Day;
		$stampMini = $stampDay-$stampnbrDays;
		//propositions les 7 dernier jours
		switch($type)
		{
			case 'time_submit' :
				$r=$db->query("SELECT `time_submit` AS `graphe_time` FROM `$tb_links` WHERE `time_submit` > $stampMini;");
				break;
			case 'time_valid' :
				$r=$db->query("SELECT `time_valid` AS `graphe_time` FROM `$tb_links` WHERE `time_valid` > $stampMini;");
				break;
			case 'time_update_submit' :
				$r=$db->query("SELECT `time_update_submit` AS `graphe_time` FROM `$tb_links` WHERE `time_update_submit` > $stampMini;");
				break;
			case 'time_update_valid' :
				$r=$db->query("SELECT `time_update_valid` AS `graphe_time` FROM `$tb_links` WHERE `time_update_valid` > $stampMini;");
				break;
		}

		//init
		$datas =array();
		$datas['total'] = array();
		$datas['total']= array_fill(0, $nbrDays, 0);
		$datas['time']=array();
		for($i=0;$i<$nbrDays;$i++)
		{
			$datas['time'][$nbrDays-$i-1] = ($stampDay - ($stamp1Day * $i));
		}
		
		while($row=$db->getRow($r,"MYSQL_ASSOC"))
		{
			
			for($i=0;$i<$nbrDays;$i++)
			{
			     if($row['graphe_time'] > ($stampDay - ($stamp1Day * $i)))
				 {
					$datas['total'][$nbrDays-$i-1]++;
					break;
				 }
			}
		}
		$db->free($r);
		return $datas;
	}
	public function drawGraphStats($type,$nbrDays)
	{
		$datas = $this->initGraphStats($type,$nbrDays);
		$totalVal = array_sum($datas['total']);
		//$prMax = 100;
		$pxMax = 120;
		$datasPx = array();
		$datasPr = array();
		
		for($i=0;$i<count($datas['total']);$i++)
		{
			if($datas['total'][$i] > 0)
			{
				$datasPx[$i] = ($datas['total'][$i] * $pxMax)/$totalVal;
				//$datasPr[$i] = ($datas['total'][$i] * $prMax)/$totalVal;
			}
			else
			{
				$datasPx[$i] = 0;
				//$datasPr[$i] = 0;
			}
		}
		$table = "";
		$table .= "<div>".translate('stats_graph_title_last_'.$type)." ".$nbrDays." ".translate('days')."<br />avg = ".round($totalVal/$nbrDays,2)." / ".translate('day')."</div>";
		$table .= "<table style='height: ".($pxMax+50)."px;width:100%; background-color: #ffffff;'><tr>";
		for($i=0;$i<count($datas['total']);$i++)
		{
			$table .= "<td style='";
			if($i == 0 || ($i%2 == 0))
				$table .= "background-color: #39CE33;";
			else
				$table .= "background-color: #75E877;";
			$table .= "' valign='bottom' align='center' height='98%'><div style='background-color: #0CB280;width: 35px;height: ".$datasPx[$i]."px'><small><span style='color: #000000;'>".$datas['total'][$i]."</spna></small></div><br /></td>";
		}
		$table .= "</tr><tr>";
		/*for($i=0;$i<count($datas['total']);$i++)
		{
			$table .= "<td height='1%' align='center'><span style='color: #000000;'>".round($datasPr[$i],2)."%</spna></td>";
		}
		$table .= "</tr><tr>";*/
		for($i=0;$i<count($datas['total']);$i++)
		{
			$table .= "<td height='1%' align='center'><span style='color: #000000;'>".date("d/m",$datas['time'][$i])."</spna></td>";
		}
		$table .= "</tr><tr>";
		$table .= "</tr></table>";
		return $table;
	}	
}
?>