<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class Plugin
{
	private $requirdeFiles = array();
	private $fileZip = '';
	public function __construct() 
	{
	
	}
	public function __destruct()
	{
		
	}
	private function requirdeFiles($plugName)
	{
		$this->requirdeFiles = array(//fichiers obligatoires
			$plugName.'/'.$plugName.'.index.php',
			$plugName.'/'.$plugName.'.admin.php',
			$plugName.'/'.$plugName.'.install.php',
			$plugName.'/'.$plugName.'.uninstall.php',
			$plugName.'/'.$plugName.'.icon_16_16.png',
			$plugName.'/'.$plugName.'.screenshot_big.png',
			$plugName.'/'.$plugName.'.screenshot_small.png',
			$plugName.'/'.$plugName.'.about.txt'
		);
	}
	public function install()
	{
		global $msgs;
		$zip = new PclZip($this->fileZip);
		if ($zip->extract(PCLZIP_OPT_PATH, PATH_PLUGINS) == 0)
		{
			die("Error : ".$archive->errorInfo(true));
		}
		else
		{
			$msgs[] = translate('plugins_install_done');
			unlink($this->fileZip);//supprimer le zip
			return true;
		}
	}
	public function installCheck($nameFile)
	{
		global $msgsw;
		$this->fileZip = PATH_CACHE.DIR_CACHE_PLUGINS.'/'.$nameFile;
		$zip = new PclZip($this->fileZip);
		if (($listFiles = $zip->listContent()) == 0)
		{
			die("Error : ".$zip->errorInfo(true));
		}
		if(isset($listFiles[0]['filename']) && !empty($listFiles[0]['filename']))
		{
			if(!is_dir(PATH_PLUGINS.$listFiles[0]['filename'].'/'))
			{
				$this->requirdeFiles(basename($listFiles[0]['filename']));
				$countFiles = 0;
				for($i=0;$i<count($listFiles);$i++)
				{
					if(in_array($listFiles[$i]['filename'],$this->requirdeFiles))
						$countFiles++;
				}
				if($countFiles == count($this->requirdeFiles))
				{
					return basename($listFiles[0]['filename']);
				}
				else
				{
					$msgsw[] = translate('plugins_install_structure_error');
					return false;
				}
			}
			else
			{
				$msgsw[] = translate('plugins_install_name_exist');
				return false;
			}
		}
		else
		{
			$msgsw[] = translate('plugins_install_structure_error');
			return false;
		}
	}
}
?>