<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class User
{
	//private $fields=array();
	private $newEmail = "";
	public $user_fields = "`id`, `ip`, `login`, `firstname`, `lastname`, `password`, `email`, `group`, `time_register`, `time_last_update`, `time_check`, `time_valid`, `avatar`, `datebirth`, `emaillive`, `emailyim`, `emailgmail`, `biographie`, `website`, `singature`, `zonetime`, `country`, `stats`,`typeadmin`, `switchsadmin`,`menuadmin`, `check_email_address`, `check_email_code`, `check_email`, `valid`, `delete`";
	private $customFields=array();
	public $member = array();
	public $user = array();
	public $admin = array();
	private $current_user = array();
	private $js_edit = '';
	public $listgroups = array();
	function __construct() 
	{
		global $s;
		$this->newEmail="";
		
		if($s->isVar('member'))
			$this->member = $s->getVar('member');
		if($s->isVar('user'))
			$this->user = $s->getVar('user');
		if($s->isVar('admin'))
			$this->admin = $s->getVar('admin');
		
	}
	function __destruct()
	{
		
	}
	private function selectCostumFields()
	{
		if(count($this->customFields) == 0)
		{
			global $db,$tb_mmbrs;
			$r=$db->query("SHOW COLUMNS FROM `".$tb_mmbrs."` LIKE 'cm_%';");
			while ($row=$db->getRow($r,"MYSQL_ASSOC"))
			{
				$this->user_fields .= ",`".$row['Field']."`";
				$this->customFields[] = $row['Field'];
			}
			$db->free($r);
		}
	}
	public function getCurrentUser()
	{//les infos sur l'user actuel
		return array(
			'isMember'=>$this->isMember(),
			'isAdmin'=>$this->isAdmin(),
			'isGuest'=>$this->isGuest()
		);
	}
	public function getCurrentMember()
	{//les infos sur le membre actuel
		global $s;
		if($this->isMember() && $s->isVar('member'))
			return $s->getVar('member');
		else
			return array();
	}
	public function getCurrentAdmin()
	{//les infos sur l'admin actuel
		global $s;
		if($this->isAdmin() && $s->isVar('admin'))
			return $s->getVar('admin');
		else
			return array();
	}
	public function getCurrentGuest()
	{//les infos sur l'user actuel
		global $s;
		if($this->isGuest() && $s->isVar('user'))
			return $s->getVar('user');
		else
			return array();
	}
	public function isAdmin()
	{
		global $s;
		if(
			count($this->admin) > 0 &&
			count($this->user) > 0 &&
			$this->admin['login'] == $this->user['login'] &&
			$this->admin['password'] == $this->user['password'] &&
			($this->admin['typeadmin'] == 'administrator' || $this->admin['typeadmin'] == 'superadministrator') &&
			$this->user['ip'] == IP &&
			$this->user['browser'] == USER_AGENT
		)
		{
			return true;
		}
		else
			return false;
	}
	public function isMember()
	{
		global $s;
		if(
			count($this->member) > 0 &&
			count($this->user) > 0 &&
			$this->member['login'] == $this->user['login'] &&
			$this->member['password'] == $this->user['password'] &&
			$this->user['ip'] == IP &&
			$this->user['browser'] == USER_AGENT
		)
		{
			return true;
		}
		else
			return false;
	}
	public function isGuest()
	{
		if($this->isAdmin() || $this->isMember())
			return false;
		else
			return true;
	}
	public function login()
	{
		global $db,$tb_mmbrs,$s,$msgsw;
		$login = isset($_POST['user_login'])?gpcToBd($_POST['user_login']):'';
		$password = isset($_POST['user_password'])?md5(md5(gpcToBd($_POST['user_password']))):'';
		if(!empty($login) && !empty($password))
		{
			//connectDb();
			global $configs;
			$f = new Checkform('logUser');
			if($f->antiRobotForm($configs['config_users_antirobot_tentative_max'],$configs['config_users_antirobot_tentative_wait']))
			{
				$member=$this->showMmbrs("`login` = '$login' AND `password` = '$password' AND ".SQL_MEMBERS_VALID,'',0,2,REWRITING,false);
				if(count($member) == 1)
				{
					$f->antiRobotForm(0,0);//remettre le compteur a 0
					$this->member = $member[0];
					$s->setVar('member',$this->member);
					$this->user = updateArray($this->user,array(
							'login'=>$login,
							'password'=>$password,
							'ip'=>IP,
							'browser'=>USER_AGENT,
							'sessionid'=>$s->getSessionId()
						));
					$s->setVar('user',$this->user);
					return true;
				}
				else
				{
					$member=$this->showMmbrs("`login` = '$login' AND `password` = '$password' AND ".SQL_MEMBERS_PENDING,'',0,2,REWRITING,false);
					if(count($member) == 1)
					{
						$msgsw[] = translate('login_error_email_no_check');
					}
					else
						$msgsw[] = translate('login_error');
	
					return false;
				}
			}
			else
				$msgsw = addArray($msgsw,$f->getErrors());
		}
		else
			return false;
	}
	public function loginAdmin()
	{
		global $db,$tb_mmbrs,$s;
		$login = isset($_POST['user_login'])?gpcToBd($_POST['user_login']):'';
		$password = isset($_POST['user_password'])?md5(md5(gpcToBd($_POST['user_password']))):'';
		if(!empty($login) && !empty($password))
		{
			global $configs,$msgsw;
			$f = new Checkform('logUser');
			if($f->antiRobotForm($configs['config_users_antirobot_tentative_max'],$configs['config_users_antirobot_tentative_wait']))
			{
				$admin=$this->showMmbrs("`login` = '$login' AND `password` = '$password' AND ".SQL_MEMBERS_ADMIN,'',0,2,REWRITING,false);
				if(count($admin) == 1)
				{
					$f->antiRobotForm(0,0);//remettre le compteur a 0
					$this->admin = $admin[0];
					$s->setVar('admin',$this->admin);
					$this->user = updateArray($this->user,array(
							'login'=>$login,
							'password'=>$password,
							'ip'=>IP,
							'browser'=>USER_AGENT,
							'sessionid'=>$s->getSessionId()
						));
					$s->setVar('user',$this->user);
					return true;
				}
				else
					$msgsw[] = translate('login_error');
			}
			else
				$msgsw = addArray($msgsw,$f->getErrors());
		}
		else
			return false;
	}
	public function getUserForm($id)
	{
		global $f;
		if($userUpdate=$this->getUser($id))
		{
			$return=array();
			$return['avatar_select']=$userUpdate['avatar'];
			$return[$f->form.'_login']=$userUpdate['login'];
			$return[$f->form.'_firstname']=$userUpdate['firstname'];
			$return[$f->form.'_lastname']=$userUpdate['lastname'];
			//$return[$f->form.'_password1']=$userUpdate[''];
			//$return[$f->form.'_password2']=$userUpdate[''];
			$return[$f->form.'_email1']=$userUpdate['email'];
			$return[$f->form.'_email2']=$userUpdate['email'];
			$date=explode('-',$userUpdate['datebirth']);
			$return[$f->form.'_daybirth']=isset($date[2])?$date[2]:'';
			$return[$f->form.'_monthbirth']=isset($date[1])?$date[1]:'';
			$return[$f->form.'_yearbirth']=isset($date[0])?$date[0]:'';
			$return[$f->form.'_group']=$userUpdate['group'];
			$return[$f->form.'_emaillive']=$userUpdate['emaillive'];
			$return[$f->form.'_emailyim']=$userUpdate['emailyim'];
			$return[$f->form.'_emailgmail']=$userUpdate['emailgmail'];
			$return[$f->form.'_biographie']=$userUpdate['biographie'];
			$return[$f->form.'_website']=$userUpdate['website'];
			$return[$f->form.'_singature']=$userUpdate['singature'];
			$return[$f->form.'_zonetime']=$userUpdate['zonetime'];
			$return[$f->form.'_country']=$userUpdate['country'];
			$return[$f->form.'_typeadmin']=$userUpdate['typeadmin'];
			//les champs personaliss
			for($i=0;$i<count($f->fieldsCustomBD);$i++)
			{
				$return[$f->form.'_'.$f->fieldsCustomBD[$i]['field']]=$userUpdate[$f->fieldsCustomBD[$i]['field']];
			}
			//switchsadmin
			//section|section-file1|section-file2|section-file3|section2|section2-file1
			$switchsArr=explode('|',$userUpdate['switchsadmin']);
			$switchs = array();
			for($i=0;$i<count($switchsArr);$i++)
			{
				$switchsArr2=explode('-',$switchsArr[$i]);
				if(count($switchsArr2) == 1)
					$switchs[$switchsArr[$i]][] = $switchsArr[$i];
				else if(count($switchsArr2) == 2)
					$switchs[$switchsArr2[0]][] = $switchsArr[$i];
			}
			$return[$f->form.'_switchsadmin']=$switchs;
			return $return;
		}
		else
			return false;
	}
	public function getUser($id,$fields=array())
	{//get user tel q il est dans db pour remplir $_POST
		global $tb_mmbrs,$db;
		if($id > 0)
		{
			if(count($fields) == 0)
				$SQLfields = '*';//tous les champs
			else
			{//selection de champs
				$SQLfields = '';
				for($i=0;$i < count($fields);$i++)
				{
					$SQLfields .= '`'.$fields[$i].'`';
					if($i < count($fields)-1)
						$SQLfields .= ',';
				}
			}
			$r=$db->query("SELECT $SQLfields FROM `$tb_mmbrs` WHERE `id`=$id Limit 1;");
			return $db->getRow($r,'MYSQL_ASSOC');
		}
		else
			return array();
	}
	public function sendMail($type,$userid,$mail_address,$addDatas)
	{
		global $configs,$tpl,$stat;
		if(!isset($configs['config_users_stats_cache']))
			$configs = getDatasInDb(array('config_users_stats_cache'));//send activation
		if(!isset($stat) || !is_object($stat))
		{
			require_once('greensdstats.class.php');
			$stat = new GreenSDStats();
		}
		$MEMBER = $this->showMmbrs("`id` = ".$userid,'','',1,REWRITING,false);
		unset($stat);
		if(isset($MEMBER[0]))
		{
			$MEMBER[0] = updateArray($MEMBER[0],$addDatas);
			$tpl->assign('MMEMBER',$MEMBER[0]);
		}
		$mail = new Mail();
		$mail->AddAddress($mail_address);
		if ($mail->postMail($type))
		{
			$tpl->clear_assign('MMEMBER');
			return true;
		}
		else
		{
			$tpl->clear_assign('MMEMBER');
			return false;
		}
	}
	private function initFields()
	{
		global $f;
		//initialisation
		$_FILES['avatar_load']['name']=isset($_FILES['avatar_load']['name'])?$_FILES['avatar_load']['name']:'';
		$_POST['avatar_select']=isset($_POST['avatar_select'])?$_POST['avatar_select']:'';
		$_POST[$f->form.'_login']=isset($_POST[$f->form.'_login'])?strtolower($_POST[$f->form.'_login']):'';//doit tre en miniscules
		$_POST[$f->form.'_firstname']=isset($_POST[$f->form.'_firstname'])?$_POST[$f->form.'_firstname']:'';
		$_POST[$f->form.'_lastname']=isset($_POST[$f->form.'_lastname'])?$_POST[$f->form.'_lastname']:'';
		$_POST[$f->form.'_password1']=isset($_POST[$f->form.'_password1'])?$_POST[$f->form.'_password1']:'';
		$_POST[$f->form.'_password2']=isset($_POST[$f->form.'_password2'])?$_POST[$f->form.'_password2']:'';
		$_POST[$f->form.'_email1']=isset($_POST[$f->form.'_email1'])?$_POST[$f->form.'_email1']:'';
		$_POST[$f->form.'_email2']=isset($_POST[$f->form.'_email2'])?$_POST[$f->form.'_email2']:'';
		$_POST[$f->form.'_daybirth']=isset($_POST[$f->form.'_daybirth'])?$_POST[$f->form.'_daybirth']:'';
		$_POST[$f->form.'_monthbirth']=isset($_POST[$f->form.'_monthbirth'])?$_POST[$f->form.'_monthbirth']:'';
		$_POST[$f->form.'_yearbirth']=isset($_POST[$f->form.'_yearbirth'])?$_POST[$f->form.'_yearbirth']:'';
		$_POST[$f->form.'_group']=isset($_POST[$f->form.'_group'])?$_POST[$f->form.'_group']:'members';
		$_POST[$f->form.'_emaillive']=isset($_POST[$f->form.'_emaillive'])?$_POST[$f->form.'_emaillive']:'';
		$_POST[$f->form.'_emailyim']=isset($_POST[$f->form.'_emailyim'])?$_POST[$f->form.'_emailyim']:'';
		$_POST[$f->form.'_emailgmail']=isset($_POST[$f->form.'_emailgmail'])?$_POST[$f->form.'_emailgmail']:'';
		$_POST[$f->form.'_biographie']=isset($_POST[$f->form.'_biographie'])?$_POST[$f->form.'_biographie']:'';
		$_POST[$f->form.'_website']=isset($_POST[$f->form.'_website'])?$_POST[$f->form.'_website']:'';
		$_POST[$f->form.'_singature']=isset($_POST[$f->form.'_singature'])?$_POST[$f->form.'_singature']:'';
		$_POST[$f->form.'_zonetime']=isset($_POST[$f->form.'_zonetime'])?$_POST[$f->form.'_zonetime']:'';
		$_POST[$f->form.'_country']=isset($_POST[$f->form.'_country'])?$_POST[$f->form.'_country']:'';
		//for admin
		$_POST[$f->form.'_typeadmin']   = isset($_POST[$f->form.'_typeadmin'])?$_POST[$f->form.'_typeadmin']:'administrator';
		$_POST[$f->form.'_switchsadmin']     = isset($_POST[$f->form.'_switchsadmin'])?$_POST[$f->form.'_switchsadmin']:array();
		
		//les champs personnaliss
		$this->selectCostumFields();
		for($i=0;$i<count($this->customFields);$i++)
		{
			$_POST[$f->form.'_'.$this->customFields[$i]]=isset($_POST[$f->form.'_'.$this->customFields[$i]])?$_POST[$f->form.'_'.$this->customFields[$i]]:'';
		}
	}
	public function checkFromGroup($update=false,$userid='')
	{
		global $f,$tb_gr;
		if($f->checkField('group',$_POST[$f->form.'_group']))
			return $f->checkField('group',array('no_exist',$tb_gr,inQuotes($_POST[$f->form.'_group']),''));
		else
			return false;
	}
	public function checkFromCountry($update=false,$userid='')
	{
		global $f,$tb_gr;
		return $f->checkField('country',$_POST[$f->form.'_country']);
	}
	public function checkAddUser($admin=false,$update=false,$userid='')
	{
		global $configs,$f,$db,$tb_mmbrs,$group;
		if($f->antiRobotForm($configs['config_users_antirobot_tentative_max_adduser'],$configs['config_users_antirobot_tentative_wait_adduser'],false))
		{
			//initialisation
			$this->initFields();
			
			//verification
			if(!$update)
			{
				if($f->checkField('login',$_POST[$f->form.'_login']))
				{
					if($f->checkField('login',array('ban_login',$_POST[$f->form.'_login'])))
						$f->checkField('login',array('exist',$tb_mmbrs,inQuotes($_POST[$f->form.'_login']),1,''));
				}
			}
			
			if(!$update || !empty($_POST[$f->form.'_password1']) || !empty($_POST[$f->form.'_password2']))
			{
				if($f->checkField('password',$_POST[$f->form.'_password1']))
				{
					$f->checkField('password',array('cmp',$_POST[$f->form.'_password1'],$_POST[$f->form.'_password2']));
				}
			}
			
			if($update)//ancien email
			{
				$r=$db->query("SELECT `email` FROM `$tb_mmbrs` WHERE `id` = $userid LIMIT 1;");
				$row=$db->getRow($r,"MYSQL_ASSOC");
				if($_POST[$f->form.'_email1'] != $row['email'])//si il ya un changement
				{
					if($f->checkField('email',array('cmp',$_POST[$f->form.'_email1'],$_POST[$f->form.'_email2'])))
					{//comparer avec la confirmation
						if($f->checkField('email',array('ban_email',$_POST[$f->form.'_email1'])))
						{
							if($f->checkField('email',$_POST[$f->form.'_email1']))//vrifier l email
								$this->newEmail = $_POST[$f->form.'_email1'];
						}
					}
				}
				$db->free($r);
			}
			else
			{
				if($f->checkField('email',array('cmp',$_POST[$f->form.'_email1'],$_POST[$f->form.'_email2'])))
				{
					if($f->checkField('email',array('ban_email',$_POST[$f->form.'_email1'])))
					{
						if($f->checkField('email',$_POST[$f->form.'_email1']))
							$f->checkField('email',array('exist',$tb_mmbrs,inQuotes($_POST[$f->form.'_email1']),1,''));
					}
				}
			}
			
			$f->checkField('firstname',$_POST[$f->form.'_firstname']);
			$f->checkField('lastname',$_POST[$f->form.'_lastname']);
			
			if($_POST[$f->form.'_daybirth'] != '' && $_POST[$f->form.'_monthbirth'] != '' && $_POST[$f->form.'_yearbirth'])
				$f->checkField('datebirth',$_POST[$f->form.'_yearbirth'].'-'.$_POST[$f->form.'_monthbirth'].'-'.$_POST[$f->form.'_daybirth']);
			
			$this->checkFromGroup($update,$userid);
			$this->checkFromCountry($update,$userid);
			$f->checkField('emaillive',$_POST[$f->form.'_emaillive']);
			$f->checkField('emailyim',$_POST[$f->form.'_emailyim']);
			$f->checkField('emailgmail',$_POST[$f->form.'_emailgmail']);
			$f->checkField('biographie',$_POST[$f->form.'_biographie']);
			$f->checkField('website',$_POST[$f->form.'_website']);
			$f->checkField('singature',$_POST[$f->form.'_singature']);
			$f->checkField('zonetime',$_POST[$f->form.'_zonetime']);
			//vrification dans champs custom
			$this->selectCostumFields();
			for($i=0;$i<count($this->customFields);$i++)
			{
				$f->checkField($this->customFields[$i],$_POST[$f->form.'_'.$this->customFields[$i]]);
			}
			//captcha
			if(!$admin && $group->can('mustCaptcha'))
			{
				$f->checkField('captcha',array('captcha',$_POST['captcha']));
			}
			//verification: avatar 
			if(!empty($_FILES['avatar_load']['name']))
			{//vrification: ce n'est pas encor le chargement !
			
				$configs=array_merge($configs,getDatasInDb(
																array(
																		'config_avatar_size_max',
																		'config_avatar_width_max',
																		'config_avatar_height_max',
																		'config_avatar_extentions_allow',
																		'config_avatar_width_resize',
																		'config_avatar_height_resize',
																		'config_avatar_resize',
																		'config_avatar_resize_small'
																)
															)
								);
								
				$configs['config_avatar_extentions_allow']=explode(',',$configs['config_avatar_extentions_allow']);
				for($i=0;$i<count($configs['config_avatar_extentions_allow']);$i++)
					$configs['config_avatar_extentions_allow'][$i]=trim($configs['config_avatar_extentions_allow'][$i]);
			
			
				
				$f->checkField('avatar',
										array('file_img',
										$_FILES['avatar_load'],
										($configs['config_avatar_size_max']*1024),
										$configs['config_avatar_width_max'],
										$configs['config_avatar_height_max'],
										$configs['config_avatar_extentions_allow']
										)
							);
			}
			else
				$f->checkField('avatar',$_POST['avatar_select']);
		}
	}
	
	public function addUser($admin=false,$update=false,$userid='')
	{
		global $configs,$db,$tb_mmbrs,$f,$s;
		if(count($f->getErrors()) == 0)
		{
			$error_load_or_create_thumb=true;
			if(!empty($_FILES['avatar_load']['name']))
			{//load_yes
				if(!isset($configs['config_avatar_size_max']))
					$configs = updateArray($configs,getDatasInDb(array('config_avatar%'),'LIKE'));
				createDirsAvatars();
				$avatar='';
				$avatar=loadFile($_FILES['avatar_load'],($configs['config_avatar_size_max']*1024),PATH_IMGS_AVATARS_UPLOADS,$configs['config_avatar_extentions_allow']);//2
				if($avatar)
				{
					$avatar=DIR_AVATARS.'/'.DIR_AVATARS_UPLOADS.'/'.$avatar;//au format pour l'enrigistrement dans la db
					$extfile=explode('.',$_FILES['avatar_load']['name']);
					$extfile=(string)strtolower($extfile[count($extfile)-1]); /* extension du fichier */
				}
				else
					$error_load_or_create_thumb=false;
				if($configs['config_avatar_resize'] == 'yes' && $avatar && in_array($extfile,array('gif','png','jpg','jpeg')))
				{
					$avatarthumb=creatThumb(PATH_IMGS_AVATARS_UPLOADS,PATH_IMGS.$avatar,$configs['config_avatar_width_resize'],$configs['config_avatar_height_resize'],'thumb_',$configs['config_avatar_resize_small']);
					unlink(PATH_IMGS.$avatar);
					if($avatarthumb)
					{
						$avatar=DIR_AVATARS.'/'.DIR_AVATARS_UPLOADS.'/'.$avatarthumb;//au format
					}
					else
						$error_load_or_create_thumb=false;
				}
				//minuature de visualisation
				$newThumbName=creatThumb(PATH_IMGS_AVATARS_UPLOADS.'thumbs_'.DIR_AVATARS_UPLOADS.'/',PATH_IMGS.$avatar,70,70,'thumb_','');
			}
			else// load_no
			{
				$avatar = $_POST['avatar_select'];
			}
			
			if($error_load_or_create_thumb)
			{//pas d'error lor qu chargement de l'avatar
				//datebirth
				if(!empty($_POST[$f->form.'_daybirth']) && !empty($_POST[$f->form.'_monthbirth']) && !empty($_POST[$f->form.'_yearbirth']))
					$_POST[$f->form.'_datebirth']=$_POST[$f->form.'_yearbirth'].'-'.$_POST[$f->form.'_monthbirth'].'-'.$_POST[$f->form.'_daybirth'];
				else
					$_POST[$f->form.'_datebirth'] = NULL;
				$codeCheckEmail=genrcodeCheckEmail();
				$datas=array(
									'avatar'=>$avatar,
									//'login'=>gpcToBd($_POST[$f->form.'_login']),
									'firstname'=>gpcToBd($_POST[$f->form.'_firstname']),
									'lastname'=>gpcToBd($_POST[$f->form.'_lastname']),
									//'password'=>gpcToBd(md5(md5($_POST[$f->form.'_password1']))),
									//'email'=>gpcToBd($_POST[$f->form.'_email1']),
									'datebirth'=>gpcToBd($_POST[$f->form.'_datebirth']),
									'group'=>gpcToBd($_POST[$f->form.'_group']),
									'emaillive'=>gpcToBd($_POST[$f->form.'_emaillive']),
									'emailyim'=>gpcToBd($_POST[$f->form.'_emailyim']),
									'emailgmail'=>gpcToBd($_POST[$f->form.'_emailgmail']),
									'biographie'=>gpcToBd($_POST[$f->form.'_biographie']),
									'website'=>gpcToBd($_POST[$f->form.'_website']),
									'singature'=>gpcToBd($_POST[$f->form.'_singature']),
									'zonetime'=>gpcToBd($_POST[$f->form.'_zonetime']),
									'country'=>gpcToBd($_POST[$f->form.'_country']),
									'time_register'=>time(),
									'ip'=>IP,
									'check_email_code'=>$codeCheckEmail,
									//'check_email'=>'0',
									//'valid'=>'0'
								);
				//champs custom
				$this->selectCostumFields();
				for($i=0;$i<count($this->customFields);$i++)
				{
					$_POST[$f->form.'_'.$this->customFields[$i]] = is_array($_POST[$f->form.'_'.$this->customFields[$i]])?implode(',',$_POST[$f->form.'_'.$this->customFields[$i]]):$_POST[$f->form.'_'.$this->customFields[$i]];
					$datas[$this->customFields[$i]] = gpcToBd($_POST[$f->form.'_'.$this->customFields[$i]]);
				}
				//admin
				if($admin)
				{
					$datas['typeadmin']=gpcToBd($_POST[$f->form.'_typeadmin']);
					//on prpare les switchs
					$datas['switchsadmin'] = "";
					foreach($_POST[$f->form.'_switchsadmin'] as $key=>$val)
					{
						for($j=0;$j<count($val);$j++)
						{
							$datas['switchsadmin'] .= $val[$j].'|';
						//section|section-name1|section-name2|section-name3
						}
					}
					$datas['switchsadmin']=rtrim($datas['switchsadmin'],'|');
				}
				
				if($update)
				{
					if(!empty($_POST[$f->form.'_password1']))
						$datas += array('password'=>md5(md5(gpcToBd($_POST[$f->form.'_password1']))));

					if($this->newEmail == $_POST[$f->form.'_email1'])
					{//changement d'email
						$datas += array('check_email_address'=>gpcToBd($_POST[$f->form.'_email1']));
						//$datas += array('check_email_code'=>$codeCheckEmail);
						
					}
					if($db->updateArr($tb_mmbrs, $datas,"`id`=$userid"))
					{
						if($this->newEmail == $_POST[$f->form.'_email1'])//changement d'email
						{
							$this->sendMail('change_email',$userid,$_POST[$f->form.'_email1'],array());
						}
						require_once 'greensdstats.class.php';
						$stat = new GreenSDStats();
						$stat->GreenSDGeneral(false);//cache mise a jour
						//on charge les nouveaux infos
						if(!$admin)
						{
							$membertmp=$this->showMmbrs("`id` = ".$userid." AND ".SQL_MEMBERS_VALID,'',0,1,REWRITING,false);
							$this->member = $membertmp[0];
							$s->setVar('member',$this->member);
						}
						return true;
					}
					else
						return false;
				}
				else
				{
					//suite
					$datas += array('login'=>gpcToBd($_POST[$f->form.'_login']));
					$datas += array('email'=>gpcToBd($_POST[$f->form.'_email1']));
					$datas += array('password'=>gpcToBd(md5(md5($_POST[$f->form.'_password1']))));
					//$datas += array('check_email_code'=>$codeCheckEmail);
					$datas += array('check_email'=>'0');
					$datas += array('valid'=>'0');
					//$datas += array('password'=>gpcToBd(md5(md5($_POST[$f->form.'_password1']))));
					//$datas += array('ip'=>IP);
					if($userid=$db->insertArr($tb_mmbrs, $datas))
					{
						//incrment le compteur
						$f->antiRobotForm($configs['config_users_antirobot_tentative_max_adduser'],$configs['config_users_antirobot_tentative_wait_adduser']);
						$this->sendMail('activation_account',$userid,$_POST[$f->form.'_email1'],array());
						require_once 'greensdstats.class.php';
						$stat = new GreenSDStats();
						$stat->GreenSDGeneral(false);
						return true;
					}
					else
					{
						return false;
					}
				}
			}
			else
			{
				$f->errors[] = $f->form."_load_createthumb_avatar";
				return false;
			}
		}
	}
	public function showMmbrs($condition,$order,$startpage,$nomberbypage,$rewriting,$jsedit)
	{
		global $db,$tb_mmbrs,$configs;
		$limit = '';//init
		if(!empty($startpage) && !empty($nomberbypage))
			$limit="LIMIT $startpage , $nomberbypage";
		else if(!empty($nomberbypage))
			$limit="LIMIT $nomberbypage";
		
		$this->selectCostumFields();
		$r = $db->query("SELECT ".$this->user_fields." FROM `$tb_mmbrs` WHERE $condition  $order $limit");
		$tabmmbrs=array();
		while ($row=$db->getRow($r, 'MYSQL_ASSOC')) 
		{
			if(file_exists(PATH_IMGS.$row['avatar']) and !is_dir(PATH_IMGS.$row['avatar']))
				$row['avatar']=URL_IMGS.$row['avatar'];
			else
				$row['avatar']='';
			///URLS
			$row['urls'] = array(
					'account'    => getUrl('member_account',array(),REWRITING),
					'activation' => getUrl('member_activation',array($row['id'],$row['check_email_code']),REWRITING),
					'editProfil' => getUrl('member_edit_profil',array(),REWRITING),
					'changemail' => getUrl('change_email',array($row['id'],$row['check_email_code']),REWRITING),
			);
			
			///STATS
			if($configs['config_users_stats_cache'] == 'yes')
				(array)$row['stats']=$this->statsMmbrGet((string)$row['stats']);
			else
			{
				$statstmp=$this->statsMmbrUpdateStructConsultCache($row['id']);
				if($statstmp)
				{//new cache
					(array)$row['stats']=$statstmp;
				}
				else
				{//le cache est encor utilisable
					(array)$row['stats']=$this->statsMmbrGet((string)$row['stats']);//on peut utiliser le cache
				}
				unset($statstmp);
			}
			///STATUS
			$row['status'] = array(
				'delete'=>$this->getsSatusMmbr('delete',$row['delete']),
				'pending'=>$this->getsSatusMmbr('pending',array('valid'=>$row['valid'],'delete'=>$row['delete'])),
				'check_email'=>$this->getsSatusMmbr('check_email',$row['check_email'])
			);
			///SWITCHSADMIN
			if(empty($row['switchsadmin']))
				$row['switchsadmin'] = array();
			else
				$row['switchsadmin'] = explode('|',$row['switchsadmin']);
			///MENUADMIN
			if(empty($row['menuadmin']))
				$row['menuadmin'] = array();
			else
			{
				$row['menuadmin'] = explode('|',$row['menuadmin']);
				//sort($row['menuadmin']);
			}
			///JSEDIT
			if($jsedit)
			{
				//JSEDIT cats
				$this->js_edit .= jsEdit('edit','#edit_mmbr_country_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=mmbr','country',"mmbrid:".$row['id'],'','','');
				if(count($this->listgroups) == 0)
				$this->listgroups= Group::getListGroups(true);
				$selectdatas = "";
				for($i = 0; $i < count($this->listgroups);$i++)
				{
					if($this->listgroups[$i] != 'guests')
						$selectdatas .= "'".$this->listgroups[$i]."' : '".$this->listgroups[$i]."',";
				}
				$selectdatas=rtrim($selectdatas,',');
				$selectdatas .= ",selected : '".$row['group']."'";
				$this->js_edit .= jsEdit('edit','#edit_mmbr_group_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=mmbr','group',"mmbrid:".$row['id'],'select',$selectdatas,'');
			}
			
			$tabmmbrs[]=$row;
		}
		$db->free($r);
		return $tabmmbrs;
	}
	public function getJsEdit()
	{
		return $this->js_edit;
	}
	public function statsMmbrCreateStruct($id)
	{
		global $stat;
		if(!is_object($stat))
		{
			require_once 'greensdstats.class.php';
			$stat = new GreenSDStats();
		}
		$stats ="";
		$statsArray = $stat->GreenSDMmbr($id);
		foreach($statsArray as $key=>$val)
		{
			$stats .= $key.']|['.$val.']||[';
		}
		$stats = rtrim($stats,']||[');
		return $stats;
	}
	public function statsMmbrGet($struct)
	{
		$stats = array();
		if(gettype($struct) == 'string')
		{
			$statsArray=explode(']||[',$struct);///id]|[name]|[parentsnames]||[id]|[name]|[parentsnames
			if(isset($statsArray[0]))
			{
				if(!empty($statsArray[0]))
				{
					for($i=0;$i<count($statsArray);$i++)
					{
						$statsArray[$i]=explode(']|[',$statsArray[$i]);
						$stats[$statsArray[$i][0]]=$statsArray[$i][1];
					}
				}
			}
		}
		else if (gettype($struct) == 'integer')
		{
			$struct = $this->statsMmbrCreateStruct($struct);
			$stats = $this->statsMmbrGet((string)$struct);
		}
		return $stats;
	}
	public function statsMmbrUpdateStructConsultCache($id)
	{
		global $db,$tb_mmbrs,$cache;
		$cache->setDir(DIR_CACHE_MMBRS_STATS);
		if($cache->old(CACHE_GENRS_STATSMMBR_ID_.$id,false,''))
		{
			$stats = $this->statsMmbrCreateStruct($id);
			if($db->updateArr($tb_mmbrs,array('stats'=>$stats),"`id`=".$id))
			{
				$cache->setDir(DIR_CACHE_MMBRS_STATS);
				$cache->create(CACHE_GENRS_STATSMMBR_ID_.$id,'');
				$cache->setDir('');
				return $stats;
			}
			else
				return $stats;
		}
		else
		{
			$cache->setDir('');
			return false;//on peut utiliser le cache sans faire de mise a jour
		}
	}
	public function statsMmbrUpdateStruct($id)
	{
		global $db,$tb_mmbrs;
		$stats = $this->statsCatCreateStruct($id);
		if($db->updateArr($tb_mmbrs,array('stats'=>$stats),"`id`=".$id))
			return $stats;
		else
			return false;
	}
	public function statsMmbrUpdateStructCache($id)
	{//update cache and db
		global $db,$tb_mmbrs,$cache;
		$stats = $this->statsMmbrCreateStruct($id);
		if($db->updateArr($tb_mmbrs,array('stats'=>$stats),"`id`=".$id))
		{
			$cache->setDir(DIR_CACHE_MMBRS_STATS);
			$cache->create(CACHE_GENRS_STATSMMBR_ID_.$id,'');
			$cache->setDir('');
			return $stats;
		}
		else
			return false;
	}
	private function getsSatusMmbr($type,$value)
	{//l'etat de la catgorie
		switch($type)
		{
			case 'delete' :
				if($value == '1')
					return true;
				else
					return false;
				break;
			case 'check_email' :
				if($value == '1')
					return true;
				else
					return false;
				break;
			case 'pending' :
				if($value['valid'] == '0' && $value['delete'] == '0')
					return true;
				else
					return false;
				break;
		}
	}
}

?>