<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










function dirThumbsForNavig($path,$ssdir,$excludes,$prfex)
{
	$dirs=parcourRepGetNamesDirs($path,$ssdir,$excludes);
	$ssdirexclude=array();
	if(isset($dirs['ssdir']))
	{
		for($i=0;$i<count($dirs['ssdir']);$i++)
		{
			for($j=0;$j<count(isset($dirs['ssdir'][$i]['ssdir'])?$dirs['ssdir'][$i]['ssdir']:array());$j++)
			{
				if($prfex.$dirs['ssdir'][$i]['dirname'] == $dirs['ssdir'][$i]['ssdir'][$j]['dirname'])
					$ssdirexclude[]=$dirs['ssdir'][$i]['ssdir'][$j]['dirname'];
				
			}
		}
	}
	return $ssdirexclude;
}
function rmFilesInDir($rep,$ssdir=false,$ssdirexclude=array(),$acceptexts=array(),$dirToo=false)
{
	if( $dir = opendir($rep) ) 
	{
		$filesinfos['dirname']=basename($rep);
		while( FALSE !== ($fich = readdir($dir)) ) 
		{
			if ($fich != "." && $fich != "..") 
			{
				$chemin = "$rep$fich";
				if (!is_dir($chemin)) 
				{
					/* on extrait la nom du fichier */
					$fichier= preg_replace("#^$rep#","", $chemin);
					$infosfile=pathinfo($chemin);
					if(!isset($infosfile['extension']) || in_array($infosfile['extension'],$acceptexts) || count($acceptexts) == 0)
					{
						unlink($chemin);
					}
				}
				else if(is_dir($chemin) && $ssdir && !in_array(basename($chemin),$ssdirexclude))
				{
					rmFilesInDir($chemin."/",$ssdir,array(),$acceptexts,$dirToo);
				}
			}
		}
		closedir($dir);
		if($dirToo && is_dir($rep))
			rmdir($rep);
	}
}
function countFilesInDir($rep,$ssdir=false,$ssdirexclude=array(),$acceptexts=array(),$totalFiles=0)
{
	if( $dir = opendir($rep) ) 
	{
		$filesinfos['dirname']=basename($rep);
		while( FALSE !== ($fich = readdir($dir)) ) 
		{
			if ($fich != "." && $fich != "..") 
			{
				$chemin = "$rep$fich";
				if (!is_dir($chemin)) 
				{
					/* on extrait la nom du fichier */
					$fichier= preg_replace("#^$rep#","", $chemin);
					$infosfile=pathinfo($chemin);
					if(in_array($infosfile['extension'],$acceptexts) or count($acceptexts) == 0)
					{
						$totalFiles++;
					}
				}
				else/*(is_dir($chemin))*/
				{
					/*pour parcourir les sous repertoir*/
					if($ssdir && !in_array(basename($chemin),$ssdirexclude))
						$totalFiles = countFilesInDir($chemin."/",$ssdir,array(),$acceptexts,$totalFiles);
				}
			}
		}
		closedir($dir);
	}
	return $totalFiles;
}
function parcourRepGetNamesDirs($rep,$ssdir=false,$ssdirexclude=array())
{
	if( $dir = opendir($rep) ) 
	{
		$filesinfos['dirname']=basename($rep);
		//$filesinfos['dirparent']='';
		while( FALSE !== ($fich = readdir($dir)) ) 
		{
			if ($fich != "." && $fich != "..") 
			{
				$chemin = "$rep$fich";
				if (is_dir($chemin)) 
				{
					/*pour parcourir les sous repertoir*/
					if($ssdir && !in_array(basename($chemin),$ssdirexclude))
						$filesinfos['ssdir'][] = parcourRepGetNamesDirs($chemin."/",$ssdir,$ssdirexclude);
				}
			}
		}
		closedir($dir);
	}
	return $filesinfos;
} 

function parcourRep($rep,$ssdir=false,$ssdirexclude=array(),$acceptexts=array(),$urls=array(),$maxFiles=0,$startFile=0)
{
	if( $dir = opendir($rep) ) 
	{
		$filesinfos['totalsize']=0;/* stock les infos des fichiers */
		$filesinfos['dirname']=basename($rep);
		$filesinfos['files']=array();
		$allsize=0;
		$i=0;
		while( FALSE !== ($fich = readdir($dir)) ) 
		{
			if ($fich != "." && $fich != "..") 
			{
				$chemin = "$rep$fich";
				/* on extrait la nom du fichier */
				//$fichier= preg_replace("#^$rep#","", $chemin);
				$infosfile=pathinfo($chemin);
				$infosfile['extension']=isset($infosfile['extension'])?$infosfile['extension']:'';
				if($ssdir && !in_array(basename($chemin),$ssdirexclude) && is_dir($chemin."/"))
						$filesinfos['ssdir'][] = parcourRep($chemin."/",$ssdir,array(),$acceptexts,$urls);
				else if(($i < $startFile) && ($maxFiles > 0) && in_array($infosfile['extension'],$acceptexts))
				{
					$i++;
					continue;
				}
				else if (($i >= ($startFile+$maxFiles)) && ($maxFiles > 0))
				{//si on limit le nombre de fichier a extraire
					$i++;
					break;
				}
				else if(!is_dir($chemin."/") && (in_array($infosfile['extension'],$acceptexts) or count($acceptexts) == 0))
				{
					$urlsimgs=array();
					foreach($urls as $ky =>$vl)
					{
						$urlsimgs[$ky]=$vl.$fich;
					}
					///IMGS
					if(in_array($infosfile['extension'],array('gif','GIF','jpg','JPG','png','PNG')))
					{
						if($_infoimage=@getimagesize($chemin))
						{
							$infoimage['width']=isset($_infoimage[0])?$_infoimage[0]:'';
							$infoimage['height']=isset($_infoimage[1])?$_infoimage[1]:'';
							$infoimage['inimg']=isset($_infoimage[3])?$_infoimage[3]:'';
							$infoimage['bits']=isset($_infoimage['bits'])?$_infoimage['bits']:'';
							$infoimage['channels']=isset($_infoimage['channels'])?$_infoimage['channels']:'';
							$infoimage['mime']=isset($_infoimage['mime'])?$_infoimage['mime']:'';
						}
					}
					else
						$infoimage='';

					$filesinfos['files'][]=array(
									'name'=>$fich,
									'ext'=>$infosfile['extension'],
									'infoimage'=>$infoimage,
									'basename'=>basename($chemin,strrchr($chemin, '.')),
									'size'=>sizeFile(filesize($chemin)),
									'chemin'=>$rep,
									'urls'=>$urlsimgs,
									'time'=>filemtime($chemin)
													);
					/* taille total du repertoire */
					$allsize=$allsize+filesize($chemin);
					$i++;
				}
			}
		}
		$filesinfos['totalsize']=sizeFile($allsize);
		closedir($dir);
	}
	return $filesinfos;
} 


?>