<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require '../cls/mysql.class.php';
require '../cls/smarty/libs/Smarty.class.php';
require 'tables.php';

require '../fnts/parcourrep.php';
require '../fnts.php';

error_reporting(E_ALL);
$gsdVersion = @file_get_contents('version.txt');
$install_is_done = false;
$tpl = new Smarty;
$db = new Mysql;

$msgs = array();
$msgsw = array();
$metaRedirect = "";
define ("IP", isset($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'');
$ins_config_path_domain  = isset($_POST['config_path_domain'])?$_POST['config_path_domain']:$_SERVER['DOCUMENT_ROOT'];
$ins_SERVER_NAME   = isset($_POST['config_domain'])?$_POST['config_domain']:$_SERVER['SERVER_NAME'];
$config_templates_site = isset($_POST['config_templates_site'])?$_POST['config_templates_site']:'';
$config_lang_site = isset($_POST['config_lang_site'])?$_POST['config_lang_site']:'';
$config_lang_admin = isset($_POST['config_lang_admin'])?$_POST['config_lang_admin']:'';
$DIRINSTALLSLANGS=parcourRepGetNamesDirs('langs/',true,array());
$ins_lang = isset($_POST['ins_lang'])?$_POST['ins_lang']:$DIRINSTALLSLANGS['ssdir'][0]['dirname'];
require 'langs/'.$ins_lang.'/install.langs.'.$ins_lang.'.php';
//rep script
if(is_dir($ins_config_path_domain))
{
	$array_rep_script = explode($ins_config_path_domain,$_SERVER["SCRIPT_FILENAME"]);
	$array_rep_script = explode('/install/',$array_rep_script[1]);
	$ins_config_rep_script = trim($array_rep_script[0],'/');
}
else
	$ins_config_rep_script = '';
define("PATH_SCRIPT",rtrim($ins_config_path_domain,'/').'/'.$ins_config_rep_script.'/');
$tpl->config_dir = PATH_SCRIPT.'langs/';
$tpl->compile_dir = PATH_SCRIPT.'cache/smarty/templates_c/';
$tpl->cache_dir = PATH_SCRIPT.'cache/smarty/cache/';
//reps
$ins_config_rep_imgs = $ins_config_rep_script.'/imgs';
$ins_config_dir_cache = $ins_config_rep_script.'/cache';
$ins_HTTP_HOST = isset($_POST['HTTP_HOST'])?$_POST['HTTP_HOST']:$_SERVER['HTTP_HOST'];
//login admin
$ins_adminlogin   = isset($_POST['adminlogin'])?$_POST['adminlogin']:'';
$ins_email1   = isset($_POST['email1'])?$_POST['email1']:'';
$ins_email2   = isset($_POST['email2'])?$_POST['email2']:'';
$ins_pw1   = isset($_POST['pw1'])?$_POST['pw1']:'';
$ins_pw2   = isset($_POST['pw2'])?$_POST['pw2']:'';

//mysql
$ins_config_db_host     = isset($_POST['config_db_host'])  ?$_POST['config_db_host']:'';
$ins_config_db_name     = isset($_POST['config_db_name'])  ?$_POST['config_db_name']:'';
$ins_config_db_user     = isset($_POST['config_db_user'])  ?$_POST['config_db_user']:'';
$ins_config_db_pw       = isset($_POST['config_db_pw'])    ?$_POST['config_db_pw']:'';
//$ins_config_db_prifex   = '';
$ins_config_db_prifex   = isset($_POST['config_db_prifex'])?$_POST['config_db_prifex']:'gsd_';
if(isset($_POST['sbminstallnext1']))
{
	if(empty($ins_adminlogin))
		$msgsw[] = $LANG["install_adminlogin"];
		
	if(empty($ins_email1) && empty($ins_email2))
		$msgsw[] = $LANG["install_email"];
	if($ins_email2 != $ins_email1)
		$msgsw[] = $LANG["install_email_confirm"];
		
	if(empty($ins_pw1) && empty($ins_pw2))
		$msgsw[] = $LANG["install_password"];
	if($ins_pw2 != $ins_pw1)
		$msgsw[] = $LANG["install_password_confirm"];
	if(count($msgsw) == 0)
	{	
		//db
		if($db->connect($ins_config_db_host, $ins_config_db_user, $ins_config_db_pw, $ins_config_db_name))
		{
			define (       "PATH_TPLS_REP_SITE", PATH_SCRIPT."tpls/");
			define (               "PATH_LANGS", PATH_SCRIPT."langs/");
			//creation du fichier start.cnf.php
			$errorsFile=checkSourceFileCnf(); //verification
			if(count($msgsw) == 0)
			{
				$sourcephp = createSourceFileCnf(); //crer la source
				if(file_put_contents(PATH_SCRIPT.'start.cnf.php',$sourcephp))
				{
					$msgs[] = $LANG['install_create_config_done'];
					//$tpl->assign('REDIRECTTAG',redirectPage($currentsectionphp.'.php?section_ad='.$currentsection,0,true));
				}
				else
					$msgsw[] = $LANG['install_create_config_error'];
			}
			else
			{
				$msgsw = updateArray($msgsw,translateArray($errorsFile));
			}
			foreach($ins_tables as $key=>$val)
			{
				if($db->query($val))
					$msgs[] = 'Table : '.$key.' <b>ok</b><br />';
				else
					$msgsw[] = 'Table : '.$key.' <b>'.$LANG['failure'].'</b><br />';
			}
			if($db->insertArr($ins_config_db_prifex.'members',array('ip'=>IP,'check_email'=>'1','valid'=>'1','login'=>$ins_adminlogin,'email'=>$ins_email1,'typeadmin'=>'superadministrator','password'=>md5(md5($ins_pw1)))))
			{
				$msgs[] = $LANG['install_create_tables_db_done'];
				$tb_dt = $ins_config_db_prifex.'datas';
				updateDataInDb(array(
						'version'=>$gsdVersion,
						'config_webmaster_mail'=>$ins_email1,
						'config_mail_from_email'=>$ins_email1,
						'config_mail_from_name'=>$ins_adminlogin,
						'theme'=>isset($_POST['config_templates_site'])?$_POST['config_templates_site']:'default'
				));
				$install_is_done = true;
			}
			else
				$msgsw[] = $LANG["db_error"];
		}
		else
			$msgsw[] = $LANG["db_no_connect"];
	}
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<META NAME="ROBOTS" CONTENT="NOINDEX, NOFOLLOW">
<?php 
echo $metaRedirect;
?>
<style type="text/css">
<!--
body
{
background-color: #ffffff;
font-family: verdana;
}
form
{
	padding: 0;
	margin: 0;
}
.tdfontstyle
{
	font: normal 11px verdana, sans-serif;
}
.tdboxtitle
{
	background:green;
	color:white;
	text-align:center;
	font-weight:bold;
	padding:5px;
}
input
{
	width: 200px;
	color: black;
	border: 1px solid green;
	padding: 2px;
}
input:focus
{
	background: #ccffcc;
}
.install
{
	border: 1px solid green;
	background-color: #FFF;
	width: 600px;
}
button
{
	height: 25px;
	border: none;
	cursor: pointer;
	background: #ccffcc;
}
button:hover
{
	background: #ccff55;
}
//-->
</style>
</head>
<body>
<table align="center" class="install" cellpadding="10" style="border: 1px solid green; background: #ccffcc;">
	<tr>
		<td>

<form method="POST" action="index.php" enctype="multipart/form-data">
<table align="center" class="install" style="background:#ccffcc;">
	<tr>
		<td><a href="http://www.greenscriptdirectory.com" target="_blank"><img src="../admin/tpls/imgs/greensd.png" border="0" alt="Green Script Directory" title="Green Script Directory" /></a></td>
		<td style="text-align:right; font: normal 12px verdana, sans-serif;">
			<?php if(!$install_is_done) { ?>
			<?php echo $LANG["ins_lang"]; ?> : 
			<select name="ins_lang">
			<?php
			for($i=0;$i<count($DIRINSTALLSLANGS['ssdir']);$i++)
			{?>
			<option <?php if($DIRINSTALLSLANGS['ssdir'][$i]['dirname'] == $ins_lang) echo 'selected="selected"'; ?> value="<?php echo $DIRINSTALLSLANGS['ssdir'][$i]['dirname']; ?>" /><?php echo $DIRINSTALLSLANGS['ssdir'][$i]['dirname'].'&nbsp;&nbsp;&nbsp;'; 
			} ?>
			</select>
			<button type="submit" name="sbminstalllang" />OK</button>
			<?php } ?>
		</td>
	</tr>
</table>
<table align="center" style="width: 600px;">
	<tr>
		<td style="font-size:24px; color:green; text-align:center;" colspan="2"><?php echo $LANG['Install']." ($gsdVersion)"; ?>
		<a href="http://www.greenscriptdirectory.com/aide/9-installation" target="_blank"><big><b>(?)</b></big></a></td>
	</tr>
</table>
<?php
//infos
for($i=0;$i<count($msgs);$i++)
{
	echo "<p align='center' style='color:green'>".$msgs[$i]."</p>";
}
for($i=0;$i<count($msgsw);$i++)
{
	echo "<p align='center' style='color:red'>".$msgsw[$i]."</p>";
}

if($install_is_done)
{
	if($ins_config_rep_script == "")
	{
		echo '<center><a href="http://'.rtrim($ins_SERVER_NAME,'/').'/admin/login.php">'.$LANG['go_to_admin'].'</a> | ';
		echo '<a href="http://'.rtrim($ins_SERVER_NAME,'/').'">'.$LANG['go_to_site'].'</a></center>';
	}
	else
	{
		echo '<center><a href="http://'.$ins_SERVER_NAME.'/'.$ins_config_rep_script.'/admin/login.php">'.$LANG['go_to_admin'].'</a> | ';
		echo '<a href="http://'.$ins_SERVER_NAME.'/'.$ins_config_rep_script.'/">'.$LANG['go_to_site'].'</a></center>';
	}
}
else
{
?>


<table align="center" class="install">
	<tr>
		<td class="tdboxtitle" colspan="2"><nobr><?php echo $LANG['Db_config']; ?></nobr></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Db_host']; ?></nobr></td>
		<td align="right">: <input type="text" name="config_db_host" value="<?php echo $ins_config_db_host; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Db_name']; ?></nobr></td>
		<td align="right">: <input type="text" name="config_db_name" value="<?php echo $ins_config_db_name; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Db_user']; ?></nobr></td>
		<td align="right">: <input type="text" name="config_db_user" value="<?php echo $ins_config_db_user; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Password']; ?></nobr></td>
		<td align="right">: <input type="password" name="config_db_pw" value="<?php echo $ins_config_db_pw; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Db_prifex']; ?></nobr></td>
		<td align="right">: <input type="text" name="config_db_prifex" value="<?php echo $ins_config_db_prifex; ?>" /></td>
	</tr>
</table>

<br />

<table align="center" class="install">
	<tr>
		<td class="tdboxtitle" colspan="2"><nobr><?php echo $LANG['Site_config']; ?></nobr></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Path_domain']; ?></nobr></td>
		<td align="right">: <input type="text" name="config_path_domain" value="<?php echo rtrim($ins_config_path_domain,'/'); ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Rep_script']; ?></nobr></td>
		<td align="right">: <input name="config_rep_script" type="text" value="<?php echo $ins_config_rep_script; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Rep_imgs']; ?></nobr></td>
		<td align="right">: <input name="config_rep_imgs" type="text" value="<?php echo $ins_config_rep_imgs; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Rep_cache']; ?></nobr></td>
		<td align="right">: <input name="config_dir_cache" type="text" value="<?php echo $ins_config_dir_cache; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Domain_name']; ?></nobr></td>
		<td align="right" style="font: normal 12px verdana, sans-serif;"><nobr>: http://<input name="config_domain" type="text" value="<?php echo $ins_SERVER_NAME; ?>" /></nobr></td>
	</tr>
<?php
//templates
$DIRSTEMPLATES=parcourRepGetNamesDirs('../tpls/',true,array());
//langs
$DIRSLANGS=parcourRepGetNamesDirs('../langs/',true,array());
?>
	<tr>
		<td class="tdfontstyle"><nobr> <?php echo $LANG['Templates']; ?></nobr></td>
		<td align="right">:
<select name="config_templates_site">
	<?php
	for($i=0;$i<count($DIRSTEMPLATES['ssdir']);$i++)
	{?>
		<option <?php if($DIRSTEMPLATES['ssdir'][$i]['dirname'] == $config_templates_site) echo 'selected="selected"'; ?> value="<?php echo $DIRSTEMPLATES['ssdir'][$i]['dirname']; ?>" /><?php echo $DIRSTEMPLATES['ssdir'][$i]['dirname'].'&nbsp;&nbsp;&nbsp;'; 
	} ?>
</select>
	</td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr> <?php echo $LANG['Lang_site']; ?></nobr></td>
		<td align="right">:
<select name="config_lang_site">
	<?php
	for($i=0;$i<count($DIRSLANGS['ssdir']);$i++)
	{?>
		<option <?php if($DIRSLANGS['ssdir'][$i]['dirname'] == $config_lang_site) echo 'selected="selected"'; ?> value="<?php echo $DIRSLANGS['ssdir'][$i]['dirname']; ?>" /><?php echo $DIRSLANGS['ssdir'][$i]['dirname'].'&nbsp;&nbsp;&nbsp;'; 
	} ?>
</select>
	</td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr> <?php echo $LANG['Lang_admin']; ?></nobr></td>
		<td align="right">:
<select name="config_lang_admin">
	<?php
	for($i=0;$i<count($DIRSLANGS['ssdir']);$i++)
	{?>
		<option <?php if($DIRSLANGS['ssdir'][$i]['dirname'] == $config_lang_admin) echo 'selected="selected"'; ?> value="<?php echo $DIRSLANGS['ssdir'][$i]['dirname']; ?>" /><?php echo $DIRSLANGS['ssdir'][$i]['dirname'].'&nbsp;&nbsp;&nbsp;'; 
	} ?>
</select>
		</td>
	</tr>
</table>

<br />

<table align="center" class="install">
	<tr>
		<td class="tdboxtitle" colspan="2"><nobr><?php echo $LANG['Admin_login']; ?></nobr></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Administrator']; ?></nobr></td>
		<td align="right">: <input type="text" name="adminlogin" value="<?php echo $ins_adminlogin; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Mail']; ?></nobr></td>
		<td align="right">: <input type="text" name="email1" value="<?php echo $ins_email1; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Mail_repeat']; ?></nobr></td>
		<td align="right">: <input type="text" name="email2" value="<?php echo $ins_email2; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Password']; ?></nobr></td>
		<td align="right">: <input type="password" name="pw1" value="<?php echo $ins_pw1; ?>" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo $LANG['Password_repeat']; ?></nobr></td>
		<td align="right">: <input type="password" name="pw2" value="<?php echo $ins_pw2; ?>" /></td>
	</tr>
</table>
<br />
<center>
	<button type="submit" name="sbminstallnext1" /><?php echo $LANG["Finish"]; ?></button>
</center>

<?php } ?>

</form>

		</td>
	</tr>
</table>
</body>
</html>
<?php
closeDb();
?>