<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










if(file_exists('../start.cnf.php'))
	require '../start.cnf.php';
else
	die("Le fichier 'start.cnf.php' n'existe pas, vous n'avez peut-tre pas encor installer GreenSD (<a href='install/index.php'>Page d'installation de GreenSD</a>).");
require "../cnf.php";
require "../cls/checkform.class.php";
require 'langs/'.LANG.'/install.langs.'.LANG.'.php';
loadLang('ge','',true);
$metaRedirect = "";
$gsdVersion = @file_get_contents('version.txt');
$upgrade_is_done = false;
createGlobalUrls();
if(isset($_POST['sbmlogadmin']))
{
	connectDb();
	$configs = updateArray($configs,getGlobalDatasInDb());
	$f = new Checkform('logAdmin',true);
	$s = new Session(SCRIPT_NAME.'_admin');
	$user = new User();
	$errors = array();
	$user->user_fields ="`login`,`password`";
	if($user->loginAdmin())
	{
		$configs = updateArray($configs,getDatasInDb(array('version')));
		$configs['version'] = isset($configs['version'])?$configs['version']:'';
		define("IS_UPGRADE", true);
		switch($configs['version'])
		{
			case '' ://dans la version alpha $configs['version'] n'existait pas, donc il est vide
			case 'alpha' :
				require 'upgrades/alpha.php';
			case 'alpha2' :
				require 'upgrades/alpha2.php';
			case 'beta' :
				require 'upgrades/beta.php';
			case 'beta2' :
				require 'upgrades/beta2.php';
				
			if(!$db->update("UPDATE `$tb_dt` SET `value`='$gsdVersion',`global`='1' WHERE `name` = 'version' LIMIT 1;"))
			{
				$msgsw[] = "Error version name";
			}
		}
		if(count($errors) > 0)
			$msgsw[] = translate('db_error').' : '.implode(',',$errors);
		else
			$upgrade_is_done = true;
	}
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET ?>">
<META NAME="ROBOTS" CONTENT="NOINDEX, NOFOLLOW">
<?php 
echo $metaRedirect;
?>
<style type="text/css">
<!--
form
{
	padding: 0;
	margin: 0;
}
.tdfontstyle
{
	font: normal 11px verdana, sans-serif;
}
input
{
	width: 200px;
	color: black;
	border: 1px solid green;
	padding: 2px;
}
input:focus
{
	background: #ccffcc;
}
.login
{
	border: 1px solid black;
	background-color: #FFF;
	width: 500px;
	margin-top: 150px;
}
.buttonimg
{
	width: 350px;
	height: 25px;
	border: none;
	background: #ccffcc;
	cursor: pointer;
}
.buttonimg:hover
{
	background: #ccff55;
}
//-->
</style>
</head>
<body style="background-color: #ffffff;">


<form method="POST" action="upgrade.php" enctype="multipart/form-data">
<table align="center" class="login">
	<tr>
		<td colspan="2">
		<center><a href="http://www.greenscriptdirectory.com" target="_blank"><img src="../admin/tpls/imgs/greensd.png" border="0" alt="Green Script Directory" title="Green Script Directory" /></a></center>
		</td>
	</tr>
	<tr>
		<td colspan="2" style="font-size:24px; color:green; text-align:center;"><?php echo $LANG['Upgrade']." ($gsdVersion)"; ?>
		<a href="http://www.greenscriptdirectory.com/aide/9-installation" target="_blank"><big><b>(?)</b></big></a></td>
	</tr>
	<tr>
		<td colspan="2">
	<?php
//infos
if(count($msgsw) > 0 || count($msgs) > 0)
{
	for($i=0;$i < count($msgsw);$i++)
		echo "<p align='center' style='color:red'>".$msgsw[$i]."</p>";
	for($i=0;$i < count($msgs);$i++)
		echo "<p align='center' style='color:green'>".$msgs[$i]."</p>";
}
?>
		</td>
	</tr>
	<tr>
		<td colspan="2">
<?php
if($upgrade_is_done)
{
	echo '<center><a href="'.$URLS['admin'].'login.php">'.$LANG['go_to_admin'].'</a> | ';
	echo '<a href="'.$URLS['script'].'">'.$LANG['go_to_site'].'</a></center>';
}
else
{
?>
		</td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo translate('Username'); ?></nobr></td>
		<td align="right">: <input type="text" name="user_login" /></td>
	</tr>
	<tr>
		<td class="tdfontstyle"><nobr><?php echo translate('Password'); ?></nobr></td>
		<td align="right">: <input name="user_password" type="password" /></td>
	</tr>
	<tr>
		<td colspan="2" align="center"><button class="buttonimg" type="submit" name="sbmlogadmin"><?php echo $LANG["Finish"]; ?></button></td>
	</tr>
<?php } ?>
</table>
</form>

</body>
</html>
<?php
closeDb();
?>