<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require 'begin.php';

if(isset($_POST['sbmconfigsavatars']))
{
	$errors=array();
	if(!ctype_digit((string)$_POST['config_avatar_size_max']))
		$errors[]="config_avatar_size_max";
	if(!ctype_digit((string)$_POST['config_avatar_width_max']))
		$errors[]="config_avatar_width_max";
	if(!ctype_digit((string)$_POST['config_avatar_height_max']))
		$errors[]="config_avatar_height_max";
	if(!ctype_digit((string)$_POST['config_avatar_width_resize']))
		$errors[]="config_avatar_width_resize";
	if(!ctype_digit((string)$_POST['config_avatar_height_resize']))
		$errors[]="config_avatar_height_resize";
	if(!in_array($_POST['config_avatar_resize'],array('no','yes')))
		$errors[]="config_avatar_resize";
	if(!in_array($_POST['config_avatar_resize_small'],array('','all')))
		$errors[]="config_avatar_resize_small";

	if(count($errors) == 0)
	{
		$datas=array(
					'config_avatar_size_max'=>gpcToBd($_POST['config_avatar_size_max']),
					'config_avatar_width_max'=>gpcToBd($_POST['config_avatar_width_max']),
					'config_avatar_height_max'=>gpcToBd($_POST['config_avatar_height_max']),
					'config_avatar_extentions_allow'=>gpcToBd($_POST['config_avatar_extentions_allow']),
					'config_avatar_width_resize'=>gpcToBd($_POST['config_avatar_width_resize']),
					'config_avatar_height_resize'=>gpcToBd($_POST['config_avatar_height_resize']),
					'config_avatar_resize'=>gpcToBd($_POST['config_avatar_resize']),
					'config_avatar_resize_small'=>gpcToBd($_POST['config_avatar_resize_small'])
			);
			
		if(updateDataInDb($datas))
			$msgs[] = translate("Edit_done");
		else
			$msgsw[] =translate("db_error");
	}
	else
	{
		$msgsw = addArray($msgsw,translateArray($errors));
			
	}
}



$configs = updateArray($configs,getDatasInDb(array('config_avatar_%'),'LIKE'));

require 'end.php';
?>