<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require 'begin.php';

$URLS['captcha'] = 'captcha.php';
if(isset($_POST['sbmconfigscaptcha']))
{
	$errors=array();
	if(!ctype_digit((string)$_POST['config_captcha_width']))
		$errors[]="config_captcha_width";
	if(!ctype_digit((string)$_POST['config_captcha_height']))
		$errors[]="config_captcha_height";
	if(!ctype_digit((string)$_POST['config_captcha_border_size']))
		$errors[]="config_captcha_border_size";
	if(!ctype_digit((string)$_POST['config_captcha_font_size']))
		$errors[]="config_captcha_font_size";
	if(!ctype_digit((string)$_POST['config_captcha_length']))
		$errors[]="config_captcha_length";
	if(strlen($_POST['config_captcha_bg_color']) == 6 && !preg_match('#[a-zA-Z0-9]+#',$_POST['config_captcha_bg_color']))
		$errors[]="config_captcha_bg_color";
	if(strlen($_POST['config_captcha_border_color']) == 6 && !preg_match('#[a-zA-Z0-9]+#',$_POST['config_captcha_border_color']))
		$errors[]="config_captcha_border_color";
	if(strlen($_POST['config_captcha_font_color']) == 6 && !preg_match('#[a-zA-Z0-9]+#',$_POST['config_captcha_font_color']))
		$errors[]="config_captcha_font_color";
	if(!in_array($_POST['config_captcha_font_color_random'],array('yes','no')))
		$errors[]="config_captcha_font_color_random";
	if(!in_array($_POST['config_captcha_font_upper_lower_case'],array('yes','no')))
		$errors[]="config_captcha_font_upper_lower_case";
	if(!in_array($_POST['config_captcha_noise_level'],array('desabled','level1','level2','level3')))
		$errors[]="config_captcha_noise_level";
	if(count($errors) == 0)
	{
		$datas=array(
					'config_captcha_width'=>gpcToBd($_POST['config_captcha_width']),
					'config_captcha_height'=>gpcToBd($_POST['config_captcha_height']),
					'config_captcha_border_size'=>gpcToBd($_POST['config_captcha_border_size']),
					'config_captcha_bg_color'=>gpcToBd($_POST['config_captcha_bg_color']),
					'config_captcha_border_color'=>gpcToBd($_POST['config_captcha_border_color']),
					'config_captcha_font_size'=>gpcToBd($_POST['config_captcha_font_size']),
					'config_captcha_font_color'=>gpcToBd($_POST['config_captcha_font_color']),
					'config_captcha_font_color_random'=>gpcToBd($_POST['config_captcha_font_color_random']),
					'config_captcha_font_upper_lower_case'=>gpcToBd($_POST['config_captcha_font_upper_lower_case']),
					'config_captcha_length'=>gpcToBd($_POST['config_captcha_length']),
					'config_captcha_noise_level'=>gpcToBd($_POST['config_captcha_noise_level']),
			);
			
		if(updateDataInDb($datas))
			$msgs[] = translate("Edit_done");
		else
			$msgsw[] =translate("db_error");
	}
	else
	{
		$msgsw = addArray($msgsw,translateArray($errors));
			
	}
}
$configs = updateArray($configs,getDatasInDb(array('config_captcha_%'),'LIKE'));
$s->setVar('captcha_code',captchaRandChars());
require 'end.php';
?>