<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require 'begin.php';


if(isset($_POST['sbmconfigsmail']))
{
	$errors=array();
	if(!in_array($_POST['config_mail_method'],array('mail','smtp')))
		$errors[]="config_mail_method";
	if(!preg_match("/^[a-z0-9_-]+@[a-z0-9_-]+\.([a-z]{2,4})$/",$_POST['config_mail_from_email']))
			$errors[]="config_mail_from_email";
	if(!in_array($_POST['switch_mail_mmbr_inform_addlink'],array('yes','no')))
		$errors[]="switch_mail_mmbr_inform_addlink";
	if(!in_array($_POST['switch_mail_mmbr_confirm_addlink_accept'],array('yes','no')))
		$errors[]="switch_mail_mmbr_confirm_addlink_accept";
	if(!in_array($_POST['switch_mail_mmbr_confirm_addlink_reject'],array('yes','no')))
		$errors[]="switch_mail_mmbr_confirm_addlink_reject";
	if(!in_array($_POST['switch_mail_mmbr_inform_editlink'],array('yes','no')))
		$errors[]="switch_mail_mmbr_inform_editlink";
	if(!in_array($_POST['switch_mail_mmbr_confirm_editlink_accept'],array('yes','no')))
		$errors[]="switch_mail_mmbr_confirm_editlink_accept";
	if(!in_array($_POST['switch_mail_mmbr_confirm_editlink_reject'],array('yes','no')))
		$errors[]="switch_mail_mmbr_confirm_editlink_reject";
	if(!in_array($_POST['switch_mail_mmbr_inform_addaccount'],array('yes','no')))
		$errors[]="switch_mail_mmbr_inform_addaccount";
	if(!in_array($_POST['switch_mail_mmbr_confirm_addaccount_accept'],array('yes','no')))
		$errors[]="switch_mail_mmbr_confirm_addaccount_accept";
	if(!in_array($_POST['switch_mail_mmbr_confirm_addaccount_reject'],array('yes','no')))
		$errors[]="switch_mail_mmbr_confirm_addaccount_reject";
	if(!in_array($_POST['switch_mail_mmbr_confirm_changemail'],array('yes','no')))
		$errors[]="switch_mail_mmbr_confirm_changemail";
	if(count($errors) == 0)
	{
		$datas=array(
								'config_mail_method'=>gpcToBd($_POST['config_mail_method']),
								'config_mail_from_email'=>gpcToBd($_POST['config_mail_from_email']),
								'config_mail_from_name'=>gpcToBd($_POST['config_mail_from_name']),
								'switch_mail_mmbr_inform_addlink'=>gpcToBd($_POST['switch_mail_mmbr_inform_addlink']),
								'switch_mail_mmbr_confirm_addlink_accept'=>gpcToBd($_POST['switch_mail_mmbr_confirm_addlink_accept']),
								'switch_mail_mmbr_confirm_addlink_reject'=>gpcToBd($_POST['switch_mail_mmbr_confirm_addlink_reject']),
								'switch_mail_mmbr_inform_editlink'=>gpcToBd($_POST['switch_mail_mmbr_inform_editlink']),
								'switch_mail_mmbr_confirm_editlink_accept'=>gpcToBd($_POST['switch_mail_mmbr_confirm_editlink_accept']),
								'switch_mail_mmbr_confirm_editlink_reject'=>gpcToBd($_POST['switch_mail_mmbr_confirm_editlink_reject']),
								'switch_mail_mmbr_inform_addaccount'=>gpcToBd($_POST['switch_mail_mmbr_inform_addaccount']),
								'switch_mail_mmbr_confirm_addaccount_accept'=>gpcToBd($_POST['switch_mail_mmbr_confirm_addaccount_accept']),
								'switch_mail_mmbr_confirm_addaccount_reject'=>gpcToBd($_POST['switch_mail_mmbr_confirm_addaccount_reject']),
								'switch_mail_mmbr_confirm_changemail'=>gpcToBd($_POST['switch_mail_mmbr_confirm_changemail'])
								
						);
		//smtp
		if($_POST['config_mail_method'] == 'smtp')
		{
			if(!ctype_digit($_POST['config_mail_smtp_port']))
				$errors[]="config_mail_smtp_port";
			
			if(!in_array($_POST['config_mail_smtp_secure'],array('ssl','tls')))
				$errors[]="config_mail_smtp_secure";
			$datas = updateArray($datas,array(
								'config_mail_smtp_host'=>gpcToBd($_POST['config_mail_smtp_host']),
								'config_mail_smtp_port'=>gpcToBd($_POST['config_mail_smtp_port']),
								'config_mail_smtp_secure'=>gpcToBd($_POST['config_mail_smtp_secure']),
								'config_mail_smtp_username'=>gpcToBd($_POST['config_mail_smtp_username']),
								'config_mail_smtp_password'=>gpcToBd($_POST['config_mail_smtp_password'])
								
						));
		}
		if(count($errors) == 0)//2eme verif pour smtp
		{
			if(updateDataInDb($datas))
				$msgs[] = translate("Edit_done");
			else
				$msgsw[] =translate("db_error");
		}
		else
			$msgsw = addArray($msgsw,translateArray($errors));
	}
	else
	{
		$msgsw = addArray($msgsw,translateArray($errors));
	}
}
$configs = updateArray($configs,getDatasInDb(array('config_mail%'),'LIKE'));
$configs = updateArray($configs,getDatasInDb(array('switch_mail%'),'LIKE'));

require 'end.php'; 
?>