<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require('begin.php');

if(isset($_POST['sbmconfigsseo_db']))
{
	$errors=array();
	if(count($errors) == 0)
	{
		$datas=array(
					'config_seo_sitemap_changefreq_cat'=>gpcToBd($_POST['config_seo_sitemap_changefreq_cat']),
					'config_seo_sitemap_changefreq_card'=>gpcToBd($_POST['config_seo_sitemap_changefreq_card']),
					'config_seo_sitemap_cache_time'=>gpcToBd($_POST['config_seo_sitemap_cache_time'])
			);
			
		if(updateDataInDb($datas))
			$msgs[] = translate("Edit_done");
		else
			$msgsw[] =translate("db_error");
	}
	else
	{
		$msgsw = addArray($msgsw,translateArray($errors));
	}
}
else if(isset($_POST['sbmconfigsseo']))
{
	$errors=array();
	$charsSpe='';
	if(preg_match('#['.$charsSpe.']+#',$_POST['config_seo_rewriting_cat_separator']))
		$errors[]="config_seo_rewriting_cat_separator";
	if(preg_match('#['.$charsSpe.']+#',$_POST['config_seo_rewriting_link_separator']))
		$errors[]="config_seo_rewriting_link_separator";

	if(count($errors) == 0)
	{
		$datas=array(
						'config_seo_rewriting_cat_separator'=>gpcToBd($_POST['config_seo_rewriting_cat_separator']),
						'config_seo_rewriting_link_separator'=>gpcToBd($_POST['config_seo_rewriting_link_separator']),
						'config_seo_rewriting_specialschars'=>gpcToBd($_POST['config_seo_rewriting_specialschars']),
						'config_seo_rewriting_htaccess'=>gpcToBd($_POST['config_seo_rewriting_htaccess']),
						'config_seo_rewriting_feedcat'=>gpcToBd($_POST['config_seo_rewriting_feedcat']),
						'config_seo_rewriting_feed'=>gpcToBd($_POST['config_seo_rewriting_feed']),
						'config_seo_rewriting_404'=>gpcToBd($_POST['config_seo_rewriting_404']),
						'config_seo_rewriting_ratelink'=>gpcToBd($_POST['config_seo_rewriting_ratelink']),
						'config_seo_rewriting_hitoutlink'=>gpcToBd($_POST['config_seo_rewriting_hitoutlink']),
						'config_seo_rewriting_register'=>gpcToBd($_POST['config_seo_rewriting_register']),
						'config_seo_rewriting_accessdenied'=>gpcToBd($_POST['config_seo_rewriting_accessdenied']),
						'config_seo_rewriting_category'=>gpcToBd($_POST['config_seo_rewriting_category']),
						'config_seo_rewriting_category_pages'=>gpcToBd($_POST['config_seo_rewriting_category_pages']),
						'config_seo_rewriting_cardlink'=>gpcToBd($_POST['config_seo_rewriting_cardlink']),
						'config_seo_rewriting_addlink'=>gpcToBd($_POST['config_seo_rewriting_addlink']),
						'config_seo_rewriting_editlink'=>gpcToBd($_POST['config_seo_rewriting_editlink']),
						'config_seo_rewriting_addcat'=>gpcToBd($_POST['config_seo_rewriting_addcat']),
						'config_seo_rewriting_newlinks'=>gpcToBd($_POST['config_seo_rewriting_newlinks']),
						'config_seo_rewriting_newlinks_pages'=>gpcToBd($_POST['config_seo_rewriting_newlinks_pages']),
						'config_seo_rewriting_search'=>gpcToBd($_POST['config_seo_rewriting_search']),
						'config_seo_rewriting_search_pages'=>gpcToBd($_POST['config_seo_rewriting_search_pages']),
						'config_seo_rewriting_login'=>gpcToBd($_POST['config_seo_rewriting_login']),
						'config_seo_rewriting_logout'=>gpcToBd($_POST['config_seo_rewriting_logout']),
						'config_seo_rewriting_forgetpw'=>gpcToBd($_POST['config_seo_rewriting_forgetpw']),
						'config_seo_rewriting_account'=>gpcToBd($_POST['config_seo_rewriting_account']),
						'config_seo_rewriting_account_pages'=>gpcToBd($_POST['config_seo_rewriting_account_pages']),
						'config_seo_rewriting_editprofil'=>gpcToBd($_POST['config_seo_rewriting_editprofil']),
						'config_seo_rewriting_captcha'=>gpcToBd($_POST['config_seo_rewriting_captcha']),
						'config_seo_rewriting_reportlink'=>gpcToBd($_POST['config_seo_rewriting_reportlink']),
						'config_seo_rewriting_activeaccount'=>gpcToBd($_POST['config_seo_rewriting_activeaccount']),
						'config_seo_rewriting_changemail'=>gpcToBd($_POST['config_seo_rewriting_changemail'])
		);
			
		if(updateDataInDb($datas))
		{
			$sourcehtaccess = createSourceFileHtaccess();
			if(file_put_contents(PATH_SCRIPT.'.htaccess',$sourcehtaccess))
			{
				$msgs[] = translate('Edit_done');
			}
			else
				$msgsw[] = translate("config_edit_file_htaccess");
		}
		else
			$msgsw[]=translate("db_error");
	}
	else
	{
		$msgsw = addArray($msgsw,translateArray($errors));
	}
}

$configs = updateArray($configs,getDatasInDb(array('config_seo%'),'LIKE'));


require('end.php'); 
?>