<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require 'begin.php';

/* liste des des champs de la table sectionnes */
$r = $db->query("SHOW COLUMNS FROM `$tb_mmbrs`");
$tb_columns=array();
$exclude_columns=array('delete','valid','ip','password','check_email_address','check_email_code','check_email','email','avatar','emaillive','emailyim','emailgmail','switchsadmin','stats','send_email_accept','send_email_reject','typeadmin','menuadmin');
while($row=$db->getRow($r,"MYSQL_NUM"))/* on cherche les infos  */
	if(!in_array($row[0],$exclude_columns))
		$tb_columns[]=$row[0];
$tpl->assign('TBCOLUMNS',$tb_columns);
$db->free($r);
if(isset($_POST['sbmconfigsusers']))
{
	$errors=array();
	if(!in_array($_POST['config_users_valid_account_by_admin'],array('yes','no')))
		$errors[]="config_users_valid_account_by_admin";
	if(!in_array($_POST['config_users_stats_cache'],array('yes','no')))
		$errors[]="config_users_stats_cache";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_max']))
		$errors[]="config_users_antirobot_tentative_max";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_wait']))
		$errors[]="config_users_antirobot_tentative_wait";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_max_addlink']))
		$errors[]="config_users_antirobot_tentative_max_addlink";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_wait_addlink']))
		$errors[]="config_users_antirobot_tentative_wait_addlink";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_max_addcat']))
		$errors[]="config_users_antirobot_tentative_max_addcat";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_wait_addcat']))
		$errors[]="config_users_antirobot_tentative_wait_addcat";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_max_adduser']))
		$errors[]="config_users_antirobot_tentative_max_adduser";
	if(!ctype_digit((string)$_POST['config_users_antirobot_tentative_wait_adduser']))
		$errors[]="config_users_antirobot_tentative_wait_adduser";
	//mettre dans l'ordre ban ips
	if(!empty($_POST['config_users_ban_ips']))
	{
		$banips = explode('\r\n',$_POST['config_users_ban_ips']);
		sort($banips);
		$_POST['config_users_ban_ips'] = implode("\r\n",$banips);
	}
	//mettre dans l'ordre ban mails
	if(!empty($_POST['config_users_ban_mails']))
	{
		$banmails = explode('\r\n',$_POST['config_users_ban_mails']);
		sort($banmails);
		$_POST['config_users_ban_mails'] = implode("\r\n",$banmails);
	}
	//mettre dans l'ordre ban logins
	if(!empty($_POST['config_users_ban_logins']))
	{
		$banlogins = explode('\r\n',$_POST['config_users_ban_logins']);
		sort($banlogins);
		$_POST['config_users_ban_logins'] = implode("\r\n",$banlogins);
	}
	$_POST['config_users_orderby'] = $_POST['config_users_orderby'].$_POST['config_users_orderby2'].$_POST['config_users_orderby3'].$_POST['config_users_orderby4'];
	if(count($errors) == 0)
	{
		$datas=array(
						'config_users_valid_account_by_admin'=>gpcToBd($_POST['config_users_valid_account_by_admin']),
						'config_users_stats_cache'=>gpcToBd($_POST['config_users_stats_cache']),
						'config_users_orderby'=>gpcToBd($_POST['config_users_orderby']),
						'config_users_antirobot_tentative_max'=>gpcToBd($_POST['config_users_antirobot_tentative_max']),
						'config_users_antirobot_tentative_wait'=>gpcToBd($_POST['config_users_antirobot_tentative_wait']),
						'config_users_ban_ips'=>gpcToBd($_POST['config_users_ban_ips']),
						'config_users_ban_mails'=>gpcToBd($_POST['config_users_ban_mails']),
						'config_users_ban_logins'=>gpcToBd($_POST['config_users_ban_logins']),
						'config_users_antirobot_tentative_max_addlink'=>gpcToBd($_POST['config_users_antirobot_tentative_max_addlink']),
						'config_users_antirobot_tentative_wait_addlink'=>gpcToBd($_POST['config_users_antirobot_tentative_wait_addlink']),
						'config_users_antirobot_tentative_max_addcat'=>gpcToBd($_POST['config_users_antirobot_tentative_max_addcat']),
						'config_users_antirobot_tentative_wait_addcat'=>gpcToBd($_POST['config_users_antirobot_tentative_wait_addcat']),
						'config_users_antirobot_tentative_max_adduser'=>gpcToBd($_POST['config_users_antirobot_tentative_max_adduser']),
						'config_users_antirobot_tentative_wait_adduser'=>gpcToBd($_POST['config_users_antirobot_tentative_wait_adduser'])
						);
			
		if(updateDataInDb($datas))
			$msgs[] = translate("Edit_done");
		else
			$msgsw[] =translate("db_error");
	}
	else
	{
		$msgsw = addArray($msgsw,translateArray($errors));
	}
}

$configs = updateArray($configs,getDatasInDb(array('config_users_%'),'LIKE'));
$tmpOrder = explode(',',$configs['config_users_orderby']);
$configs['config_users_orderby'] = isset($tmpOrder[0])?$tmpOrder[0]:'';
$configs['config_users_orderby2'] = isset($tmpOrder[1])?','.$tmpOrder[1]:'';
$configs['config_users_orderby3'] = isset($tmpOrder[2])?','.$tmpOrder[2]:'';
$configs['config_users_orderby4'] = isset($tmpOrder[3])?','.$tmpOrder[3]:'';
unset($tmpOrder);
require 'end.php'; 
 ?>