<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require 'begin.php';
$tpl->register_function('print_var', 'print_var');
function colorStr($str,$color)
{
	return "<span style='color: #$color'>$str</span>";
}
function colorCode($code)
{
	$code = str_replace('Array',colorStr('<b>Array</b>','0000FF'),$code);//Array
	$code = preg_replace("#\[(.*)\]#",colorStr("[$1]",'008200'),$code);//]
	$code = str_replace('[',colorStr('[','FF3333'),$code);//[
	$code = str_replace(']',colorStr(']','FF3333'),$code);//]
	$code = str_replace('(',colorStr('(','0000FF'),$code);//[
	$code = str_replace(')',colorStr(')','0000FF'),$code);//]
	return $code;
}
function print_var($params)
{
	global $tpl;
    extract($params);
    //coloration
    $value=colorCode(print_r($tpl->get_template_vars($name),true));
	return '<pre>'.colorStr('{$'.$name.'}','660000').' = '.$value.'</pre>';
}
loadLang('mn','parts',true);
$tpl->assign('LAST_UPDATE','07-10-2008');


//tableau de structure
$manualSections=array(
				array('title'=>translate('les_variables_globales'),'sections'=>array('vars_URLS','vars_GSD','vars_STATS')),
				array('title'=>translate('les_variables_des_categories'),'sections'=>array('vars_CATS','vars_CAT')),
				array('title'=>translate('les_variables_des_liens'),'sections'=>array('vars_LINKS','vars_LINK')),
				array('title'=>translate('les_variables_des_utilisateurs'),'sections'=>array('vars_USER','vars_MEMBER'))
				);

//partie qui permet de rcuperer le contenu de certaines vars
$_GET['namevar']=isset($_GET['namevar'])?$_GET['namevar']:'';
if(!empty($_GET['namevar']))
{
	switch($_GET['namevar'])
	{
		case 'STATS' :
			require_once '../cls/greensdstats.class.php';
			$stat = new GreenSDStats();
			$tpl->assign('STATS',$stat->GreenSDGeneral(true));
			break;
		case 'MEMBER' : 
			$tpl->assign('MEMBER','Array
(
    [id] => 1
    [ip] => 
    [login] => admin
    [firstname] => 
    [lastname] => 
    [email] => 
    [group] => members
    [time_register] => 1216492483
    [time_last_update] => 0
    [time_check] => 1216472637
    [time_valid] => 0
    [avatar] => http://www.example.com/GreenSD/imgs/avatars/uploads/abrochadora.jpg
    [datebirth] => 0000-00-00
    [emaillive] => 
    [emailyim] => 
    [emailgmail] => 
    [biographie] => 
    [website] => 
    [singature] => 
    [zonetime] => 
    [country] => 
    [stats] => Array
        (
        )

    [check_email_address] => 
    [check_email_code] => hF9I03t7t6Mjut9v69Wnej465xI1Z6
    [check_email] => 1
    [valid] => 1
    [delete] => 0
    [urls] => Array
        (
            [account] => http://www.example.com/GreenSD/account.php
            [activation] => http://www.example.com/GreenSD/active_account.php?userid=1&activation=hF9I03t7t6Mjut9v69Wnej465xI1Z6
            [editProfil] => http://www.example.com/GreenSD/editprofil.php
        )

    [status] => Array
        (
            [delete] => 
            [pending] => 
            [check_email] => 1
        )

)
			');
			break;
		case 'USER' :
			$tpl->assign('USER','Array
(
    [isMember] => 1
    [isGuest] => 
    [canAddCat] => 1
    [canAddLink] => 1
    [canEditLink] => 1
    [canEditProfil] => 1
    [canReportLink] => 1
    [mustCaptcha] => 1
)
			');
			break;
		case 'CATS' :
		case 'CAT' :
			require '../cls/cat.class.php';
			$cat = new Cat();
			$tmpCATS = $cat->showCats(SQL_CATS_VALID,$configs['config_cats_orderby'],0,1,2,REWRITING,false);
			
			if($_GET['namevar'] == 'CAT')
					$tpl->assign('CAT',isset($tmpCATS[0])?$tmpCATS[0]:Array());
				else
					$tpl->assign('CATS',$tmpCATS);
			break;
		case 'LINKS':
		case 'LINK':
			

			
			if($_GET['namevar'] == 'LINKS' || $_GET['namevar'] == 'LINK')
			{
				require_once '../cls/link.class.php';
				$link = new Link();
				$tmpLINKS=$link->showLinks(
								SQL_LINKS_VALID,
								$configs['config_links_orderby'],
								0,
								1,
								REWRITING,
								false
							);
				if($_GET['namevar'] == 'LINK')
					$tpl->assign('LINK',isset($tmpLINKS[0])?$tmpLINKS[0]:Array());
				else
					$tpl->assign('LINKS',$tmpLINKS);
			}
		break;
	}
}



//on charge les variables du manual
$manualContents=array();
for($i=0;$i<count($manualSections);$i++)
{
	$manualContents[$i]['part']['num'] = $i+1;
	$manualContents[$i]['part']['title'] = $manualSections[$i]['title'];
	for($j=0;$j<count($manualSections[$i]['sections']);$j++)
	{
		loadLang('mn',$manualSections[$i]['sections'][$j],true);
		$manualContents[$i]['part']['sections'][] = array(
			'num'=>($i+1).'.'.($j+1),
			'title'=>translate('manualTitle'),
			'printVar'=>print_var(array('name'=>translate('manualVar'))),
			'nameVar'=>translate('manualVar'),
			'description'=>translate('manualDescription'),
			'example'=>translate('manualExample')
		);
	}
}
$tpl->assign_by_ref('MANUAL',$manualContents);
//print_r($manualContents);



require 'end.php'; 
?>