<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










require 'simplepie/simplepie.inc';

class Feed
{
	function __construct()
	{
		
		
	}
	function __destruct()
	{
		
	}
	public function parseFeed($url)
	{
		//initialisation
		$feed = new SimplePie();
		$feed->set_feed_url($url);
		$feed->enable_cache(true);
		$feed->set_cache_location(PATH_CACHE. 'simplepie');
		$feed->set_cache_duration(900);//secondes
		$feed->set_timeout(30);
		$feed->set_max_checked_feeds(1);//nombre d'url max a virifier
		$feed->enable_order_by_date(true);
		$feed->set_output_encoding(CHARSET);
		$feed->strip_attributes(array()/*array('src', 'alt', 'title')*/);
		$feed->strip_comments(array());
		$feed->strip_htmltags(array()/*array('blink', 'font', 'marquee')*/);
		$feed->set_autodiscovery_cache_duration(1209600); // 2 weeks
		$feed->init();
		
		$contentsFeed=array();
		$contentsFeed['feed']=array(
											'copyright'=>$feed->get_copyright(),
											'description'=>$feed->get_description(),
											'quantity'=>$feed->get_item_quantity(20),
											'language'=>$feed->get_language(),
											'type'=>$feed->get_type(),
											'title'=>$feed->get_title(),
											'favicon'=>$feed->get_favicon(),
											'link'=>$feed->get_permalink(),
											'imglink'=>$feed->get_image_link(),
											'imgurl'=>$feed->get_image_url(),
											'imgtitle'=>$feed->get_image_title(),
											'imgwidth'=>$feed->get_image_width(),
											'imgheight'=>$feed->get_image_height()
											
											);
		$i=1;
		foreach ($feed->get_items() as $item)
		{
			//cat
			$itemcat='';
			if ($category = $item->get_category())
			{
				$itemcat = $category->get_label();
			}
			//enclosure
			$itemenclosureUrl='';
			if ($enclosure = $item->get_enclosure())
			{
				$itemenclosureUrl=$enclosure->get_link();
			}
			
			$contentsFeed['items'][]=array(
											'index'=>$i-1,
											'number'=>$i,
											'title'=>$item->get_title(),
											'link'=>$item->get_permalink(),
											'date'=>$item->get_date(/*'j F Y, g:i a'*/),
											'description'=>$item->get_description(),
											'category'=>$itemcat,
											'enclosureUrl'=>$itemenclosureUrl
								);
			if($i >= 20)
				break;
			$i++;
		}
		return $contentsFeed;
	}
}
?>