<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class Group
{
	private	$userGroup;
	private $userPrivileges = array();
	private $listgroups = array();
	private $fields = '`canAddCat`,`canAddLink`,`canEditLink`,`canEditProfil`,`canRateLink`,`canReportLink`,`mustCaptcha`';
	function __construct($userid)
	{
		global $user;
		if(ctype_digit($userid))
		{
			$infosUser=$user->getUser($userid,array('group'));
			$this->userGroup = $infosUser['group'];
		}
		else
			$this->userGroup = 'guests';
	}
	function __destruct()
	{
		
	}
	public function getPrivileges($reload=false)
	{//yes => true et no => false
		$this->loadPrivileges($reload);
		return yesNoToBolArray($this->userPrivileges);
	}
	private function loadPrivileges($reload)
	{
		if($reload || count($this->userPrivileges) == 0)
		{
			global $db,$tb_gr;
			$r=$db->query("SELECT ".$this->fields." FROM `$tb_gr` WHERE `group` = '".$this->userGroup."' LIMIT 1;");
			$this->userPrivileges = $db->getRow($r,'MYSQL_ASSOC');
			$db->free($r);
			//valeurs fixes
			if($this->userGroup == 'guests')
				$this->userPrivileges['canAddLink'] = 'no';
		}
		
	}
	public function can($id,$reload=false)
	{
		$this->loadPrivileges($reload);
		if(isset($this->userPrivileges[$id]) && $this->userPrivileges[$id] == 'yes')
			return true;
		else
			return false;
		
	}
	public function getListGroups($reload)
	{
		if($reload || count($this->listgroups) == 0)
		{
			global $db,$tb_gr;
			$r = $db->query("SELECT `group` FROM `$tb_gr`");
			$this->groups = array();
			while($row=$db->getRow($r,"MYSQL_ASSOC"))/* on cherche les infos  */
			{
				$this->listgroups[]=$row['group'];
			}
			$db->free($r);
		}
		return $this->listgroups;
	}
}
?>