<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class Link
{
	private $js_edit = '';
	private $cats = array();
	private $link_fields = '';
	private $customFields=array();
	function __construct()
	{
		global $tb_cats,$tb_links;
		$this->link_fields="
		`$tb_links`.`id` AS `id`,
		`$tb_links`.`updateid` AS `updateid`,
		`$tb_links`.`catid` AS `catid` ,
		`$tb_cats`.`parentsids` AS `parentsids`,
		`$tb_cats`.`parentsnames` AS `parentsnames`,
		`$tb_links`.`userid` AS `userid`,
		`$tb_links`.`user_login` AS `user_login`,
		`$tb_links`.`time_submit` AS `time_submit`,
		`$tb_links`.`time_valid` AS `time_valid`,
		`$tb_links`.`time_update_submit` AS `time_update_submit`,
		`$tb_links`.`time_update_valid` AS `time_update_valid`,
		`$tb_links`.`url` AS `url`,
		`$tb_links`.`title` AS `title`,
		`$tb_links`.`description` AS `description`,
		`$tb_links`.`recip_url` AS `recip_url`,
		`$tb_links`.`feed_url` AS `feed_url`,
		`$tb_links`.`tags` AS `tags`,
		`$tb_links`.`ip` AS `ip`,
		`$tb_links`.`recip_valid` AS `recip_valid`,
		`$tb_links`.`check_email` AS `check_email`,
		`$tb_links`.`valid` AS `valid`,
		`$tb_links`.`update` AS `update`,
		`$tb_links`.`hide` AS `hide`,
		`$tb_links`.`dead` AS `dead`,
		`$tb_links`.`delete` AS `delete`,
		`$tb_links`.`rate` AS `rate`,
		`$tb_links`.`countrate` AS `countrate`,
		`$tb_links`.`pagerank` AS `pagerank`,
		`$tb_cats`.`nav` AS `nav`,
		`$tb_links`.`report` AS `report`,
		`$tb_links`.`hitsout` AS `hitsout`
		";
	}
	function __destruct()
	{

	}
	private function selectCostumFields()
	{
		if(count($this->customFields) == 0)
		{
			global $db,$tb_links;
			$r=$db->query("SHOW COLUMNS FROM `".$tb_links."` LIKE 'cl_%';");
			while ($row=$db->getRow($r,"MYSQL_ASSOC"))
			{
				$this->link_fields .= ",`".$row['Field']."`";
				$this->customFields[] = $row['Field'];
			}
			$db->free($r);
		}
	}
	function getCats($condition)
	{
		if(count($this->cats) == 0)
		{
			global $db,$tb_cats;
			$r=$db->query("SELECT `id`,`parentsnames` FROM `$tb_cats` WHERE $condition ORDER BY `parentsnames`;");
			while($row=$db->getRow($r,'MYSQL_ASSOC'))
			{
				$this->cats[] = $row;
			}
			$db->free($r);
		}
		return $this->cats;
	}
	function getJsEdit()
	{
		return $this->js_edit;
	}
	function addJsEdit($js,$id,$url,$fieldname,$submitdata,$type,$data,$idaction)
	{//id est un tableau des id dans l'ordre ;)
		if($js == "edit")
		{
			$this->js_edit .= '$("'.$id.'").editable("'.$url.'",{'."\n";
			$this->js_edit .='indicator : "<img src=\"'.URL_IMGS_ADMIN.'loading3.gif\" alt=\"\" border=\"\" />",'."\n";
			$this->js_edit .='tooltip   : "Doubleclick to edit...",'."\n";
			if(!empty($type))
				$this->js_edit .='type      : "'.$type.'",'."\n";
			$this->js_edit .='submit    : "OK",'."\n";
			$this->js_edit .='cancel    : "Cancel",'."\n";
			$this->js_edit .='event     : "dblclick",'."\n";
			if(!empty($data))
			$this->js_edit .='data      : "{'.$data.'}",'."\n";
			//$this->js_edit .='cssclass  : "ajaxedit",'."\n";
			//$this->js_edit .='style     : "height: 150px",'."\n";
			//$this->js_edit .='select : true,'."\n";
			if(!empty($submitdata))
				$submitdata = ",".$submitdata;
			$this->js_edit .='submitdata: { fieldname: "'.$fieldname.'"'.$submitdata.' }'."\n";
			$this->js_edit .='});'."\n";
		}
		else if($js == 'post')
		{
			$this->js_edit .= '$("'.$idaction.'").click(function(){'."\n";
				$this->js_edit .= '$.ajax({'."\n";
				$this->js_edit .= 'type: "POST",'."\n";
				$this->js_edit .= 'url: "'.$url.'",'."\n";
				$this->js_edit .= ' data: "'.$submitdata.'",'."\n";
				$this->js_edit .= 'beforeSend: function(){'."\n";
				$this->js_edit .= '$("'.$id.'").html("<img src=\"'.URL_IMGS_ADMIN.'loading3.gif\" alt=\"\" border=\"\" />");'."\n";
				$this->js_edit .= '},'."\n";
				$this->js_edit .= 'success: function(check){'."\n";
				$this->js_edit .= '$("'.$id.'").html(check);'."\n";
				$this->js_edit .= '}'."\n";
				$this->js_edit .= '});'."\n";
			$this->js_edit .= '});'."\n";
		}
	}
	function getsStatusLink($type,$value)
	{//l'etat de la catgorie
		switch($type)
		{
			case 'report' :
				if($value == '')
					return false;
				else
					return true;
				break;
			case 'delete' :
				if($value == '1')
					return true;
				else
					return false;
				break;
			case 'hide' :
				if($value == '1')
					return true;
				else
					return false;
				break;
			case 'update' :
				if($value == '1')
					return true;
				else
					return false;
				break;
			case 'pending' :
				if($value['valid'] == '0' && $value['delete'] == '0' && $value['hide'] == '0' && $value['update'] == '0')
					return true;
				else
					return false;
				break;
		}
	}
	public function getLinkRate($id,$max,$useCache)
	{
		global $db,$tb_rts,$cache,$tb_links;
		$cache->setDir(DIR_CACHE_LINKS_RATES);
		//RATES
		$rateArr = array();
		for($i=0;$i<$max;$i++)//notes possibles
		{
			$rateArr['vals'][] = $i+1;
		}
		//moyenne
		$rAvg = $db->query("SELECT `rate` FROM `$tb_rts` WHERE `linkid` = ".$id.";");
		$sumRate = 0;//somme des notes
		$countRate = 0;
		while($rowAvg = $db->getRow($rAvg,'MYSQL_ASSOC'))
		{
			$sumRate = $sumRate + $rowAvg['rate'];
			$countRate++;
		}
		if($sumRate > 0)
			$rateArr['avg'] = round($sumRate/$countRate,2);
		else
			$rateArr['avg'] = '';
		$rateArr['countRates'] = $countRate;//nombre de notes
		$rateArr['max'] = $max;

		//mise a jour cache
		if($useCache == 'yes' && !empty($rateArr['avg']))
			$db->updateArr($tb_links,array('rate'=>$rateArr['avg'],'countrate'=>$countRate),'`id` = '.$id);

		return $rateArr;
	}
	private function reportLinkToArray($struct)
	{
		$return =array('ip'=>'','time'=>'','report'=>'','email'=>'','login'=>'','userid'=>'');
		$structArr = explode(']||[',$struct);
		for($i=0;$i<count($structArr);$i++)
		{
			$structArr2 = explode(']|[',$structArr[$i]);
			if(isset($structArr2[0]) && isset($structArr2[1]))
				$return[$structArr2[0]] = $structArr2[1];
		}
		return $return;
	}
	public function showLinks($condition,$order,$startpage,$nomberbypage,$rewriting,$jsedit)
	{
		global $tb_links,$tb_cats,$db,$stat,$configs,$tb_rts;
		require_once 'cat.class.php';
		$cat = new Cat();
		$limit='';
		if(!empty($startpage) && !empty($nomberbypage))
			$limit="LIMIT $startpage , $nomberbypage";
		else if(!empty($nomberbypage))
			$limit="LIMIT $nomberbypage";
			
		$this->selectCostumFields();
		$r = $db->query("SELECT ".$this->link_fields." FROM `$tb_links`,`$tb_cats` WHERE $condition AND `$tb_links`.`catid` = `$tb_cats`.`id` $order $limit;");
		$tablinks=array();
		while ($row=$db->getRow($r,'MYSQL_ASSOC')) 
		{
			//STATUS
			$row['status']['update']=$this->getsStatusLink('update',$row['update']);
			$row['status']['delete']=$this->getsStatusLink('delete',$row['delete']);
			$row['status']['hide']=$this->getsStatusLink('hide',$row['hide']);
			$row['status']['report']=$this->getsStatusLink('report',$row['report']);
			$row['status']['pending']=$this->getsStatusLink('pending',array('update'=>$row['update'],'valid'=>$row['valid'],'delete'=>$row['delete'],'hide'=>$row['hide']));
			//TAGS
			$row['tagsArr'] = array();
			$arrtmp = explode(',',$row['tags']);
			for($i=0;$i< count($arrtmp);$i++)
			{
				$arrtmp[$i] = trim($arrtmp[$i]);
				$row['tagsArr'][] = array('tag'=>$arrtmp[$i],'url'=>getUrl('link_search_pages',array($arrtmp[$i],'off','startlinks',0),$rewriting));
			}
			unset($arrtmp);
			//REPORT
			$row['report'] = $this->reportLinkToArray($row['report']);
			$row['reports'] = explode("\r\n",$configs['config_links_types_report']);//les rapports possibles
			//URLS
			$row['urls'] = array(
				'card' => getUrl('link_card',array($row['parentsnames'],$row['catid'],$row['title'],$row['id']),$rewriting),
				'cat' => getUrl('link_cat',array($row['parentsnames'],$row['catid']),$rewriting),
				'edit' => getUrl('member_edit_link',array($row['id']),$rewriting),
				'report' => getUrl('link_report',array($row['id']),$rewriting),
				'feedCat' => getUrl('cat_feed',array($row['catid']),$rewriting),
				'rate' => getUrl('link_rate',array($row['id']),$rewriting),
				'hitout' => getUrl('link_hitout',array($row['id']),$rewriting)
							);

			if($row['update'] == '1')
			{//si une mise a jour les nouvelles donnes
				$update_newdatas=$this->showLinks("`updateid`=".$row['id'],'ORDER BY `id` DESC',0,1,$rewriting,$jsedit);
				$row['update_newdatas']=isset($update_newdatas[0])?$update_newdatas[0]:array();
				unset($update_newdatas);
				
			}else
				$row['update_newdatas']=array();
			//nav
			if($configs['config_cats_nav_cache'] == 'yes')
				(array)$row['nav']=$cat->navCatGet((string)$row['nav']);
			else
			{
				$navtmp=$cat->navCatUpdateStructConsultCache($row['catid']);
				if($navtmp)
				{//new cache
					(array)$row['nav']=$navtmp;
					unset($navtmp);
				}
				else
				{//le cache est encor utilisable
					(array)$row['nav']=$cat->navCatGet((string)$row['nav']);//on peut utiliser le cache
				}
			}
			//RATE
			if($configs['config_links_rate_cache'] == 'yes')
			{
				$rateArr=array();
				for($i=0;$i<$configs['config_links_rate_max'];$i++)//notes possibles
				{
					$rateArr[] = $i+1;
				}
				$row['rate'] = array(
					'avg'=>$row['rate'],
					'max'=>$configs['config_links_rate_max'],
					'vals'=>$rateArr
				);
			}
			else
				$row['rate'] = $this->getLinkRate($row['id'],$configs['config_links_rate_max'],$configs['config_links_rate_cache']);
			//DATES
			if($row['time_submit'] == 0)
				$row['time_submit'] = '';
			if($row['time_valid'] == 0)
				$row['time_valid'] = '';
			if($row['time_update_submit'] == 0)
				$row['time_update_submit'] = '';
			if($row['time_update_valid'] == 0)
				$row['time_update_valid'] = '';
			
			//PRIORITY
			$row['priority'] = $this->linkPriority();
			//JSEDIT
			if($jsedit)
			{
				$this->addJsEdit('edit','#edit_link_title_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','title',"linkid:".$row['id'],'','','');
				$this->addJsEdit('edit','#edit_link_description_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','description',"linkid:".$row['id'],'textarea','','');
				$this->addJsEdit('edit','#edit_link_url_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','url',"linkid:".$row['id'],'','','');
				$this->addJsEdit('edit','#edit_link_recip_url_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','recip_url',"linkid:".$row['id'],'','','');
				$this->addJsEdit('edit','#edit_link_feed_url_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','feed_url',"linkid:".$row['id'],'','','');
				$this->addJsEdit('edit','#edit_link_tags_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','tags',"linkid:".$row['id'],'','','');
				$this->addJsEdit('edit','#edit_link_user_login_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','user_login',"linkid:".$row['id'],'','','');
				//JSEDIT cats
				if(ctype_digit($configs['stats_cat_total_cats_valid']) && $configs['stats_cat_total_cats_valid'] < 1000)
				{
					$this->getCats(SQL_CATS_VALID);
					$selectdatas = "";
					for($i = 0; $i < count($this->cats);$i++)
					{
						$selectdatas .= $this->cats[$i]['id']." : ".inQuotes(str_replace('][','-->',$this->cats[$i]['parentsnames'])).",";
					}
					$selectdatas=rtrim($selectdatas,',');
					$selectdatas .= ",selected : ".$row['catid'];
					$this->addJsEdit('edit','#edit_link_catid_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','catid',"linkid:".$row['id'],'select',$selectdatas,'');
				}
				//JSEDIT valider le lien reciproque
				$this->addJsEdit('post','#edit_link_recip_valid_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','recip_valid',"fieldname=recip_valid&linkid=".$row['id']."&value=".$row['recip_valid'],'','','#check_recip_valid_'.$row['id']);
				//JSEDIT lien mort
				$this->addJsEdit('post','#edit_link_dead_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','dead',"fieldname=dead&linkid=".$row['id']."&value=".$row['dead'],'','','#check_dead_'.$row['id']);
				$this->addJsEdit('post','#edit_link_pagerank_'.$row['id'],URL_ADMIN.'ajax.edit.php?action=link','pagerank',"fieldname=pagerank&linkid=".$row['id']."&value=".$row['pagerank'],'','','#check_pagerank_'.$row['id']);
			}
			$tablinks[]=$row;
		}
		$db->free($r);
		return $tablinks;
	}
	private function linkPriority()
	{
		global $row;
		$p = 0.0;
		if($row['time_valid'] < (30*20*60*60))//non ancien
			$p = $p + 0.1;
		if($row['time_update_valid'] < (30*15*60*60))
			$p = $p + 0.1;
		if($row['countrate'] >= 20 && $row['rate']['avg'] > $row['rate']['max']/0)
			$p = $p + 0.3;
		else if($row['countrate'] < 20 && $row['rate']['avg'] > $row['rate']['max']/2)
			$p = $p + 0.2;
		else if($row['countrate'] > 0 && $row['rate']['avg'] < $row['rate']['max']/2)
			$p = $p + 0.1;
		if($row['pr'] > 6)
			$p = $p + 0.2;
		else if($row['pr'] > 6)
			$p = $p + 0.1;
		if($row['hitsout'] > 500)
			$p = $p + 0.2;
		else if($row['hitsout'] > 100)
			$p = $p + 0.1;
		
		return $p;
	}
	function getLink($id,$fields=array())
	{//infos de la BD
		global $tb_links,$db;
		if($id > 0)
		{
			if(count($fields) == 0)
				$SQLfields = '*';//tous les champs
			else
			{//selection de champs
				$SQLfields = '';
				for($i=0;$i < count($fields);$i++)
				{
					$SQLfields .= '`'.$fields[$i].'`';
					if($i < count($fields)-1)
						$SQLfields .= ',';
				}
			}
			$r=$db->query("SELECT $SQLfields FROM `$tb_links` WHERE ".SQL_LINKS_ALL." AND `id`=$id Limit 1;");
			$row = $db->getRow($r,'MYSQL_ASSOC');
			$db->free($r);
			return $row;
		}
		else
			return array();
	}
	function getLinkForm($id)
	{//form de maj
		global $f;
		$update=$this->getLink($id);
		$return = array();
		$return[$f->form.'_catid']      =isset($update['catid'])      ?$update['catid']      :'';
		$return[$f->form.'_title']      =isset($update['title'])      ?$update['title']      :'';
		$return[$f->form.'_url']        =isset($update['url'])        ?$update['url']        :'';
		$return[$f->form.'_description']=isset($update['description'])?$update['description']:'';
		$return[$f->form.'_recip_url']  =isset($update['recip_url'])  ?$update['recip_url']  :'';
		$return[$f->form.'_feed_url']   =isset($update['feed_url'])   ?$update['feed_url']   :'';
		$return[$f->form.'_tags']       =isset($update['tags'])       ?$update['tags']           :'';
		$return[$f->form.'_user_login'] =isset($update['user_login']) ?$update['user_login'] :'';
		//les champs personaliss
		for($i=0;$i<count($f->fieldsCustomBD);$i++)
		{
			$return[$f->form.'_'.$f->fieldsCustomBD[$i]['field']]=$update[$f->fieldsCustomBD[$i]['field']];
		}
		return $return;
	}
	public function addLink($admin=false,$update=false,$linkid='')
	{
		global $db,$tb_links,$tb_mmbrs,$tb_cats,$f,$configs;
		require_once('greensdstats.class.php');
		$stat = new GreenSDStats();
		require_once('cat.class.php');
		$cat = new Cat();
		if(count($f->getErrors()) == 0)
		{
			//on rcupre les infos du membre
			$r=$db->query("SELECT `id`,`login`,`check_email` FROM `$tb_mmbrs` WHERE `login`='".gpcToBd($_POST[$f->form.'_user_login'])."' LIMIT 1;");
			$row=$db->getRow($r,'MYSQL_ASSOC');
			$datas = array(
					'catid'=>gpcToBd($_POST[$f->form.'_catid']),
					'userid'=>$row['id'],
					'user_login'=>$row['login'],
					'url'=>gpcToBd($_POST[$f->form.'_url']),
					'title'=>gpcToBd($_POST[$f->form.'_title']),
					'description'=>gpcToBd($_POST[$f->form.'_description']),
					'recip_url'=>gpcToBd($_POST[$f->form.'_recip_url']),
					'feed_url'=>gpcToBd($_POST[$f->form.'_feed_url']),
					'tags'=>gpcToBd($_POST[$f->form.'_tags']),
					'ip'=>IP,
					'check_email'=>$row['check_email']
				);
			//champs custom
			$this->selectCostumFields();
			for($i=0;$i<count($this->customFields);$i++)
			{
				$_POST[$f->form.'_'.$this->customFields[$i]] = is_array($_POST[$f->form.'_'.$this->customFields[$i]])?implode(',',$_POST[$f->form.'_'.$this->customFields[$i]]):$_POST[$f->form.'_'.$this->customFields[$i]];
				$datas[$this->customFields[$i]] = gpcToBd($_POST[$f->form.'_'.$this->customFields[$i]]);
			}
			if($update)
			{////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J////M-A-J
				if($admin)
				{//maj par admin
					$datas['updateid'] = NULL;
					$datas['time_update_submit']=time();
					if($db->updateArr($tb_links, $datas, "`id`=$linkid"))
					{
						return true;
					}
					else
						return false;
				}
				else
				{//maj par membre (ajout d'un enrigistrement de maj)
					$datas['updateid'] = $linkid;
					$datas['time_update_submit']=time();
					$row = $db->getOneRow("`$tb_links`,`$tb_cats`","`$tb_links`.`id`","`$tb_links`.`id` = $linkid AND ".SQL_LINKS_PENDING);
					$r=$db->query("SELECT `id` FROM `$tb_links` WHERE `updateid` = $linkid;");
					if(isset($row['id']) && $row['id'] > 0)
					{//si il est en attente, on autorise la mise  jour sans vrif
						$datas['updateid'] = NULL;
						if($db->updateArr($tb_links, $datas, "`id`=$linkid"))
						{
							if($configs['switch_mail_mmbr_inform_editlink'] == 'yes')
								$this->sendMail('information_link_edit',$linkid);
							return true;
						}
						else
							return false;
					}
					else if(mysql_num_rows($r) > 0)
					{//on vrifier si l'enrigistrent de maj existe
						if($db->updateArr($tb_links, $datas,"`updateid`=$linkid"))
						{
							$db->update("UPDATE `$tb_links` SET `update`='1' WHERE `id`=$linkid LIMIT 1;");//changement de status de l'origin
							$stat->GreenSDGeneral(false);//stats a jour
							$cat->statsCatUpdateStructCache(gpcToBd($_POST[$f->form.'_catid']));//initialisation du cache
							if($configs['switch_mail_mmbr_inform_editlink'] == 'yes')
								$this->sendMail('information_link_edit',$linkid);
							return true;
						}
						else
						{
							return false;
						}
					}
					else
					{//si non on cre un nouveau
						if($db->insertArr($tb_links, $datas))
						{
							$db->update("UPDATE `$tb_links` SET `update`='1' WHERE `id`=$linkid LIMIT 1;");//changement de status de l'origin
							$stat->GreenSDGeneral(false);//stats a jour
							$cat->statsCatUpdateStructCache(gpcToBd($_POST[$f->form.'_catid']));//initialisation du cache
							if($configs['switch_mail_mmbr_inform_editlink'] == 'yes')
								$this->sendMail('information_link_edit',$linkid);
							return true;
						}
						else
						{
							return false;
						}
					}
				}
			}
			else
			{////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT////AJOUT
				if($admin)
				{//ajout par admin
					if(isset($_POST[$f->form.'_valid']))
					{
						$datas['time_valid']=time();
						$datas['valid']='1';
					}
					else
						$datas['valid']='0';
					if($db->insertArr($tb_links, $datas))
					{
						$stat->GreenSDGeneral(false);
						//mise a jour les statistiques
						$cat->statsCatUpdateStructCache(gpcToBd($_POST[$f->form.'_catid']));//initialisation du cache
						return true;
					}
					else
					{
						return false;
					}
				}
				else
				{//ajou par membre
					$datas['time_submit']=time();
					$datas['valid']='0';
					if($linkid=$db->insertArr($tb_links, $datas))
					{
						//incrment le compteur
						$f->antiRobotForm($configs['config_users_antirobot_tentative_max_addlink'],$configs['config_users_antirobot_tentative_wait_addlink']);
						$stat->GreenSDGeneral(false);
						$cat->statsCatUpdateStructCache(gpcToBd($_POST[$f->form.'_catid']));//initialisation du cache
						if($configs['switch_mail_mmbr_inform_addlink'] == 'yes')
							$this->sendMail('information_link_suggest',$linkid);
						return true;
					}
					else
					{
						return false;
					}
				}
			}
		}
		else
			return false;
	}
	public function sendMail($type,$linkid)
	{
		global $configs,$tpl,$tb_links;
		require_once('greensdstats.class.php');
		$stat = new GreenSDStats();
		
		$onelink=$this->showLinks(
									"`$tb_links`.`id` = $linkid",
									$configs['config_links_orderby'],
									'',
									1,
									REWRITING,
									false
									);
		//lien
		if(isset($onelink[0]))
		{
			$tpl->assign('MLINK',$onelink[0]);
			require_once 'cat.class.php';
			require_once 'user.class.php';
			$cat = new Cat();
			$user = new User();
			//current cat
			$currentCat=$cat->showCats("`id` = ".$onelink[0]['catid'],$configs['config_cats_orderby'],'',1,0,REWRITING,false);
			$tpl->assign('MCAT',isset($currentCat[0])?$currentCat[0]:array());
			unset($currentCat);
			//member
			$MEMBER = $user->showMmbrs("`id` = ".$onelink[0]['userid'],'','',1,REWRITING,false);
			unset($cat,$link,$user);
			if(isset($MEMBER[0]))
			{
				$tpl->assign('MMEMBER',$MEMBER[0]);
				$mail = new Mail();
				$mail->AddAddress($MEMBER[0]['email']);
				unset($MEMBER);
				if ($mail->postMail($type))
				{
					$tpl->clear_assign('MLINK');
					$tpl->clear_assign('MCAT');
					$tpl->clear_assign('MMEMBER');
					return true;
				}
				else
				{
					$tpl->clear_assign('MLINK');
					$tpl->clear_assign('MCAT');
					$tpl->clear_assign('MMEMBER');
					return false;
				}
			}
			else
				return false;
			
		}
		else
		{
			unset($link);
			return false;
		}
	}
	public function checkFormUrl($update=false,$linkid='')
	{
		global $f,$tb_links;
		if($f->checkField('url',$_POST[$f->form.'_url']))
		{
			if($update)
			{
				if($f->checkField('url',array('ban_url',$_POST[$f->form.'_url'])))
				{
					if($f->checkField('url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_url']),1,"`updateid` IS NULL AND `id` != $linkid AND `delete` = '0'")))
					{//on vrifier c il ya un meme url non supprimer
						return $f->checkField('url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_url']),1,"`updateid` > 0 AND `updateid` != $linkid"));//on vrifier c il ya un meme url on mise a jour avec un autre site
					}
					else
						return false;
				}
				else
					return false;
			}
			else
			{
				if($f->checkField('url',array('ban_url',$_POST[$f->form.'_url'])))
					return $f->checkField('url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_url']),1,"`updateid` IS NULL"));
				else
					return false;
			}
		}
	}
	public function checkFormTitle($update=false,$linkid='')
	{
		global $f;
		return $f->checkField('title',$_POST[$f->form.'_title']);
	}
	public function checkFormCatid($update=false,$linkid='')
	{
		global $f,$tb_cats;
		if($f->checkField('catid',array('ctype_digit',$_POST[$f->form.'_catid'])))
			return $f->checkField('id',array('no_exist',$tb_cats,$_POST[$f->form.'_catid'],SQL_CATS_VALID));
	}
	public function checkFormRecip_url($update=false,$linkid='',$url='')
	{
		global $f,$tb_links;
		if($f->checkField('recip_url',$_POST[$f->form.'_recip_url']))
		{
			if($update)
			{
				if($f->checkField('recip_url',array('str_in_str',$_POST[$f->form.'_recip_url'],$url)))
				{
					if($f->checkField('recip_url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_recip_url']),1,"`updateid` = 0 AND `id` != $linkid")))
					{//vrifier si une autre url recip exist
						return $f->checkField('recip_url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_recip_url']),1,"`updateid` > 0 AND `updateid` != $linkid"));
					}
				}
			}
			else
			{
				//return $f->checkField('recip_url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_recip_url']),1,"`updateid` = 0"));
				return $f->checkField('recip_url',array('str_in_str',$_POST[$f->form.'_recip_url'],$url));	
			}
		}
	}
	public function checkFormFeed_url($update=false,$linkid='')
	{
		global $f,$tb_links;
		if($f->checkField('feed_url',$_POST[$f->form.'_feed_url']))
		{
			if($update)
			{
				if($f->checkField('feed_url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_feed_url']),2,"`updateid` = 0 AND `id` != $linkid")))
					return $f->checkField('feed_url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_feed_url']),1,"`updateid` > 0 AND `updateid` != $linkid"));
			}
			else
				return $f->checkField('feed_url',array('exist',$tb_links,inQuotes($_POST[$f->form.'_feed_url']),1,"`updateid` = 0"));
		}
	}
	public function checkFormDescription($update=false,$linkid='')
	{
		global $f;
		return $f->checkField('description',$_POST[$f->form.'_description']);
	}
	public function checkFormUser_login($update=false,$linkid='')
	{
		global $f,$tb_mmbrs;
		return $f->checkField('login',array('no_exist',$tb_mmbrs,inQuotes($_POST[$f->form.'_user_login']),SQL_MEMBERS_VALID));
	}
	public function checkFormTags($update=false,$linkid='')
	{
		global $f;
		return $f->checkField('tags',$_POST[$f->form.'_tags']);
	}
	public function checkAddLink($admin,$update=false,$linkid='')
	{
		global $f,$group,$configs;
		if($f->antiRobotForm($configs['config_users_antirobot_tentative_max_addlink'],$configs['config_users_antirobot_tentative_wait_addlink'],false))
		{
			$this->initFields();
			//verification
			$this->checkFormCatid($update,$linkid);
			$this->checkFormTitle($update,$linkid);
			$this->checkFormUrl($update,$linkid);
			$this->checkFormRecip_url($update,$linkid,$_POST[$f->form.'_url']);
			$this->checkFormFeed_url($update,$linkid);
			$this->checkFormDescription($update,$linkid);
			$this->checkFormUser_login($update,$linkid);
			//vrification dans champs custom
			$this->selectCostumFields();
			for($i=0;$i<count($this->customFields);$i++)
			{
				$f->checkField($this->customFields[$i],$_POST[$f->form.'_'.$this->customFields[$i]]);
			}
			//captcha
			if(!$admin && $group->can('mustCaptcha'))
			{
				$f->checkField('captcha',array('captcha',$_POST['captcha']));
			}
		}
	}
	private function initFields()
	{//initialisation des champs du formulaire
		global $f;
		//initialisation
		$_POST[$f->form.'_title']=isset($_POST[$f->form.'_title'])?$_POST[$f->form.'_title']:'';
		$_POST[$f->form.'_catid']=isset($_POST[$f->form.'_catid'])?$_POST[$f->form.'_catid']:'';
		$_POST[$f->form.'_url']=isset($_POST[$f->form.'_url'])?$_POST[$f->form.'_url']:'';
		$_POST[$f->form.'_description']=isset($_POST[$f->form.'_description'])?$_POST[$f->form.'_description']:'';
		$_POST[$f->form.'_recip_url']=isset($_POST[$f->form.'_recip_url'])?$_POST[$f->form.'_recip_url']:'';
		$_POST[$f->form.'_feed_url']=isset($_POST[$f->form.'_feed_url'])?$_POST[$f->form.'_feed_url']:'';
		$_POST[$f->form.'_tags']=isset($_POST[$f->form.'_tags'])?$_POST[$f->form.'_tags']:'';
		$_POST[$f->form.'_user_login']=isset($_POST[$f->form.'_user_login'])?$_POST[$f->form.'_user_login']:'';
		//les champs personaliss
		$this->selectCostumFields();
		for($i=0;$i<count($this->customFields);$i++)
		{
			$_POST[$f->form.'_'.$this->customFields[$i]]=isset($_POST[$f->form.'_'.$this->customFields[$i]])?$_POST[$f->form.'_'.$this->customFields[$i]]:'';
		}
	}
	public function checkRecipUrl($key,$url)
	{
		$string = getContentsUrl($url);
		if(ereg($key,$string))//recherche $key dans $string
			return true;
		else
			return false;
	}
	public function checkUrl($url, $timeout=10)
	{
		
		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		curl_setopt($ch, CURLOPT_NOBODY, TRUE);
		if (strpos($url, 'https://') === 0)
		{
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); // On ne vrifie que l'existence de la page
		}
		if (!curl_exec($ch))
		{
			return FALSE;
		}
		$ret = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);

		return in_array($ret, array(200, 301, 302));
	}
	public function getPageRank($url)
	{
		require_once '../cls/googlepr.class.php';
		$gpr = new GooglePR();
		$gpr->userAgent = USER_AGENT;
		$gpr->useCache = false;
		$pr = $gpr->GetPR($url);
		unset($gpr);
		return $pr;
	}
}
?>