<?php
require 'phpmailer/class.phpmailer.php';
require 'phpmailer/class.smtp.php';
class Mail extends PHPMailer
{
	function __construct()
	{
		//configuration
		//global $configs;
		$configs = getDatasInDb(
						array(
								'config_mail_method',
								'config_mail_from_email',
								'config_mail_from_name',
								'config_mail_smtp_host',
								'config_mail_smtp_port',
								'config_mail_smtp_secure',
								'config_mail_smtp_username',
								'config_mail_smtp_password'
						)
					);
		//$this->SMTPDebug  = true;
		if($configs['config_mail_method'] == 'smtp')
		{
			$this->IsSMTP();
			if($configs['config_mail_smtp_username'] != '' || $configs['config_mail_smtp_username'] != 'config_mail_smtp_password')
				$this->SMTPAuth   = true;                  // enable SMTP authentication
			
			if($configs['config_mail_smtp_secure'] != '')
				$this->SMTPSecure = "ssl";                 // sets the prefix to the server
			if($configs['config_mail_smtp_host'] != '')
				$this->Host       = $configs['config_mail_smtp_host'];      // sets GMAIL as the SMTP server
			if($configs['config_mail_smtp_port'] != '')	
				$this->Port       = $configs['config_mail_smtp_port'];                   // set the SMTP port 
			if($configs['config_mail_smtp_username'] != '')
				$this->Username   = $configs['config_mail_smtp_username'];  // GMAIL username
			if($configs['config_mail_smtp_password'] != '')
				$this->Password   = $configs['config_mail_smtp_password'];            // GMAIL password
		}
		else
			$this->IsMail();
			
		if($configs['config_mail_from_email'] != '')
			$this->From       = $configs['config_mail_from_email'];
		if($configs['config_mail_from_name'] != '')
			$this->FromName   = $configs['config_mail_from_name'];
		
		$this->CharSet = CHARSET;
		
		$this->IsHTML(true);
	}
	function __destruct()
	{

	}
	function postMail($name)
	{
		loadLang('ml',$name,false);
		$this->Subject    = $this->getSubject();
		$this->Body       = $this->getBody();  //HTML Body
		$this->AltBody    = $this->getAltBody(); //Text Body
		if(!$this->Send())
			return false;
		else
		{
			$this->ClearAddresses();
			return true;
		}
	}
	function compileMsg($msg)
	{
		global $tpl,$configs;
		//$tpl->assign_by_ref('GSD',$configs);
		preg_match_all('#(\{\$)([a-z0-9\._]+)(\})#i',$msg,$matches);

		////GSD////GSD////GSD////GSD////GSD////GSD////GSD
		////GSD////GSD////GSD////GSD////GSD////GSD////GSD
		/*
		 * on charge les variables de configuration qui sont ds le tpl mail, mais non charg de la db
		 */
		$datas=array();
		for($i=0;$i<count($matches[0]);$i++)
		{//config par config
			if(strpos($matches[2][$i],'.'))//. est bien un tableau (configs est tableau a une dimension)
			{
				$vartpl=explode('.',$matches[2][$i]);
				if($vartpl[0] == 'GSD')
				{
					$getvartpl=$tpl->get_template_vars($vartpl[0]);
					if(!isset($getvartpl[$vartpl[1]]))
						$datas += array($vartpl[1]);
				}
			}
		}
		//maintemant a la BD
		if(count($datas) > 0)
			$configs = updateArray($configs,getDatasInDb($datas));
		unset($datas);
		
		/*
		 * remplacer les variable trouvs par leurs valeurs ( GSD et les autres )
		 */
		for($i=0;$i<count($matches[0]);$i++)
		{
			if(strpos($matches[2][$i],'.'))
			{
				$vartpl=explode('.',$matches[2][$i]);
				$getvartpl=$tpl->get_template_vars($vartpl[0]);
				//je laisse la max a 5 pour l'instant
				if(count($vartpl) == 2 && isset($getvartpl[$vartpl[1]]))
					$msg=str_replace($matches[0][$i],$getvartpl[$vartpl[1]],$msg);
				else if(count($vartpl) == 3 && isset($getvartpl[$vartpl[1]][$vartpl[2]]))
					$msg=str_replace($matches[0][$i],$getvartpl[$vartpl[1]][$vartpl[2]],$msg);
				else if(count($vartpl) == 4 && isset($getvartpl[$vartpl[1]][$vartpl[2]][$vartpl[3]]))
					$msg=str_replace($matches[0][$i],$getvartpl[$vartpl[1]][$vartpl[2]][$vartpl[3]],$msg);
				else if(count($vartpl) == 5 && isset($getvartpl[$vartpl[1]][$vartpl[2]][$vartpl[3]][$vartpl[4]]))
					$msg=str_replace($matches[0][$i],$getvartpl[$vartpl[1]][$vartpl[2]][$vartpl[3]][$vartpl[4]],$msg);
				else if(count($vartpl) == 6 && isset($getvartpl[$vartpl[1]][$vartpl[2]][$vartpl[3]][$vartpl[4]][$vartpl[5]]))
					$msg=str_replace($matches[0][$i],$getvartpl[$vartpl[1]][$vartpl[2]][$vartpl[3]][$vartpl[4]][$vartpl[5]],$msg);
			}
			else
				$msg=str_replace($matches[0][$i],$tpl->get_template_vars($matches[2][$i]),$msg);
		}
		return $msg;
	}
	function getBody()
	{
		global $tpl;
		if($tpl->get_config_vars('body'))
			return $this->compileMsg($tpl->get_config_vars('body'));
		else
			die("erreur dans le fichier mails.".LANG_SITE.".lng: la variable 'body' manque.");
	}
	function getAltBody()
	{
		global $tpl;
		if($tpl->get_config_vars('altbody'))
			return $this->compileMsg($tpl->get_config_vars('altbody'));
		else
			die("erreur dans le fichier mails.".LANG_SITE.".lng: la variable 'altbody' manque.");
	}
	function getSubject()
	{
		global $tpl;
		if($tpl->get_config_vars('subject'))
			return $this->compileMsg($tpl->get_config_vars('subject'));
		else
			die("erreur dans le fichier mails.".LANG_SITE.".lng: la variable 'subject' manque.");
	}
}
?>