<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class Mysql
{
	private $lastQuery;
	public $queryCount;
	public $debug=false;
	private $host;
	private $user;
	private $pw;
	private $db;
	public $link;
   
   function __construct()
   {
		$this->host = '';
		$this->user = '';
		$this->pw = '';
		$this->db = '';
		$this->link = false;
		$this->queryCount=0;
	}
	function __destruct()
	{
		
	}
	
	public function connect($host='', $user='', $pw='', $db='')
	{
		if (!empty($host))
			$this->host = $host; 
		if (!empty($user))
			$this->user = $user; 
		if (!empty($pw))
			$this->pw = $pw; 
		$this->link = @mysql_pconnect($this->host, $this->user, $this->pw);

		if (!$this->link)
			return false;

		if (!$this->selectdb($db)) 
			return false;

		return $this->link; 
	}
	public function close($link)
	{
		mysql_close($link);
	}
	public function free($r)
	{
		mysql_free_result($r);
	}
	
	public function selectdb($db='')
	{
		if (!empty($db))
			$this->db = $db; 
		if (!mysql_select_db($this->db))
			return false;
			
		return true;
	}
	private function debug()
	{
		if($this->debug)
		{
			global $msgs;
				$msgs[] = " ---><font style='background-color: #000000;color:#ffffff;'>".$this->lastQuery."</font>";
				$msgs[] = " -----><font style='background-color: red;color:#ffffff;'>".mysql_error()."</font>";
		}
	}
   public function query($sql)
	{		
		$this->lastQuery = $sql;
		$r = mysql_query($sql);
		$this->debug();
		if (!$r)
			return false;
		$this->queryCount++;
		
		return $r;
	}
	public function getOneRow($table,$fields,$condition)
	{
		$r=$this->query("SELECT $fields FROM $table WHERE $condition LIMIT 1;");
		$row = $this->getRow($r,"MYSQL_ASSOC");
		$this->free($r);
		return $row;
	}
	public function getRow($result, $type='MYSQL_ASSOC')
	{
		if (!$result)
			return false;  

		if ($type == 'MYSQL_ASSOC')
			$row = mysql_fetch_array($result, MYSQL_ASSOC);
		if ($type == 'MYSQL_NUM')
			$row = mysql_fetch_array($result, MYSQL_NUM);
		if ($type == 'MYSQL_BOTH')
			$row = mysql_fetch_array($result, MYSQL_BOTH); 

		if (!$row)
			return false;
		return $row;
	}
      
	public function insert($sql)
	{
	  $this->lastQuery = $sql;
	  $r = mysql_query($sql);
	  $this->debug();
	  if (!$r)
		return false;
	  
	  $id = mysql_insert_id();
	  $this->queryCount++;
	  if ($id == 0)
		return true;
	  else
		return $id; 
	}
	public function insertArr($table, $data)
	{
		$cols = '(';
		$values = '(';
		foreach ($data as $key=>$value) 
		{ 
			$cols .= "`$key`,";  
			if (is_null($value))
				$values .= "NULL,";
			else if (is_int($value))
				$values .= "$value,";
			else
				$values .= "'$value',";
		}
		$cols = rtrim($cols, ',').')';
		$values = rtrim($values, ',').')';     
		$sql = "INSERT INTO $table $cols VALUES $values";

		return $this->insert($sql);

	}
	public function update($sql)
	{
		$this->lastQuery = $sql;
		$r = mysql_query($sql);
		$this->debug();
		if (!$r)
			return false;
		$rows = mysql_affected_rows();
		$this->queryCount++;
		if ($rows == 0)
			return true;
		else
			return $rows;
	}
	
   
	public function updateArr($table, $data, $condition)
	{
		$sql = "UPDATE `$table` SET";
		foreach ($data as $key=>$value)
		{
			$sql .= " `$key`=";  
			if (is_null($value))
				$sql .= "NULL,";
			else if (is_int($value))
				$sql .= "$value,";
			else
				$sql .= "'$value',";
		}
		$sql = rtrim($sql, ',');
		if (!empty($condition))
			$sql .= " WHERE $condition;";
		
		return $this->update($sql);
	}
	
	public function deleteOneRow($tb,$condition)
	{
		$this->lastQuery = "DELETE FROM `$tb` WHERE ".$condition." LIMIT 1;";
		$r=mysql_query($this->lastQuery);
		$this->debug();
		$this->queryCount++;
		return $r;
	}
   
	public function file ($file)
	{
		if (!file_exists($file))
			return false;
		$str = file_get_contents($file);
		if (!$str)
			return false; 

		
		$sql = explode(';', $str);
		foreach ($sql as $query)
		{
				if (!empty($query))
				{
					$this->lastQuery = $query; 
					$r = mysql_query($query);
					$this->debug();
					$this->queryCount++;
				}
		}
		return true;
	}
	public function backupDb($db,$db_name_db)
	{
		$sql = "
-- ".SCRIPT_NAME."
-- ".SCRIPT_URL."

-- Gnr le : ".date("d-m-Y H:i:s")."

--
-- Base de donnes: `".$db_name_db."`
--

-- --------------------------------------------------------

	";
		$r = mysql_list_tables($db_name_db);
		while($row = $db->getRow($r,'MYSQL_NUM'))
		{
			$r2=$db->query("SHOW CREATE TABLE ".$row[0]);//$row[0] = nom de la table
			while($row2= $db->getRow($r2,'MYSQL_NUM'))
			{
				$sql .="
--
-- Structure de la table `".$row[0]."`
--
DROP TABLE IF EXISTS `".$row[0]."`;";
			$sql .= $row2[1].';';
			$sql .="
--
-- Contenu de la table `".$row[0]."`
--	

	";
				$r3=$db->query("SELECT * FROM ".$row[0]);
				while($row3=$db->getRow($r3,'MYSQL_NUM'))
				{
					$sql .= "INSERT INTO `".$row[0]."` VALUES(";
					for($i=0;$i<count($row3);$i++)
					{
						$sql .= "'".mysql_real_escape_string($row3[$i])."', ";
					}
					$sql = rtrim($sql,', ');
					$sql .= ");";
				}
			}
		}
			return $sql;
	}
}

?>