<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










class Session 
{
	public $sess_baseVars = 'greensd';
	private $cook_lifetime = 86400;//1 jour
	private $sess_name = SCRIPT_NAME;
	function __construct($sess_name)
	{
		$this->sess_name = $sess_name;
		$this->start($this->sess_name);
		if(!isset($_SESSION[$this->sess_baseVars]))
		{
			$_SESSION = array();
			$_SESSION[$this->sess_baseVars]=array();
		}
	}
	function __destruct()
	{

	}
	public function isStart()
	{
		return isset($_SESSION[$this->sess_baseVars])?true:false;
	}
	public function start($sess_name)
	{
		session_set_cookie_params($this->cook_lifetime);
		session_name($sess_name);
		session_start();
		session_regenerate_id();
	}
	public function distory()
	{
		if($this->isStart())
		{
			$_SESSION[$this->sess_baseVars] = array();
			unset($_SESSION[$this->sess_baseVars]);
			$_SESSION = array();
	    	session_unset();
	    	@session_destroy();
			$_COOKIE = array();
		}
		else
		{
			$this->start($this->sess_name);
			$_SESSION[$this->sess_baseVars] = array();
			unset($_SESSION[$this->sess_baseVars]);
			$_SESSION = array();
	    	session_unset();
	    	@session_destroy();
			$_COOKIE = array();
		}
	}
	public function clairVar($name)
	{
		$_SESSION[$this->sess_baseVars][$name] = '';
	}
	public function delVar($name)
	{
		if(isset($_SESSION[$this->sess_baseVars][$name]))
		{
			unset($_SESSION[$this->sess_baseVars][$name]);
		}
	}
	public function getVar($name)
	{
		return $_SESSION[$this->sess_baseVars][$name];
	}
	public function setVar($name,$val)
	{
		$_SESSION[$this->sess_baseVars][$name] = $val;
	}
	public function isVar($var)
	{
		if(isset($_SESSION[$this->sess_baseVars][$var]))
			return true;
		else
			return false;
	}
	public function getSessionId()
	{
		return session_id();
	} 
}
?>