<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */








if(!isset($configs))
	die("Vous n'avez peut-tre pas encore installer GreenSD (<a href='install/index.php'>Page d'installation de GreenSD</a>).");




require 'fnts.php';
require 'cls/cache.class.php';
require 'cls/mysql.class.php';
require 'cls/smarty/libs/Smarty.class.php';
require 'cls/template.class.php';
require 'cls/user.class.php';
require 'cls/session.class.php';
require 'cls/mail.class.php';
require 'fnts/rewriting.php';


define (               "LANG", trim($configs['config_lang_admin'],'/'));
define (          "LANG_SITE", trim($configs['config_lang_site'],'/'));
define (        "DIR_AVATARS", "avatars");
define ("DIR_AVATARS_UPLOADS", "uploads");
define (       "DIR_BACKUPDB", "backupdb");
define (          "DIR_CRONS", "crons");
define (          "DIR_CACHE", trim($configs['config_dir_cache'],'/'));
define (         "TIME_CACHE", $configs['config_time_cache']*60);//en secondes
define (            "CHARSET", $configs['config_charset']);
define (         "REP_SCRIPT", trim($configs['config_rep_script'],'/'));
define (          "REP_ADMIN", trim($configs['config_rep_admin'],'/'));
define (           "REP_IMGS", trim($configs['config_rep_imgs'],'/'));
define (        "PATH_DOMAIN", rtrim($configs['config_path_domain'],'/'));
define (           "PROTOCOL", $configs['config_protocol']);
define (             "DOMAIN", rtrim($configs['config_domain'],'/'));
define (          "REWRITING", $configs['config_rewriting']);

define (                     "SELF", isset($_SERVER['PHP_SELF'])?$_SERVER['PHP_SELF']:'');
define (                 "SELF_REQ", isset($_SERVER['REQUEST_URI'])?$_SERVER['REQUEST_URI']:'');
define (                 "REFERRER", isset($_SERVER['HTTP_REFERRER'])?$_SERVER['HTTP_REFERRER']:'');
define (               "USER_AGENT", isset($_SERVER['HTTP_USER_AGENT'])?$_SERVER['HTTP_USER_AGENT']:'');
define (                       "IP", isset($_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'');
define ( "PROTOCOL_DOMAIN_SELF_REQ", PROTOCOL.DOMAIN.SELF_REQ);

if(REP_SCRIPT == "")
	define (              "PATH_SCRIPT", PATH_DOMAIN.'/');
else
	define (              "PATH_SCRIPT", PATH_DOMAIN.'/'.REP_SCRIPT.'/');

define (               "PATH_LANGS", PATH_SCRIPT."langs/");
define (       "PATH_TPLS_REP_SITE", PATH_SCRIPT."tpls/");
define (             "PATH_PLUGINS", PATH_SCRIPT."plugins/");
define (           "PATH_SCR_ADMIN", PATH_SCRIPT.REP_ADMIN."/");
define (          "PATH_TPLS_ADMIN", PATH_SCR_ADMIN."tpls/");
define (           "PATH_BACKUP_DB", PATH_SCR_ADMIN.DIR_BACKUPDB."/");
define (               "PATH_CRONS", PATH_SCR_ADMIN.DIR_CRONS."/");
define (                "PATH_IMGS", PATH_DOMAIN.'/'.REP_IMGS."/");
define (        "PATH_IMGS_AVATARS", PATH_DOMAIN.'/'.REP_IMGS."/".DIR_AVATARS."/");
define ("PATH_IMGS_AVATARS_UPLOADS", PATH_DOMAIN.'/'.REP_IMGS."/".DIR_AVATARS."/".DIR_AVATARS_UPLOADS."/");
define (               "PATH_CACHE", PATH_DOMAIN.'/'.DIR_CACHE."/");

define (                 "URL_SITE", PROTOCOL.DOMAIN);//..... .com
if(REP_SCRIPT == "")
	define (               "URL_SCRIPT", PROTOCOL.DOMAIN.'/'); //  .... .com/
else
	define (               "URL_SCRIPT", PROTOCOL.DOMAIN.'/'.REP_SCRIPT.'/'); //  .... .com/blabla/

define (                "URL_ADMIN", URL_SCRIPT.REP_ADMIN."/");
define (                 "URL_IMGS", PROTOCOL.DOMAIN.'/'.REP_IMGS.'/');
define (              "URL_PLUGINS", URL_SCRIPT.'plugins/');
define (         "URL_IMGS_AVATARS", PROTOCOL.DOMAIN.'/'.REP_IMGS.'/'.DIR_AVATARS.'/');
define (           "URL_TPLS_ADMIN", URL_SCRIPT.REP_ADMIN."/"."tpls/");
define (           "URL_IMGS_ADMIN", URL_SCRIPT.REP_ADMIN."/"."tpls/imgs/");

define (              "SCRIPT_NAME", "GreenSD");
define (            "BEGIN_GREENSD", "BEGIN_GREENSD");
define (               "SCRIPT_URL", "http://www.greenscriptdirectory.com");
////////////////////////////////////////////////////////////////////////////



//////CATS TYPE
//$TYPES_CATS=array('link');



/////MYSQL/////MYSQL/////MYSQL/////MYSQL/////MYSQL/////MYSQL
/////MYSQL/////MYSQL/////MYSQL/////MYSQL/////MYSQL/////MYSQL
define("DB_HOST"               , $configs['config_db_host']);
define("DB_USER"               , $configs['config_db_user']);
define("DB_PW"                 , $configs['config_db_pw']);
define("DB_NAME"               , $configs['config_db_name']);
define("DB_PRIFEX"             , $configs['config_db_prifex']);

unset($configs['config_db_host']);
unset($configs['config_db_user']);
unset($configs['config_db_pw']);
unset($configs['config_db_name']);
unset($configs['config_db_prifex']);

$tb_cats                       = DB_PRIFEX.'categories';
$tb_links                      = DB_PRIFEX.'links';
$tb_crons                      = DB_PRIFEX.'crons';
$tb_mmbrs                      = DB_PRIFEX.'members';
$tb_gr                         = DB_PRIFEX.'groups';
$tb_robots                     = DB_PRIFEX.'listerobots';
$tb_statsvisits                = DB_PRIFEX.'statsvisites';
$tb_comments                   = DB_PRIFEX.'comments';
$tb_lgforms                    = DB_PRIFEX.'logforms';
$tb_dt                         = DB_PRIFEX.'datas';
$tb_ckforms                    = DB_PRIFEX.'checkforms';
$tb_sess                       = DB_PRIFEX.'sessions';
$tb_stats                      = DB_PRIFEX.'stats';
$tb_lgadmins				   = DB_PRIFEX.'logadmins';
$tb_rts                        = DB_PRIFEX.'rates';
$tb_hts                        = DB_PRIFEX.'hits';
$tb_mls                        = DB_PRIFEX.'mails';

//sql catgories
define("SQL_CATS_ALL"          , "`$tb_cats`.`type` = 'link'                                                                                        ");
define("SQL_CATS_VALID"        , "`$tb_cats`.`type` = 'link' AND `$tb_cats`.`valid`  = '1' AND `$tb_cats`.`delete` = '0' AND `$tb_cats`.`hide` = '0'");
define("SQL_CATS_UPDATE"       , "`$tb_cats`.`type` = 'link'                               AND `$tb_cats`.`delete` = '0' AND `$tb_cats`.`hide` = '0'");
define("SQL_CATS_PENDING"      , "`$tb_cats`.`type` = 'link' AND `$tb_cats`.`valid`  = '0' AND `$tb_cats`.`delete` = '0' AND `$tb_cats`.`hide` = '0'");
define("SQL_CATS_HIDE"         , "`$tb_cats`.`type` = 'link'                                                             AND `$tb_cats`.`hide` = '1'");
define("SQL_CATS_DELETE"       , "`$tb_cats`.`type` = 'link'                               AND `$tb_cats`.`delete` = '1'                            ");
define("SQL_CATS_NODELETE"     , "`$tb_cats`.`type` = 'link'                               AND `$tb_cats`.`delete` = '0'                            ");
define("SQL_CATS_RECYCLE"      , "`$tb_cats`.`type` = 'link' AND `$tb_cats`.`valid`  = '1' AND `$tb_cats`.`delete` = '0' AND `$tb_cats`.`hide` = '0' AND `$tb_cats`.`parentid` > 0 AND `$tb_cats`.`parentid` NOT IN (SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_VALID.")");

//sql liens
define("SQL_LINKS_ALL"         , "`$tb_links`.`updateid` IS NULL                                                                                           ");
define("SQL_LINKS_VALID"       , "`$tb_links`.`updateid` IS NULL AND `$tb_links`.`valid`  = '1'                                AND `$tb_links`.`delete` = '0' AND `$tb_links`.`hide` = '0'                                                                 ");
define("SQL_LINKS_NOUPDATE"    , "`$tb_links`.`updateid` IS NULL                                AND `$tb_links`.`update` = '0' AND `$tb_links`.`delete` = '0' AND `$tb_links`.`hide` = '0'                                                                 ");
define("SQL_LINKS_UPDATE"      , "`$tb_links`.`updateid` IS NULL                                AND `$tb_links`.`update` = '1' AND `$tb_links`.`delete` = '0' AND `$tb_links`.`hide` = '0'                                                                 ");
define("SQL_LINKS_PENDING"     , "`$tb_links`.`updateid` IS NULL AND `$tb_links`.`valid`  = '0'                                AND `$tb_links`.`delete` = '0' AND `$tb_links`.`hide` = '0'                                                                 ");
define("SQL_LINKS_HIDE"        , "`$tb_links`.`updateid` IS NULL                                                               AND `$tb_links`.`delete` = '0' AND `$tb_links`.`hide` = '1'                                                                 ");
define("SQL_LINKS_DELETE"      , "`$tb_links`.`updateid` IS NULL                                                               AND `$tb_links`.`delete` = '1'                                                                                              ");
define("SQL_LINKS_RECIP_VALID" , "`$tb_links`.`updateid` IS NULL                                                               AND `$tb_links`.`delete` = '0'                                                           AND `$tb_links`.`recip_valid` = '1'");
define("SQL_LINKS_DEAD"        , "`$tb_links`.`updateid` IS NULL                                                               AND `$tb_links`.`delete` = '0'                              AND `$tb_links`.`dead` = '1'                                    ");
define("SQL_LINKS_RECYCLE"     , "`$tb_links`.`updateid` IS NULL AND `$tb_links`.`valid`  = '1'                                AND `$tb_links`.`delete` = '0' AND `$tb_links`.`hide` = '0'                                                                  AND `$tb_links`.`catid` > 0 AND `$tb_links`.`catid` NOT IN (SELECT `id` FROM `$tb_cats` WHERE ".SQL_CATS_VALID.")");
define("SQL_LINKS_REPORT"      , "`$tb_links`.`updateid` IS NULL                                                               AND `$tb_links`.`delete` = '0'                                                                                               AND `report` != ''");
//sql membres
define("SQL_MEMBERS_ALL"              , "1=1");
define("SQL_MEMBERS_VALID"            , "`$tb_mmbrs`.`valid` = '1' AND `$tb_mmbrs`.`delete` = '0'");
define("SQL_MEMBERS_ADMIN"            , "`$tb_mmbrs`.`valid` = '1' AND `$tb_mmbrs`.`delete` = '0' AND (`typeadmin` = 'administrator' OR `typeadmin` = 'superadministrator')");
define("SQL_MEMBERS_PENDING"          , "`$tb_mmbrs`.`valid` = '0' AND `$tb_mmbrs`.`delete` = '0'");
define("SQL_MEMBERS_DELETE"           , "                              `$tb_mmbrs`.`delete` = '1'");
define("SQL_MEMBERS_RECYCLE"          , "                              `$tb_mmbrs`.`delete` = '0' AND `$tb_mmbrs`.`id` NOT IN (SELECT `userid` FROM `$tb_links` WHERE ".SQL_LINKS_ALL.")");//pas de lien ni de commentaire
define("SQL_MEMBERS_NO_CHECK_EMAIL"   , "                              `$tb_mmbrs`.`delete` = '0' AND `$tb_mmbrs`.`check_email` = '0'");
//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE
//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE//CACHE
//ids
define(              "CACHE_CRONS_CHECK_EXECUTION", "CACHE_CRONS_CHECK_EXECUTION");//vrifier la dniere execution des crons
define(                         "CACHE_MAILS_SEND", "CACHE_MAILS_SEND");//envoi d'email
define(                "CACHE_GENRS_STATS_GENERAL", "CACHE_GENRS_STATS_GENERAL");//vrifier la dniere rgnration des statistiques gnrales
define(              "CACHE_GENRS_SUBSCAT_ID_", "CACHE_GENRS_SUBSCAT_ID_");
define(               "CACHE_GENRS_NAVCAT_ID_", "CACHE_GENRS_NAVCAT_ID_");
define(             "CACHE_GENRS_STATSCAT_ID_", "CACHE_GENRS_STATSCAT_ID_");
define(            "CACHE_GENRS_STATSMMBR_ID_", "CACHE_GENRS_STATSMMBR_ID_");
define(            "CACHE_GENRS_RATESLINK_ID_", "CACHE_GENRS_SUBSCAT_ID_");
define(      "CACHE_GENRS_PARENTSNAMESCAT_ID_", "CACHE_GENRS_PARENTSNAMESCAT_ID_");
define(    "CACHE_GENRS_SELECTORCAT_URLCATID_", "CACHE_GENRS_SELECTORCAT_URLCATID_");
define(               "CACHE_GENRS_PAGINS_ID_", "CACHE_GENRS_PAGINS_ID_");
define(                 "CACHE_GENRS_TOPS_ID_", "CACHE_GENRS_TOPS_ID_");
define(              "CACHE_GENRS_SITEMAP_ID_", "CACHE_GENRS_SITEMAP_ID_");
define(                "CACHE_GENRS_FEEDS_ID_", "CACHE_GENRS_FEEDS_ID_");
//dirs
define(                  "DIR_CACHE_PLUGINS",'plugins');
define(                  "DIR_CACHE_LINKS_RATES",'links/rates');
define(                  "DIR_CACHE_CATS_SELECTORS",'cats/selectors');
define(                  "DIR_CACHE_CATS_STATS",'cats/stats');
define(                 "DIR_CACHE_MMBRS_STATS",'mmbrs/stats');
define(                "DIR_CACHE_CATS_SUBSCAT",'cats/subscat');
define(                    "DIR_CACHE_CATS_NAV",'cats/nav');
define(                    "DIR_CACHE_CATS_PARENTSNAMES",'cats/parentsnames');
define(                    "DIR_CACHE_PAGINS",'pagins');
define(                    "DIR_CACHE_TOPS",'tops');
define(                    "DIR_CACHE_SITEMAPS",'sitemaps');
define(                    "DIR_CACHE_FEEDS",'feeds');

//les messages
$msgs = array();
$msgsw = array();
$cache = new Cache(PATH_CACHE);
$db = new Mysql;

$tpl = new template;

$tpl->assign_by_ref('MSGS',$msgs);
$tpl->assign_by_ref('MSGSW',$msgsw);



$tpl->assign_by_ref('DBTOTALQUERY',$db->queryCount);
if(get_magic_quotes_gpc())
{
   $_GET = stripslashes_array($_GET);
   $_POST = stripslashes_array($_POST);
   $_COOKIE = stripslashes_array($_COOKIE);
}

$body=array();
setcookie('GreenSD_active_cookie','GreenSD_active_cookie',time()+3600,'/',DOMAIN);


?>
