<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */








function alert($msg)
{
	echo '
		<script type="text/JavaScript"> 
<!--
$(document).ready(function(){
	alert("'.$msg.'");
}); 
//--> 
</script>
	';
}
function loadPlugin($params)
{
	extract($params);
	if(file_exists(PATH_PLUGINS.$plg_name.'/'.$plg_name.'.index.php'))
		include PATH_PLUGINS.$plg_name.'/'.$plg_name.'.index.php';
}
function banLogin($login)
{
	$configs = getDatasInDb(array('config_users_ban_logins'));
	$bansArr = explode("\r\n",$configs['config_users_ban_logins']);
	for($i=0;$i<count($bansArr);$i++)
	{
		if(!empty($bansArr[$i]))
		{
			$bansArr[$i] = str_replace('.','\.',$bansArr[$i]);
			$bansArr[$i] = str_replace('-','\-',$bansArr[$i]);
			$bansArr[$i] = str_replace('_','\_',$bansArr[$i]);
			$bansArr[$i] = str_replace('*','(.*)',$bansArr[$i]);
			if(preg_match("#(^".trim($bansArr[$i])."$)#i",$login))
				return true;
		}
	}
	return false;
}
function banUrl($url)
{
	$configs = getDatasInDb(array('config_links_ban_urls'));
	$bansArr = explode("\r\n",$configs['config_links_ban_urls']);
	for($i=0;$i<count($bansArr);$i++)
	{
		if(!empty($bansArr[$i]))
		{
			$bansArr[$i] = str_replace('.','\.',$bansArr[$i]);
			$bansArr[$i] = str_replace('-','\-',$bansArr[$i]);
			$bansArr[$i] = str_replace('*','(.*)',$bansArr[$i]);
			if(preg_match("#(^".trim($bansArr[$i])."$)#i",$url))
				return true;
		}
	}
	return false;
}
function banMail($mail)
{
	$configs = getDatasInDb(array('config_users_ban_mails'));
	$bansArr = explode("\r\n",$configs['config_users_ban_mails']);
	for($i=0;$i<count($bansArr);$i++)
	{
		if(!empty($bansArr[$i]))
		{
			$bansArr[$i] = str_replace('.','\.',$bansArr[$i]);
			$bansArr[$i] = str_replace('-','\-',$bansArr[$i]);
			$bansArr[$i] = str_replace('*','(.*)',$bansArr[$i]);
			if(preg_match("#(^".trim($bansArr[$i])."$)#i",$mail))
				return true;
		}
	}
	return false;
}
function banIp()
{
	global $configs;
	$bansArr = explode("\r\n",$configs['config_users_ban_ips']);
	for($i=0;$i<count($bansArr);$i++)
	{
		if(!empty($bansArr[$i]))
		{
			$bansArr[$i] = explode('|',$bansArr[$i]);
			if(isset($bansArr[$i][0]) && !empty($bansArr[$i][0]))
			{
				$bansArr[$i][0] = str_replace('.','\.',$bansArr[$i][0]);
				$bansArr[$i][0] = str_replace('*','(.+)?',$bansArr[$i][0]);
				
				if(preg_match("#(^".trim($bansArr[$i][0]).")#",IP))
				{
					header("Status: 403 Forbidden", false, 403);
					closeDb();
					if(isset($bansArr[$i][1]))
					{
						die('<h1>'.$bansArr[$i][1].'<h1>');
						exit(0);
					}
					else
					{
						die(0);
						exit(0);
					}
				}
			}
		}
	}
}
function createDefines()
{
	global $configs;
	define (                 "URL_TPLS", URL_SCRIPT."tpls/".$configs['theme'].'/');
	define (            "URL_TPLS_IMGS", URL_SCRIPT."tpls/".$configs['theme'].'/imgs/');
	define (           "PATH_TPLS_SITE", PATH_SCRIPT."tpls/".$configs['theme'].'/');
}
function captchaRandChars()
{
	global $configs;
	$chars = array(2, 3, 4, 5, 6, 7, 8, 9, "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "m", "n", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z");
	$majMin = array(true,false);
	$code="";
	for($i=0;$i<$configs['config_captcha_length'];$i++)
	{
		if($configs['config_captcha_font_upper_lower_case'] == 'yes')
			$code .= ($majMin[array_rand($majMin)]) ? strtoupper($chars[array_rand($chars)]) : $chars[array_rand($chars)];
		else
			$code .= $chars[array_rand($chars)];
	}
	return $code;
}
function getContentsUrl($url, $timeout = 10)
{
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	if ($userpwd)
	{
		curl_setopt($ch, CURLOPT_USERPWD, $userpwd);
	}
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}
function deleteInArray($arr,$val)
{
	$newArr = array();
	foreach($arr as $v)
	{
		if($val != $v)
			$newArr [] = $v;
	}
	return $newArr;
}
function replaceInUrl($url,$search,$replace)
{
	if(isset($_GET[$search]))
	{//si le param existe dj
	
		$search = $search.'='.$_GET[$search];
		$newUrl = str_replace('&'.$search,$replace,$url);//soit
		$newUrl = str_replace('?'.$search,$replace,$newUrl);//ou
		return $newUrl;
	}
	else
	{//si non on l'ajoute
		if(count($_GET) > 0)//avec un &
			return $url.'&'.$replace;
		else//avec ?
			return $url.'?'.$replace;
	}
}
function debugRepPathUrl()
{
	echo "LANG :".LANG."<br>";
	echo "LANG_SITE :".LANG_SITE."<br>";
	echo "DIR_AVATARS :".DIR_AVATARS."<br>";
	echo "DIR_AVATARS_UPLOADS :".DIR_AVATARS_UPLOADS."<br>";
	echo "DIR_BACKUPDB :".DIR_BACKUPDB."<br>";
	echo "DIR_CRONS :".DIR_CRONS."<br>";
	echo "DIR_CACHE :".DIR_CACHE."<br>";
	echo "REP_SCRIPT :".REP_SCRIPT."<br>";
	echo "REP_ADMIN :".REP_ADMIN."<br>";
	echo "REP_IMGS :".REP_IMGS."<br>";
	echo "PATH_DOMAIN :".PATH_DOMAIN."<br>";
	echo "DOMAIN :".DOMAIN."<br>";
	echo "PATH_SCRIPT :".PATH_SCRIPT."<br>";
	echo "PATH_LANGS :".PATH_LANGS."<br>";
	echo "PATH_TPLS_REP_SITE :".PATH_TPLS_REP_SITE."<br>";
	echo "PATH_TPLS_SITE :".PATH_TPLS_SITE."<br>";
	echo "PATH_SCR_ADMIN :".PATH_SCR_ADMIN."<br>";
	echo "PATH_TPLS_ADMIN :".PATH_TPLS_ADMIN."<br>";
	echo "PATH_BACKUP_DB :".PATH_BACKUP_DB."<br>";
	echo "PATH_CRONS :".PATH_CRONS."<br>";
	echo "PATH_IMGS :".PATH_IMGS."<br>";
	echo "PATH_IMGS_AVATARS :".PATH_IMGS_AVATARS."<br>";
	echo "PATH_IMGS_AVATARS_UPLOADS :".PATH_IMGS_AVATARS_UPLOADS."<br>";
	echo "PATH_CACHE :".PATH_CACHE."<br>";
	echo "URL_SITE :".URL_SITE."<br>";
	echo "URL_SCRIPT :".URL_SCRIPT."<br>";
	echo "URL_ADMIN :".URL_ADMIN."<br>";
	echo "URL_IMGS :".URL_IMGS."<br>";
	echo "URL_IMGS_AVATARS :".URL_IMGS_AVATARS."<br>";
	echo "URL_TPLS :".URL_TPLS."<br>";
	echo "URL_TPLS_IMGS :".URL_TPLS_IMGS."<br>";
	echo "URL_IMGS_ADMIN :".URL_IMGS_ADMIN."<br>";
}

function createGlobalUrls()
{
	global $URLS;
	$URLS = array(
				'account'=>getUrl('member_account',array(),REWRITING),
				'addCat'=>getUrl('cat_addcat',array(),REWRITING),
				'addLink'=>getUrl('link_addlink',array(),REWRITING),
				'admin'=>URL_ADMIN,
				'adminTpls'=>URL_TPLS_ADMIN,
				'adminTplsImages'=>URL_IMGS_ADMIN,
				'avatars'=>URL_IMGS_AVATARS,
				'current'=>PROTOCOL_DOMAIN_SELF_REQ,
				'feed'=>getUrl('feed',array(),REWRITING),
				'forgetPassword'=>getUrl('member_forgetpassword',array(),REWRITING),
				'images'=>URL_IMGS,
				'login'=>getUrl('user_login',array(),REWRITING),
				'logout'=>getUrl('user_logout',array(),REWRITING),
				'new'=>getUrl('link_new',array(),REWRITING),
				'plugins'=>URL_PLUGINS,
				'register'=>getUrl('register',array(),REWRITING),
				'search'=>getUrl('link_search',array(),REWRITING),
				'script'=>URL_SCRIPT,
				'sitemap'=>getUrl('sitemap',array(),REWRITING),
				'tpls'=>URL_TPLS,
				'tplsImages'=>URL_TPLS_IMGS,
				'webSite'=>URL_SITE
			);
}
function adminCanAccess($section)
{
	global $ADMIN,$user;
	if($user->isAdmin() && ($ADMIN['typeadmin'] == 'superadministrator' || in_array($section,$ADMIN['switchsadmin'])))
		return true;
	else
		return false;
}

function cookieIsActive()
{
	//setcookie('GreenSD_active_cookie','GreenSD_active_cookie',time()+10000,'/',DOMAIN);
	if(isset($_COOKIE['GreenSD_active_cookie']))
	{
		return true;
	}
	else
		return false;
}
function checkSourceFileCnf()
{
	$errors=array();

	if(!is_dir($_POST['config_path_domain'].'/'))
		$errors[]="admin_config_path_domain";

	if(!is_dir($_POST['config_path_domain'].'/'.$_POST['config_rep_script'].'/'))
		$errors[]="admin_config_rep_script";
		
	/*if(!is_dir($_POST['config_path_domain'].'/'.$_POST['config_rep_script'].'/'.$_POST['config_rep_admin'].'/'))
		$errors[]="admin_config_rep_admin";*/
		
	if(!is_dir($_POST['config_path_domain'].'/'.$_POST['config_rep_imgs'].'/'))
		$errors[]="admin_config_rep_imgs";

	if(!is_dir($_POST['config_path_domain'].'/'.$_POST['config_dir_cache'].'/'))
		$errors[]="admin_config_dir_cache";	
	
	if(!is_dir(PATH_TPLS_REP_SITE.$_POST['config_templates_site']))
		$errors[]="admin_config_templates_site";
		
	if(!is_dir(PATH_LANGS.$_POST['config_lang_site'].'/'))
		$errors[]="admin_config_lang_site";

	if(!is_dir(PATH_LANGS.$_POST['config_lang_admin'].'/'))
		$errors[]="admin_config_lang_admin";

	/*if($_POST['config_protocol'] != 'http://' && $_POST['config_protocol'] != 'https://')
		$errors[]="admin_config_protocol";
		
	if($_POST['config_rewriting'] != 'yes' && $_POST['config_rewriting'] != 'no')
		$errors[]="admin_config_rewriting";*/
	return $errors;
}
function createSourceFileCnf()
{
	$sourcephp = "";
	$sourcephp .= '<?php'."\n";
	$sourcephp .= '$configs[\'config_rep_script\']      = "'.gpcToFile($_POST['config_rep_script']).'";//reprtoire d\'installation du script exemple (sans slash a la fin) : /rep/annuare'."\n";
	$sourcephp .= '$configs[\'config_rep_admin\']       = "'.gpcToFile(isset($_POST['config_rep_admin'])?$_POST['config_rep_admin']:'admin').'";'."\n";
	$sourcephp .= '$configs[\'config_rep_imgs\']        = "'.gpcToFile($_POST['config_rep_imgs']).'";'."\n";
	$sourcephp .= '$configs[\'config_path_domain\']     = "'.gpcToFile($_POST['config_path_domain']).'";'."\n";
	$sourcephp .= '$configs[\'config_protocol\']        = "'.gpcToFile(isset($_POST['config_protocol'])?$_POST['config_protocol']:'http://').'";'."\n";
	$sourcephp .= '$configs[\'config_domain\']          = "'.gpcToFile($_POST['config_domain']).'";'."\n";
	$sourcephp .= '$configs[\'config_charset\']         = "'.gpcToFile(isset($_POST['config_charset'])?$_POST['config_charset']:'iso-8859-1').'";'."\n";
	$sourcephp .= '$configs[\'config_lang_admin\']      = "'.gpcToFile($_POST['config_lang_admin']).'";'."\n";
	$sourcephp .= '$configs[\'config_lang_site\']       = "'.gpcToFile($_POST['config_lang_site']).'";'."\n";
	$sourcephp .= '$configs[\'config_zone_time\']       =  '.gpcToFile(isset($_POST['config_zone_time'])?$_POST['config_zone_time']:0).';'."\n";
	$sourcephp .= '$configs[\'config_rewriting\']       = "'.gpcToFile(isset($_POST['config_rewriting'])?$_POST['config_rewriting']:'no').'";'."\n";
	$sourcephp .= '$configs[\'config_time_cache\']      = '.gpcToFile(isset($_POST['config_time_cache'])?$_POST['config_time_cache']:3).';//temps cache en minutes'."\n";
	$sourcephp .= '$configs[\'config_dir_cache\']       = "'.gpcToFile($_POST['config_dir_cache']).'";//rep cache'."\n";
	$sourcephp .= "\n";
	$sourcephp .= '//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL'."\n";
	$sourcephp .= '//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL//////MYSQL'."\n";
	$sourcephp .= '$configs[\'config_db_host\']      = "'.gpcToFile($_POST['config_db_host']).'";'."\n";
	$sourcephp .= '$configs[\'config_db_user\']      = "'.gpcToFile($_POST['config_db_user']).'";'."\n";
	$sourcephp .= '$configs[\'config_db_pw\']        = "'.gpcToFile($_POST['config_db_pw']).'";'."\n";
	$sourcephp .= '$configs[\'config_db_name\']      = "'.gpcToFile($_POST['config_db_name']).'";'."\n";
	$sourcephp .= '$configs[\'config_db_prifex\']    = "'.gpcToFile($_POST['config_db_prifex']).'";'."\n";
	$sourcephp .= '?>';

	return $sourcephp;
}

function yesNoToBol($data)
{
	if($data == 'yes')
		return true;
	else if($data == false)
		return false;
	else
		return null;
}
function yesNoToBolArray($datas)
{
	foreach($datas as $key => $val)
		(bool)$datas[$key] = ($val == 'yes')?true:false;
	return $datas;
}
/*
 * Si un index existe dans l'ancien tableau on le garde avec sa valeur, on cr un index numrique pour la nouvelle valeur
 */
function addArray($old,$new)
{
	foreach($new as $key => $val)
	{
		if(isset($old[$key]))
			$old[] = $val;
		else
			$old[$key] = $val;
	}
	return $old;
}
function updateArray($old,$new)
{
	foreach($new as $key => $val)
		$old[$key] = $val;
	return $old;
}
function getExtensionFile($File,$Dot=false)
{
	if($Dot == true)
	{
		$Ext = strtolower(substr($File, strrpos($File, '.')));
	}
	else
	{
		$Ext = strtolower(substr($File, strrpos($File, '.') + 1));
	}
	return $Ext;
}
function jsEdit($js,$id,$url,$fieldname,$submitdata,$type,$data,$idaction)
{//id est un tableau des ids dans l'ordre ;)
	$js_edit = "";
	if($js == "edit")
	{
		$js_edit .= '$("'.$id.'").editable("'.$url.'",{'."\n";
		$js_edit .='indicator : "<img src=\"'.URL_IMGS_ADMIN.'loading3.gif\" alt=\"\" border=\"\" />",'."\n";
		$js_edit .='tooltip   : "Doubleclick to edit...",'."\n";
		if(!empty($type))
			$js_edit .='type      : "'.$type.'",'."\n";
		$js_edit .='submit    : "OK",'."\n";
		$js_edit .='cancel    : "Cancel",'."\n";
		$js_edit .='event     : "dblclick",'."\n";
		if(!empty($data))
			$js_edit .='data      : "{'.$data.'}",'."\n";
		//$this->js_edit .='cssclass  : "ajaxedit",'."\n";
		//$this->js_edit .='style     : "height: 150px",'."\n";
		//$this->js_edit .='select : true,'."\n";
		if(!empty($submitdata))
			$submitdata = ",".$submitdata;
		$js_edit .='submitdata: { fieldname: "'.$fieldname.'"'.$submitdata.' }'."\n";
		$js_edit .='});'."\n";
	}
	else if($js == 'post')
	{
		$js_edit .= '$("'.$idaction.'").click(function(){'."\n";
			$js_edit .= '$.ajax({'."\n";
			$js_edit .= 'type: "POST",'."\n";
			$js_edit .= 'url: "'.$url.'",'."\n";
			$js_edit .= ' data: "'.$submitdata.'",'."\n";
			$js_edit .= 'beforeSend: function(){'."\n";
			$js_edit .= '$("'.$id.'").html("<img src=\"'.URL_IMGS_ADMIN.'loading3.gif\" alt=\"\" border=\"\" />");'."\n";
			$js_edit .= '},'."\n";
			$js_edit .= 'success: function(check){'."\n";
			$js_edit .= '$("'.$id.'").html(check);'."\n";
			$js_edit .= '}'."\n";
			$js_edit .= '});'."\n";
		$js_edit .= '});'."\n";
	}
	return $js_edit;
}
function inQuotes($s,$q="'")
{
	return $q.$s.$q;
}
function updateUrl($url,$replace,$rewriting)
{
	$param = explode('=',$replace);
	if(isset($_GET[$param[0]]))
	{//si le param existe dj
		$search = $param[0].'='.$_GET[$param[0]];
		return str_replace($search,$replace,$url);
	}
	else
	{//si non on l'ajoute
		if(count($_GET) > 0)//avec un &
			return $url.'&'.$replace;
		else//avec ?
			return $url.'?'.$replace;
	}
}
function parentsNamesCats($catid)
{ //utilise dans addcat
	global $tb_cats,$db;
	$nav=navCats($catid);
	$parents='';
	for($i=0;$i<count($nav);$i++)
	{
		$parents .= trim($nav[$i]['name']);
		if($i != (count($nav)-1))
			$parents .= '][';
	}
	return $parents;
}
function checkCodeAjax()
{
	global $s;
	$ajaxCodeCurrent = isset($_GET['s'])?$_GET['s']:'_&$%;:!<<>m~~~#([(';
	//$ajaxCodeParent  = isset($_SESSION['ajaxcheck'])?$_SESSION['ajaxcheck']:'&#((55([_^^)=}';
	$ajaxCodeParent  = $s->isVar('ajaxcheck')?$s->getVar('ajaxcheck'):'&#((55([_^^)=}';
	if($ajaxCodeCurrent != $ajaxCodeParent)
		notFound404();
}
function setCodeAjax()
{
	global $tpl,$s;
	//$_SESSION['ajaxcheck']=genrCodeCheckAjax();
	$s->setVar('ajaxcheck',genrCodeCheckAjax());
	$tpl->assign_by_ref('AJAXCHECK',$s->getVar('ajaxcheck'));
}
function genrCodeCheckAjax()
{
  $chars = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z");
  $majMin = array(true,false);
  $code="";
  $size=20;
  for($i=0;$i<$size;$i++)
  {
    $code .= ($majMin[array_rand($majMin)]) ? strtoupper($chars[array_rand($chars)]) : $chars[array_rand($chars)];
  }
  return $code;
}
function genrCode($size)
{
  $chars = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z");
  $majMin = array(true,false);
  $code="";
  for($i=0;$i<$size;$i++)
  {
    $code .= ($majMin[array_rand($majMin)]) ? strtoupper($chars[array_rand($chars)]) : $chars[array_rand($chars)];
  }
  return $code;
}
function genrcodeCheckEmail()
{
  $chars = array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z");
  $majMin = array(true,false);
  $code="";
  $size=30;
  for($i=0;$i<$size;$i++)
  {
    $code .= ($majMin[array_rand($majMin)]) ? strtoupper($chars[array_rand($chars)]) : $chars[array_rand($chars)];
  }
  return $code;
}
function createDirsAvatars()
{
	if(!is_dir(PATH_IMGS_AVATARS))
		mkdir(PATH_IMGS_AVATARS);//cration
	if(!is_dir(PATH_IMGS_AVATARS_UPLOADS))
		mkdir(PATH_IMGS_AVATARS_UPLOADS);//cration
	if(!is_dir(PATH_IMGS_AVATARS.'thumbs_'.DIR_AVATARS))
		mkdir(PATH_IMGS_AVATARS.'thumbs_'.DIR_AVATARS);//cration
	if(!is_dir(PATH_IMGS_AVATARS_UPLOADS.'thumbs_'.DIR_AVATARS_UPLOADS))
		mkdir(PATH_IMGS_AVATARS_UPLOADS.'thumbs_'.DIR_AVATARS_UPLOADS);//cration
}
function createDirsBackupDb()
{
	if(!is_dir(PATH_BACKUP_DB))
		mkdir(PATH_BACKUP_DB);//cration
}
function yearForm()
{
	$year=array('');
	$i=0;
	while($i < 100)
	{
		$year[]=date('Y')-$i;
		$i++;
	}
	return $year;
}
function monthForm()
{
	$month=array('');
	$i=1;
	while($i <= 12)
	{
		$month[]=$i;
		$i++;
	}
	return $month;
}
function dayForm()
{
	$day=array('');
	$i=1;
	while($i <= 31)
	{
		$day[]=$i;
		$i++;
	}
	return $day;
}
function loadLang($file,$section,$admin)
{
	global $tpl;
	if($admin)
		$lang = LANG;
	else
		$lang = LANG_SITE;
	switch($file)
	{
		case 'me' : ///menu
			if(empty($section))
				$tpl->config_load(PATH_LANGS.$lang.'/admin.menu'.'.'.$lang.'.lng');
			else
				$tpl->config_load(PATH_LANGS.$lang.'/admin.menu'.'.'.$lang.'.lng',$section);
			break;
		case 'cu' : ///custom
				if(file_exists(PATH_LANGS.$lang.'/custom.langs'.'.'.$lang.'.lng'))
				{
					if(empty($section))
						$tpl->config_load(PATH_LANGS.$lang.'/custom.langs'.'.'.$lang.'.lng');
					else
						$tpl->config_load(PATH_LANGS.$lang.'/custom.langs'.'.'.$lang.'.lng',$section);
				}
			break;
		case 'mn' : ///manuel
			if(empty($section))
				$tpl->config_load(PATH_LANGS.$lang.'/manual.langs'.'.'.$lang.'.lng');
			else
				$tpl->config_load(PATH_LANGS.$lang.'/manual.langs'.'.'.$lang.'.lng',$section);
			break;
		case 'ml' : ///mails
			if(empty($section))
				$tpl->config_load(PATH_LANGS.$lang.'/mails.langs'.'.'.$lang.'.lng');
			else
				$tpl->config_load(PATH_LANGS.$lang.'/mails.langs'.'.'.$lang.'.lng',$section);
			break;
		case 'mf' : //massage forms
			if(empty($section))
				$tpl->config_load(PATH_LANGS.$lang.'/msgs.forms'.'.'.$lang.'.lng');
			else
				$tpl->config_load(PATH_LANGS.$lang.'/msgs.forms'.'.'.$lang.'.lng',$section);
			break;
		case 'ef' ://errorsforms
			if(empty($section))
				$tpl->config_load(PATH_LANGS.$lang.'/errors.forms'.'.'.$lang.'.lng'); 
			else
				$tpl->config_load(PATH_LANGS.$lang.'/errors.forms'.'.'.$lang.'.lng',$section); 
			break;
		case 'ge' : //genetal
			if(empty($section))
				$tpl->config_load(PATH_LANGS.$lang.'/general.langs'.'.'.$lang.'.lng');
			else
				$tpl->config_load(PATH_LANGS.$lang.'/general.langs'.'.'.$lang.'.lng',$section);
			break;
		case 'ad' : //admin
			if(empty($section))
				$tpl->config_load(PATH_LANGS.$lang.'/admin.langs'.'.'.$lang.'.lng');
			else
				$tpl->config_load(PATH_LANGS.$lang.'/admin.langs'.'.'.$lang.'.lng',$section);
			break;
	}
}
function connectDb()
{
	global $db;
	if(!$db->link)
	{
		if(!$db->connect(DB_HOST, DB_USER, DB_PW, DB_NAME))
			exit(translate("db_no_connect"));
	}
}
function closeDb()
{
	global $db;
	if(isset($db->link) && $db->link)
	{
		$db->close($db->link);
	}
}
function translateArray($datas)
{
	for($i=0;$i<count($datas);$i++)
		$datas[$i] = translate($datas[$i]);
	return $datas;
}
function translateKeyArray($datas)
{
	foreach($datas as $key=>$val)
	{
		unset($datas[$key]);
		$datas[translate($key)] = $val;
	}
	return $datas;
}
function translate($datas)
{
	global $tpl;
	if($tpl->get_config_vars($datas))
		return $tpl->get_config_vars($datas);
	else
		return $datas;

}
function getUser($id)
{
	global $db,$tb_mmbrs;
	$r=$db->query("SELECT * FROM `$tb_mmbrs` WHERE `id` = $id;");
	if($r)
	{
		$user=$db->getRow($r,"MYSQL_ASSOC");
		$user['avatar_select']=$user['avatar'];
		$user['email1']=$user['email'];
		$user['email2']=$user['email'];
		$datebirth=explode('-',$user['datebirth']);
		$user['daybirth']=$datebirth[2];
		$user['monthbirth']=$datebirth[1];
		$user['yearbirth']=$datebirth[0];
		return $user;
	}
	else
		return false;
	
}
function updateDataInDb($datas)
{
	global $db,$tb_dt;
	foreach($datas as $ky => $vl)
	{
		if(!$db->update("UPDATE `$tb_dt` SET `value` = '$vl' WHERE `name`='$ky';"))
			return false;
	}
	return true;
}
function getGlobalDatasInDb()
{
	global $tb_dt,$db;
	$results=array();
	$r=$db->query("SELECT `name`,`value` FROM `$tb_dt` WHERE `global` = '1';");
	while($row=$db->getRow($r,"MYSQL_ASSOC"))
	{
		$results[$row['name']]=$row['value'];
	}
	$db->free($r);
	return $results;
}
function getDatasInDb($names,$SQLop='=')
{
	global $tb_dt,$db;
	$results=array();
	//initialisation avec le vide ;)
	for($i=0;$i<count($names);$i++)
		$results[$names[$i]]='';
	//maintenant la config
	$SQLWhereNames="`name` $SQLop '".implode("' OR `name` $SQLop '",$names)."'";
	$r=$db->query("SELECT `name`,`value` FROM `$tb_dt` WHERE $SQLWhereNames;");
	while($row=$db->getRow($r,"MYSQL_ASSOC"))
	{
		$results[$row['name']]=$row['value'];
	}
	$db->free($r);
	return $results;
}

function newNameFile($file)
{/*
permet d'avoir un nom qui n'existe pas dans le repertoire de $file, pour ne pas ecraser un fichier qui existe dja*/
	$repfile=dirname($file);/* emplacement du fichier */
	$repfile=$repfile."/";
	$extfile=strrchr($file, '.'); /* extension du fichier  qui va tre tlcharge */
	$namefile=basename($file,$extfile);/* basename extrait le nom du fichier dans la path sans l'ext */
	$namefile=formatUrl($namefile,'_');/* on formate le nom*/
	/* on vrifi s'il existe,  sinon on lui donne un autre nom et on teste de nouveau jusqu  trouver un libre ;)*/
		if(file_exists($repfile.$namefile.$extfile))
		{
			$i=0;
			$newnamefile=$namefile."_".$i.$extfile;
			while(file_exists($repfile.$newnamefile))
			{
				$newnamefile=$namefile."_".$i.$extfile;
				$i++;
			}
			$newnamefileext=$newnamefile;
		}
		else
			$newnamefileext=$namefile.$extfile;
			
	return $newnamefileext;
}
function notFound404()
{
	header("Status: 404 Not Found", false, 404);
	header("Location: ".getUrl('404',array(),REWRITING));
	redirectPage(getUrl('404',array(),REWRITING));
	exit();
}
function accessDenied401()
{
	header("Status: 401 : access denied", false, 401);
	header("Location: ".getUrl('access_denied',array(),REWRITING));
	redirectPage(getUrl('access_denied',array(),REWRITING));
	exit();
}
function redirectPage($url=URLS_CRIPT,$time=0,$display=true)
{
	if($time == 0)
		header("Location: $url");
	if($display)
		echo "<meta http-equiv=\"refresh\" content=\"$time;url=$url\" />";
	else
		return "<meta http-equiv=\"refresh\" content=\"$time;url=$url\" />";
}
function parentsNamesUrl($parents,$sep='/',$specialsChar='_')
{
	$new_s = str_replace('][',$sep,$parents);
	return formatUrl($new_s,$specialsChar,$sep);
}
function formatUrl($chaine,$replace=',',$charsPlus="")
{
	$charsPlus=str_replace('/','\/',$charsPlus);
	$newchaine= strtr($chaine,"","aaaaaaaaaaaaooooooooooooeeeeeeeecciiiiiiiiuuuuuuuuynn");
	$newchaine= strtr($newchaine,"ABCDEFGHIJKLMNOPQRSTUVWXYZ","abcdefghijklmnopqrstuvwxyz");
	$newchaine = preg_replace('/([^'."$charsPlus".'a-z0-9]+)/i', "$replace", $newchaine);
	return $newchaine; 
}
function sizeFile($octets)
{
	$sizedir = $octets;
	$unit="Octet(s)";
	if($sizedir >= 1024 && $sizedir < 1024*1024)
	{
		$sizedir = number_format($sizedir/1024, 2, '.', '');//2 chiffres aprs la vrgule
		$unit="Ko";
	}
	elseif ($sizedir >= 1024*1024 && $sizedir < 1024*1024*1024)
	{
		$sizedir = number_format($sizedir/(1024*1024), 2, '.', '');
		$unit="Mo";
	}
	elseif ($sizedir >= 1024*1024*1024)
	{
		$sizedir = number_format($sizedir/(1024*1024*1024), 2, '.', '');
		$unit="Go";
	}
	return $sizedir." ".$unit;
}
function dateFR($date)
{
	if($date == 0)
		$date="-";
	else
	{
		$nom_jour_fr = array("Dimanche", "Lundi", "Mardi", "Mercredi", "Jeudi", "Vendredi", "Samedi");
		$mois_fr = Array("", "janvier", "fvrier", "mars", "avril", "mai", "juin", "juillet", "aot", "septembre", "octobre", "novembre", "dcembre");
		list($nom_jour, $jour, $mois, $annee,$heure,$minute,$seconde) = explode('/', date("w/d/n/Y/H/i/s", $date));
		$date=$nom_jour_fr[$nom_jour].' '.$jour.' '.$mois_fr[$mois].' '.$annee.'-'.$heure.'h'.$minute;
	}
	return $date;		
}

function gpcToForm($datas)
{
	return htmlentities(trim($datas),ENT_QUOTES);
}
function gpcToBody($datas)
{
	return nl2br(htmlentities(trim($datas),ENT_QUOTES));
}
function gpcToBody_Ajax($datas)
{
	if(get_magic_quotes_gpc() == 1)
		return nl2br(htmlentities(utf8_decode(stripslashes(trim($datas))),ENT_QUOTES));
	else
		return nl2br(htmlentities(utf8_decode(trim($datas)),ENT_QUOTES));
}

function gpcToBd($datas)
{
	return mysql_real_escape_string(trim($datas));
}

function gpcToFile($datas)
{
	return trim($datas);
}
function fileToBd($datas)
{
	//return str_replace("'","''",$datas);
	return mysql_escape_string(trim($datas));
}
function gpcToBd_Ajax($datas)
{
		return mysql_real_escape_string(utf8_decode(trim($datas)));
}
function stripslashes_array($value)
{
    $value = is_array($value) ?
                array_map('stripslashes_array', $value) :
                stripslashes($value);
    return $value;
}
?>