<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */











function creatThumb($filedestination,$filesource,$newwidth,$newheight,$prefix="thumb_",$forcedim='')/* dimention en % : expemple pour 50% en met 0.5 */
{
	/* nom du fichier */
	$namefile=basename($filesource);
	/*on va virifier si le nom existe dans la distination*/
	if(file_exists($filedestination.$namefile))
		$namefile=newNameFile($filedestination.$namefile);/*on lui change de nom */
		
	/* on va chercher la taille de l image */
	$tailleimage=getimagesize($filesource);
	$width=$tailleimage[0];
	$height=$tailleimage[1];
	/* on calcul les nouvelles dimensions */
	switch ($forcedim)
	{
		case 'w':
					if($width > 0)
						$newheight=($height*($newwidth*100/$width))/100;
						break;
		case 'h':
					if($height > 0)
						$newwidth=($width*($newheight*100/$height))/100;
					break;
		default:
					
					if($width >= $height && $forcedim == 'all') {
						if($width > 0)
							$newheight=($height*($newwidth*100/$width))/100;
					} elseif($height > $width && $forcedim == 'all') {
						if($height > 0)
							$newwidth=($width*($newheight*100/$height))/100;
					}
					else if($width < $newwidth && $height < $newheight)
					{
						$newheight=$height;
						$newwidth=$width;
					}
					
	}
	/* on s'occup de l'extention */
	$ext=strtolower(strrchr($namefile, '.'));
	
	/* creation */
	$newfile = imagecreatetruecolor($newwidth, $newheight);
	//$newfile = imagecreate($newwidth,$newheight); 
	$blanc = imagecolorallocate($newfile,255,255,255);
	imagefill ( $newfile, 0, 0, $blanc);
	if($newfile) {
		switch(strtolower($ext)) {
			case '.gif':
						$copyfile = imagecreatefromgif($filesource);
						break;
			case '.jpg':
						$copyfile = imagecreatefromjpeg($filesource);
						break;
			case '.jpeg':
						$copyfile = imagecreatefromjpeg($filesource);
						break;
			case '.png':
						$copyfile = imagecreatefrompng($filesource);
						break;
			default:
						//echo "- Impossible de crer la miniature. ( vrifier l'extention code 1)<br>";
						return false;
		}
	
		/* enrgistrement */
		if(imagecopyresampled($newfile, $copyfile, 0, 0, 0, 0, $newwidth, $newheight, $width, $height)) {/* Test d'chec */
			switch(strtolower($ext))
			{
				case '.gif':
							imagegif($newfile,$filedestination.$prefix.$namefile);
							break;
				case '.jpg':
							imagejpeg($newfile,$filedestination.$prefix.$namefile);
							break;
				case '.jpeg':
							imagejpeg($newfile,$filedestination.$prefix.$namefile);
							break;
				case '.png':
							imagepng($newfile,$filedestination.$prefix.$namefile);
							break;
				default:
							//echo "- Impossible d'enrgistrer la minuature. ( vrifier l'extention code 2)<br>";
							return false;
			}
			return $prefix.$namefile;
		}else{
			return false;
		}
	}else{
		return false;
	}
	
}

?>