<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */




//{GSDTOP assign="TOP_SITE" tags="annuaire" type="links" parentsids=5 parentid=1 status="active" order="title DESC,id ASC" max=1 start=0 template="customtpl.tpl" tmpcache=20}

//require 'fnts/greensdtop.php';
//$tpl->register_function('GSDTOP','GreenSDtop');


function GreenSDtop($params)
{
	extract($params);
	global $tpl,$link,$cat,$user,$cache,$tb_cats,$tb_links,$tb_mmbrs;
	$max=isset($max)?$max:5;
	$start=isset($start)?$start:'';
	$type = isset($type)?$type:null;
	$parentid = isset($parentid)?$parentid:null;
	$parentid = ctype_digit((string)$parentid)?$parentid:null;
	$parentsids = isset($parentsids)?$parentsids:null;
	$parentsids = ctype_digit((string)$parentsids)?$parentsids:null;
	$tags = isset($tags)?$tags:null;
	$status = isset($status)?$status:null;
	$order = isset($order)?$order:null;
	$template = isset($template)?$template:false;
	$tmpcache = isset($tmpcache)?$tmpcache:null;
	//CACHE
	if(isset($tmpcache) && !ctype_digit((string)$tmpcache))
		$tmpcache = TIME_CACHE;
	//ORDER
	if(isset($order) && !empty($order))
		$order = 'ORDER BY '.$order;
	else
		$order = '';
	$idCache = CACHE_GENRS_TOPS_ID_.$assign.$type.$parentid.$parentsids.$tags.$status.$order.$max.$start.$template.$tmpcache;
	$cache->setDir(DIR_CACHE_TOPS);

	if($template == false || $cache->old($idCache,false,$tmpcache))
	{
		switch($type)
		{
			case 'members' :
				$status=isset($status)?$status:'active';
				$SQLwhere='';
				///TAGS
				if($tags === null)
					$SQLwhere .='';
				else
				{
					$tagsSpace = str_replace(' ','_',$tags);//.*|.*
					$tagsSpace = str_replace(array(',',' ,',', ',' , '),'_',$tags);//.*|.*
					$SQLwhere .= "(`$tb_mmbrs`.`login` = '$tags' OR `$tb_mmbrs`.`ip` = '$tags' OR `$tb_mmbrs`.`firstname` = '$tags' OR `$tb_mmbrs`.`lastname` = '$tags' OR `$tb_mmbrs`.`group` = '$tags' OR `$tb_mmbrs`.`country` = '$tags') AND ";
				}
				
				switch($status)
				{
					case 'all' :
							$SQLwhere = SQL_MEMBERS_ALL;//tous les membres
						break;
					case 'active' :
							$SQLwhere = SQL_MEMBERS_VALID;//les membres valident
						break;
					case 'pending' :
						$SQLwhere = SQL_MEMBERS_PENDING;//en attente de validation ou de vrification d'email
						break;
					//case 'hide' :
					//	$SQLwhere = SQL_MEMBERS_HIDE;
					//	break;
					case 'delete' :
						$SQLwhere = SQL_MEMBERS_DELETE;//les membres supprims
						break;
					case 'recycle' :
						$SQLwhere = SQL_MEMBERS_RECYCLE;//ceux qui n'ont pas de lien ni de commantaire
						break;
					case 'no_check_email' :
						$SQLwhere = SQL_MEMBERS_NO_CHECK_EMAIL;//email non vrifi
						break;
					default : 
						$SQLwhere = SQL_MEMBERS_VALID;
						break;
				}
				if(!is_object($user))
				{
					require_once 'cls/user.class.php';
					$user = new User();
				}
				$tpl->assign($assign,$user->showMmbrs($SQLwhere,$order,$start,$max,REWRITING,false));
				break;
			case 'cats' :
				$status=isset($status)?$status:'active';
				$SQLwhere='';
				///PARENTID
				if($parentid === null)
					$SQLwhere .= '';
				else
					$SQLwhere .= "`parentid` = $parentid AND ";
				///PARENTSIDS
				if($parentsids === null)
					$SQLwhere .= '';
				else
					$SQLwhere .= "(`parentsids` = '$parentsids' OR `parentsids` LIKE '%][$parentsids' OR `parentsids` LIKE '$parentsids][%' OR `parentsids` LIKE '%][$parentsids][%') AND ";
				///TAGS
				if($tags === null)
					$SQLwhere .='';
				else
				{
					$tagsSpace = str_replace(' ','_',$tags);//.*|.*
					$tagsSpace = str_replace(array(',',' ,',', ',' , '),'_',$tags);//.*|.*
					$SQLwhere .= "(`$tb_cats`.`name` REGEXP '.*$tagsSpace.*' OR `$tb_cats`.`description` REGEXP '.*$tagsSpace.*' OR `$tb_links`.`parentsnames` REGEXP '.*$tagsSpace.*') AND ";
				}
				switch($status)
				{
					case 'all' :
							$SQLwhere = $SQLwhere.SQL_CATS_ALL;
						break;
					case 'active' :
							$SQLwhere = $SQLwhere.SQL_CATS_VALID;
						break;
					case 'pending' :
						$SQLwhere = $SQLwhere.SQL_CATS_PENDING;
						break;
					case 'hide' :
						$SQLwhere = $SQLwhere.SQL_CATS_HIDE;
						break;
					case 'delete' :
						$SQLwhere = $SQLwhere.SQL_CATS_DELETE;
						break;
					case 'recycle' :
						$SQLwhere = $SQLwhere.SQL_CATS_RECYCLE;
						break;
					default : 
						$SQLwhere = $SQLwhere.SQL_CATS_VALID;
						break;
				}
				$SQLwhere=rtrim($SQLwhere,'AND ');
				if(!is_object($cat))
				{
					require_once 'cls/cat.class.php';
					$cat = new Cat();
				}
				$tpl->assign($assign,$cat->showCats($SQLwhere,$order,$start,$max,0,REWRITING,false));
				break;
			case 'links' :
				///STATUS
				
				$status=isset($status)?$status:'active';
				$SQLwhere = '';
				///PARENTIS
				if($parentid === null)
					$SQLwhere .='';
				else
					$SQLwhere .="`catid` = $parentid AND ";
				///PARENTSIDS
				if($parentsids === null)
					$SQLwhere .= '';
				else
					$SQLwhere .= "(`$tb_cats`.`parentsids` = '$parentsids' OR `$tb_cats`.`parentsids` LIKE '%][$parentsids' OR `$tb_cats`.`parentsids` LIKE '$parentsids][%' OR `$tb_cats`.`parentsids` LIKE '%][$parentsids][%') AND ";
				///TAGS
				if($tags === null)
					$SQLwhere .='';
				else
				{
					$tagsSpace = str_replace(' ','_',$tags);//.*|.*
					$tagsSpace = str_replace(array(',',' ,',', ',' , '),'_',$tags);//.*|.*
					$SQLwhere .= "(`$tb_links`.`title` REGEXP '.*$tagsSpace.*' OR `$tb_links`.`description` REGEXP '.*$tagsSpace.*' OR `$tb_links`.`tags` REGEXP '.*$tagsSpace.*' OR `$tb_links`.`url` REGEXP '.*$tagsSpace.*') AND ";
				}
				
				switch($status)
				{
					case 'all' :
							$SQLwhere = $SQLwhere.SQL_LINKS_ALL;
						break;
					case 'active' :
							$SQLwhere = $SQLwhere.SQL_LINKS_VALID;
						break;
					case 'pending' :
						$SQLwhere = $SQLwhere.SQL_LINKS_PENDING;
						break;
					case 'update' :
						$SQLwhere = $SQLwhere.SQL_LINKS_UPDATE;
						break;
					case 'hide' :
						$SQLwhere = $SQLwhere.SQL_LINKS_HIDE;
						break;
					case 'delete' :
						$SQLwhere = $SQLwhere.SQL_LINKS_DELETE;
						break;
					case 'recip_valid' :
						$SQLwhere = $SQLwhere.SQL_LINKS_RECIP_VALID;
						break;
					case 'dead' :
						$SQLwhere = $SQLwhere.SQL_LINKS_DEAD;
						break;
					case 'recycle' :
						$SQLwhere = $SQLwhere.SQL_LINKS_RECYCLE;
						break;
					case 'report' :
						$SQLwhere = $SQLwhere.SQL_LINKS_REPORT;
						break;
					default : 
						$SQLwhere = $SQLwhere.SQL_LINKS_VALID;
						break;
				}
				$SQLwhere=rtrim($SQLwhere,'AND ');
				
				if(!is_object($link))
				{
					require_once 'cls/link.class.php';
					$link = new Link();
				}

				$tpl->assign($assign,$link->showLinks(
										$SQLwhere,
										$order,
										$start,
										$max,
										REWRITING,
										false
										)
				);
				break;
		}
		//cache
		if($template != false)
		{
			$cache->create($idCache,$tpl->fetch($template));
			echo $cache->read($idCache);
		}
	}
	else
		echo $cache->read($idCache);
	$cache->setDir('');
}

?>