<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










function getUrl($type,$datas,$rewriting)
{
	global $configs,$s,$tpl;
	switch ($type)
	{
		case 'sitemap' :
			return URL_SCRIPT.'sitemap.php?action=sitemapindex';
		case 'sitemap_cat' :
			return URL_SCRIPT.'sitemap.php?action=urlset&catid='.$datas[0];
		case '404' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_404'];
			else
				return URL_SCRIPT.'404.php';
		case 'link_hitout' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace('[->linkid<-]',$datas[0],$configs['config_seo_rewriting_hitoutlink']);
			else
				return URL_SCRIPT.'hitout.php?linkid='.$datas[0];
		case 'link_rate' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace('[->linkid<-]',$datas[0],$configs['config_seo_rewriting_ratelink']);
			else
				return URL_SCRIPT.'rate.php?linkid='.$datas[0];
		case 'feed' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_feed'];
			else
				return URL_SCRIPT.'feed.php';
		case 'cat_feed' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace('[->catid<-]',$datas[0],$configs['config_seo_rewriting_feedcat']);
			else
				return URL_SCRIPT.'feed.php?catid='.$datas[0];
		case 'register' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_register'];
			else
				return URL_SCRIPT.'register.php';
		case 'captcha' :
			$s->setVar('captcha_sec',genrCode(10));
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace('[->code<-]',$s->getVar('captcha_sec'),$configs['config_seo_rewriting_captcha']);
			else
				return URL_SCRIPT.'captcha.php?sec='.$s->getVar('captcha_sec');	
		case 'access_denied' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_accessdenied'];
			else
				return URL_SCRIPT.'access_denied.php';		
		case 'link_cat' :
			//partag (showscats showlinks)
			if($rewriting == 'yes')
			{
				$urlCat = str_replace('[->parentsnames<-]',parentsNamesUrl($datas[0],$configs['config_seo_rewriting_cat_separator'],$configs['config_seo_rewriting_specialschars']),$configs['config_seo_rewriting_category']);
				return URL_SCRIPT.str_replace('[->catid<-]',$datas[1],$urlCat);
			}
			else
				return URL_SCRIPT.'index.php?catid='.$datas[1];
		case 'link_addlink' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_addlink'];
			else
				return URL_SCRIPT.'addlink.php';
		case 'link_editlink' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace('[->linkid<-]',$datas[0],$configs['config_seo_rewriting_editlink']);
			else
				return URL_SCRIPT.'editlink.php?linkid='.$datas[0];
		case 'cat_addcat' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_addcat'];
			else
				return URL_SCRIPT.'addcat.php';
		case 'link_new' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_newlinks'];
			else
				return URL_SCRIPT.'new.php';
		case 'link_search' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_search'];
			else
				return URL_SCRIPT.'search.php';
		case 'link_search_pages' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace(array('[->tags<-]','[->tags_exact<-]','[->page<-]','[->pagenum<-]'),array(formatUrl($datas[0],NULL,' '),$datas[1],$datas[2],$datas[3]),$configs['config_seo_rewriting_search_pages']);
			else
				return URL_SCRIPT.'search.php?tags='.$datas[0].'&'.$datas[2].'='.$datas[3].'&tags_exact='.$datas[1];
		case 'link_card' :
			if($rewriting == 'yes')
			{
				$urlCard = str_replace('[->parentsnames<-]',parentsNamesUrl($datas[0],$configs['config_seo_rewriting_cat_separator'],$configs['config_seo_rewriting_specialschars']),$configs['config_seo_rewriting_cardlink']);
				$urlCard = str_replace('[->title<-]',formatUrl($datas[2],$configs['config_seo_rewriting_specialschars']),$urlCard);
				$urlCard = str_replace('[->catid<-]',$datas[1],$urlCard);
				return URL_SCRIPT.str_replace('[->linkid<-]',$datas[3],$urlCard);
			}
			else
				return URL_SCRIPT.'card.php?linkid='.$datas[3];
		case 'link_report' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace('[->linkid<-]',$datas[0],$configs['config_seo_rewriting_reportlink']);
			else
				return URL_SCRIPT.'report.php?linkid='.$datas[0];
		case 'user_login' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_login'];
			else
				return URL_SCRIPT."login.php";
		case 'user_logout' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_logout'];
			else
				return URL_SCRIPT."logout.php";
		case 'member_forgetpassword' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_forgetpw'];
			else
				return URL_SCRIPT.'forget_pw.php';
		case 'member_account' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_account'];
			else
				return URL_SCRIPT."account.php";
		case 'member_edit_link' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace('[->linkid<-]',$datas[0],$configs['config_seo_rewriting_editlink']);
			else
				return URL_SCRIPT.'editlink.php?linkid='.$datas[0];
		case 'member_edit_profil' :
			if($rewriting == 'yes')
				return URL_SCRIPT.$configs['config_seo_rewriting_editprofil'];
			else
				return URL_SCRIPT."editprofil.php";
		case 'member_activation' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace(array('[->mmbrid<-]','[->code<-]'),array($datas[0],$datas[1]),$configs['config_seo_rewriting_activeaccount']);
			else
				return URL_SCRIPT."active_account.php?userid=".$datas[0]."&activation=".$datas[1];
		case 'change_email' :
			if($rewriting == 'yes')
				return URL_SCRIPT.str_replace(array('[->mmbrid<-]','[->code<-]'),array($datas[0],$datas[1]),$configs['config_seo_rewriting_changemail']);
			else
				return URL_SCRIPT."active_mail.php?userid=".$datas[0]."&activation=".$datas[1];
		case 'index' :
			return URL_SCRIPT;
			break;
		case 'admin_index' :
			return URL_ADMIN."addlink.php?section_ad=index";
		case 'admin_addLink' :
			return URL_ADMIN."addlink.php?section_ad=links-addlink";
		case 'admin_updatLink' :
			return URL_ADMIN."updatlink.php?section_ad=links-updatlink";
		case 'admin_updatUser' :
			return URL_ADMIN."updatuser.php?section_ad=users-updatuser";
		case 'admin_updatAdmin' :
			return URL_ADMIN."updatadmin.php?section_ad=users-updatadmin";
		case 'admin_addAdmin' :
			return URL_ADMIN."addAdmin.php?section_ad=users-addadmin";
		case 'admin_addUser' :
			return URL_ADMIN."adduser.php?section_ad=users-adduser";
		case 'admin_crons' :
			return URL_ADMIN."crons.php?section_ad=tools-crons";
		case 'admin_addCat' :
			return URL_ADMIN."addcat.php?section_ad=cats-addcat";
		case 'admin_updatCat' :
			return URL_ADMIN."updatcat.php?section_ad=cats-updatcat";
		default :
			return URL_SCRIPT;
	}
}
function createSourceFileHtaccess()
{
	global $configs;
	$configs = updateArray($configs,getDatasInDb(array('config_seo%'),'LIKE'));
	$source = str_replace('[->feed<-]',$configs['config_seo_rewriting_feed'],$configs['config_seo_rewriting_htaccess']);
	$source = str_replace('[->ratelink<-]',$configs['config_seo_rewriting_ratelink'],$source);
	$source = str_replace('[->hitoutlink<-]',$configs['config_seo_rewriting_hitoutlink'],$source);
	$source = str_replace('[->register<-]',$configs['config_seo_rewriting_register'],$source);
	$source = str_replace('[->accessdenied<-]',$configs['config_seo_rewriting_accessdenied'],$source);
	$source = str_replace('[->addlink<-]',$configs['config_seo_rewriting_addlink'],$source);
	$source = str_replace('[->editlink<-]',$configs['config_seo_rewriting_editlink'],$source);
	$source = str_replace('[->addcat<-]',$configs['config_seo_rewriting_addcat'],$source);
	$source = str_replace('[->newlinks<-]',$configs['config_seo_rewriting_newlinks'],$source);
	$source = str_replace('[->newlinks-pages<-]',$configs['config_seo_rewriting_newlinks_pages'],$source);
	$source = str_replace('[->search<-]',$configs['config_seo_rewriting_search'],$source);
	$source = str_replace('[->search-pages<-]',$configs['config_seo_rewriting_search_pages'],$source);
	$source = str_replace('[->login<-]',$configs['config_seo_rewriting_login'],$source);
	$source = str_replace('[->logout<-]',$configs['config_seo_rewriting_logout'],$source);
	$source = str_replace('[->forgetpw<-]',$configs['config_seo_rewriting_forgetpw'],$source);
	$source = str_replace('[->account<-]',$configs['config_seo_rewriting_account'],$source);
	$source = str_replace('[->account-pages<-]',$configs['config_seo_rewriting_account_pages'],$source);
	$source = str_replace('[->editprofil<-]',$configs['config_seo_rewriting_editprofil'],$source);
	$source = str_replace('[->captcha<-]',$configs['config_seo_rewriting_captcha'],$source);
	$source = str_replace('[->feedcat<-]',$configs['config_seo_rewriting_feedcat'],$source);
	$source = str_replace('[->category<-]',$configs['config_seo_rewriting_category'],$source);
	$source = str_replace('[->category-pages<-]',$configs['config_seo_rewriting_category_pages'],$source);
	$source = str_replace('[->cardlink<-]',$configs['config_seo_rewriting_cardlink'],$source);
	$source = str_replace('[->reportlink<-]',$configs['config_seo_rewriting_reportlink'],$source);
	$source = str_replace('[->activeaccount<-]',$configs['config_seo_rewriting_activeaccount'],$source);
	$source = str_replace('[->changemail<-]',$configs['config_seo_rewriting_changemail'],$source);
	$source = str_replace('[->404<-]',$configs['config_seo_rewriting_404'],$source);
	
	//
	//general
	$source = str_replace('[->pagenum<-]','([0-9]+)',$source);
	$source = str_replace('[->page<-]','([a-z]+)',$source);
	$source = str_replace('[->catid<-]','([0-9]+)',$source);
	$source = str_replace('[->parentsnames<-]','(.*)',$source);
	$source = str_replace('[->title<-]','(.*)',$source);
	$source = str_replace('[->linkid<-]','([0-9]+)',$source);
	$source = str_replace('[->code<-]','([a-zA-Z0-9]+)',$source);
	$source = str_replace('[->mmbrid<-]','([0-9]+)',$source);
	$source = str_replace('[->tags<-]','(.*)',$source);
	$source = str_replace('[->tags_exact<-]','(.*)',$source);
	return $source;
}

?>