<?php
/*
 * 
 * copyright : copyright (c) 2008 GreenSD - Green Script Directory
 * Licence   : Creative Commons Paternit 2.0 France (http://creativecommons.org/licenses/by/2.0/fr/)
 * Site web  : www.greenscriptdirectory.com
 * 
 */










$ins_prifex = isset($_POST['config_db_prifex'])?$_POST['config_db_prifex']:'';
$ins_tables = array();
$ins_tables['mails'] = "
--
-- Structure de la table `".$ins_prifex."mails`
--

CREATE TABLE `".$ins_prifex."mails`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `type` varchar(255) NOT NULL,
  `model` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `typeid` int(11) unsigned NOT NULL,
  `send` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;


";

$ins_tables['rates'] = "
--
-- Structure de la table `".$ins_prifex."rates`
--

CREATE TABLE `".$ins_prifex."rates`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `ip` varchar(255) NOT NULL,
  `linkid` int(11) unsigned NOT NULL,
  `rate` int(3) unsigned NOT NULL,
  `time` int(11) unsigned NOT NULL,
  `userid` int(11) unsigned default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
";

$ins_tables['members'] = "
--
-- Structure de la table `".$ins_prifex."members`
--

CREATE TABLE `".$ins_prifex."members`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `ip` varchar(255) NOT NULL,
  `login` varchar(255) NOT NULL,
  `firstname` varchar(255) default NULL,
  `lastname` varchar(255) default NULL,
  `password` varchar(255) NOT NULL,
  `email` varchar(255) NOT NULL,
  `group` varchar(255) NOT NULL default 'members',
  `time_register` int(11) unsigned NOT NULL,
  `time_last_update` int(11) unsigned default NULL,
  `time_check` int(11) unsigned default NULL,
  `time_valid` int(11) unsigned default NULL,
  `avatar` varchar(255) default NULL,
  `datebirth` date default NULL,
  `emaillive` varchar(255) default NULL,
  `emailyim` varchar(255) default NULL,
  `emailgmail` varchar(255) default NULL,
  `biographie` text,
  `website` varchar(255) default NULL,
  `singature` text,
  `zonetime` varchar(6) NOT NULL default '0',
  `country` varchar(255) default NULL,
  `typeadmin` enum('no','administrator','superadministrator') NOT NULL default 'no',
  `switchsadmin` longtext NOT NULL,
  `menuadmin` text default NULL,
  `stats` text NOT NULL,
  `check_email_address` varchar(255) NOT NULL,
  `check_email_code` varchar(255) NOT NULL,
  `check_email` enum('0','1') NOT NULL default '0',
  `send_email_accept` enum('0','1') NOT NULL default '0',
  `send_email_reject` enum('0','1') NOT NULL default '0',
  `valid` enum('0','1') NOT NULL default '0',
  `delete` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `email` (`email`),
  UNIQUE KEY `login` (`login`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

";
$ins_tables['logforms'] = "
--
-- Structure de la table `".$ins_prifex."logforms`
--

CREATE TABLE `".$ins_prifex."logforms`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `ip` varchar(255) NOT NULL,
  `userid` int(11) unsigned NOT NULL,
  `userlogin` varchar(255) NOT NULL,
  `lastconnexion` int(11) unsigned NOT NULL,
  `nbrsubmit` tinyint(2) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

";

$ins_tables['links'] = "
--
-- Structure de la table `".$ins_prifex."links`
--

CREATE TABLE `".$ins_prifex."links`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `updateid` int(11) unsigned default NULL,
  `catid` int(11) unsigned NOT NULL,
  `parentsnames` varchar(255) NOT NULL,
  `userid` int(11) unsigned NOT NULL,
  `user_login` varchar(255) NOT NULL,
  `time_submit` int(11) unsigned default NULL,
  `time_valid` int(11) unsigned default NULL,
  `time_update_submit` int(11) unsigned default NULL,
  `time_update_valid` int(11) unsigned default NULL,
  `url` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `recip_url` varchar(255) default NULL,
  `feed_url` varchar(255) default NULL,
  `tags` varchar(255) NOT NULL,
  `rate` float unsigned default NULL,
  `countrate` int(11) unsigned NOT NULL,
  `pagerank` enum('','0','1','2','3','4','5','6','7','8','9','10') NOT NULL,
  `hitsout` int(11) unsigned NOT NULL,
  `report` text NOT NULL,
  `ip` varchar(255) NOT NULL,
  `recip_valid` enum('0','1') default NULL,
  `check_email` enum('0','1') default NULL,
  `send_email_accept` enum('0','1') NOT NULL default '0',
  `send_email_reject` enum('0','1') NOT NULL default '0',
  `send_email_accept_edit` enum('0','1') NOT NULL default '0',
  `send_email_reject_edit` enum('0','1') NOT NULL default '0',
  `valid` enum('0','1') NOT NULL default '0',
  `update` enum('0','1') NOT NULL default '0',
  `hide` enum('0','1') NOT NULL default '0',
  `dead` enum('0','1') default NULL,
  `delete` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
";

$ins_tables['hits'] = "
--
-- Structure de la table `".$ins_prifex."hits`
--

CREATE TABLE `".$ins_prifex."hits`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `ip` varchar(255) character set latin1 NOT NULL,
  `type` enum('in','out') character set latin1 NOT NULL,
  `linkid` int(11) unsigned NOT NULL,
  `userid` int(11) unsigned NOT NULL,
  `time` int(11) unsigned NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

";

$ins_tables['groups'] = "
--
-- Structure de la table `".$ins_prifex."groups`
--

CREATE TABLE `".$ins_prifex."groups`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `require` enum('0','1') NOT NULL default '0',
  `group` varchar(255) NOT NULL,
  `canAddCat` enum('yes','no') NOT NULL default 'no',
  `canAddLink` enum('yes','no') NOT NULL default 'no',
  `canEditLink` enum('yes','no') NOT NULL default 'no',
  `canEditProfil` enum('yes','no') NOT NULL default 'no',
  `canRateLink` enum('yes','no') NOT NULL default 'no',
  `canReportLink` enum('yes','no') NOT NULL default 'no',
  `mustCaptcha` enum('yes','no') NOT NULL default 'yes',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `group` (`group`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
";


$ins_tables['datas'] = "
--
-- Structure de la table `".$ins_prifex."datas`
--

CREATE TABLE `".$ins_prifex."datas`
(
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `global` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

";

$ins_tables['crons'] = "
--
-- Structure de la table `".$ins_prifex."crons`
--

CREATE TABLE `".$ins_prifex."crons` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL,
  `frequency` int(11) unsigned NOT NULL default '0',
  `nextexecution` int(11) unsigned NOT NULL default '0',
  `lastexecution` int(11) unsigned NOT NULL default '0',
  `file` varchar(255) NOT NULL,
  `time` int(11) unsigned NOT NULL default '0',
  `active` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `file` (`file`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

";


$ins_tables['checkforms'] = "

--
-- Structure de la table `".$ins_prifex."checkforms`
--

CREATE TABLE `".$ins_prifex."checkforms`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `field` varchar(255) NOT NULL,
  `required` enum('yes','no') NOT NULL default 'no',
  `maxCars` int(11) unsigned NOT NULL default '0',
  `minCars` int(11) unsigned NOT NULL default '0',
  `acceptCars` varchar(255) NOT NULL,
  `formName` varchar(255) NOT NULL,
  `acceptCarsDefault` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
";


$ins_tables['categories'] = "
--
-- Structure de la table `".$ins_prifex."categories`
--

CREATE TABLE `".$ins_prifex."categories`
(
  `id` int(11) unsigned NOT NULL auto_increment,
  `type` varchar(255) NOT NULL default 'link',
  `name` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `tags` varchar(255) NOT NULL,
  `parentid` int(11) unsigned NOT NULL default '0',
  `parentsids` varchar(255) NOT NULL,
  `parentname` varchar(255) NOT NULL,
  `parentsnames` varchar(255) NOT NULL,
  `subscat` text NOT NULL,
  `nav` text NOT NULL,
  `stats` text NOT NULL,
  `icon` varchar(255) NOT NULL,
  `hide` enum('0','1') NOT NULL default '0',
  `delete` enum('0','1') NOT NULL default '0',
  `valid` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 PACK_KEYS=0;
";



$ins_tables['groups_datas'] = "
--
-- Contenu de la table `".$ins_prifex."groups`
--

INSERT INTO `".$ins_prifex."groups`
(`id`, `require`, `group`, `canAddCat`, `canAddLink`, `canEditLink`, `canEditProfil`, `canRateLink`, `canReportLink`, `mustCaptcha`)
 VALUES
(NULL , '1', 'members', 'yes', 'yes', 'yes', 'yes', 'yes', 'yes', 'no'),
(NULL , '1', 'guests', 'no', 'no', 'no', 'no', 'yes', 'yes', 'yes');


";



$ins_tables['datas_datas'] = "
--
-- Contenu de la table `".$ins_prifex."datas`
--

INSERT INTO `".$ins_prifex."datas` 
(`id`, `name`, `value`, `global`)
 VALUES
(NULL, 'ads_1', '', '1'),
(NULL, 'ads_10', '', '1'),
(NULL, 'ads_2', '', '1'),
(NULL, 'ads_3', '', '1'),
(NULL, 'ads_4', '', '1'),
(NULL, 'ads_5', '', '1'),
(NULL, 'ads_6', '', '1'),
(NULL, 'ads_7', '', '1'),
(NULL, 'ads_8', '', '1'),
(NULL, 'ads_9', '', '1'),
(NULL, 'config_avatar_extentions_allow', 'jpg,png,gif', '0'),
(NULL, 'config_avatar_height_max', '200', '0'),
(NULL, 'config_avatar_height_resize', '90', '0'),
(NULL, 'config_avatar_resize', 'yes', '0'),
(NULL, 'config_avatar_resize_small', '', '0'),
(NULL, 'config_avatar_size_max', '10', '0'),
(NULL, 'config_avatar_width_max', '200', '0'),
(NULL, 'config_avatar_width_resize', '90', '0'),
(NULL, 'config_captcha_bg_color', '77FF66', '0'),
(NULL, 'config_captcha_border_color', '225500', '0'),
(NULL, 'config_captcha_border_size', '1', '0'),
(NULL, 'config_captcha_font_color', '000000', '0'),
(NULL, 'config_captcha_font_color_random', 'no', '0'),
(NULL, 'config_captcha_font_size', '4', '0'),
(NULL, 'config_captcha_font_upper_lower_case', 'no', '1'),
(NULL, 'config_captcha_height', '40', '0'),
(NULL, 'config_captcha_length', '4', '1'),
(NULL, 'config_captcha_noise_level', 'level1', '0'),
(NULL, 'config_captcha_width', '100', '0'),
(NULL, 'config_cats_nav_cache', 'yes', '1'),
(NULL, 'config_cats_num_cols', '2', '1'),
(NULL, 'config_cats_num_subcat', '5', '1'),
(NULL, 'config_cats_orderby', 'ORDER BY `name` ASC', '1'),
(NULL, 'config_cats_selector_cache', 'yes', '1'),
(NULL, 'config_cats_stats_cache', 'yes', '1'),
(NULL, 'config_cats_subscat_cache', 'yes', '1'),
(NULL, 'config_links_ban_urls', '', '0'),
(NULL, 'config_links_hitout_by', 'ip', '1'),
(NULL, 'config_links_hitout_time_between_hitsout', '6', '1'),
(NULL, 'config_links_num_byfeed', '10', '1'),
(NULL, 'config_links_num_bypage', '10', '1'),
(NULL, 'config_links_num_cols', '3', '1'),
(NULL, 'config_links_orderby', 'ORDER BY `id` DESC', '1'),
(NULL, 'config_links_rate_by', 'ip', '1'),
(NULL, 'config_links_rate_cache', 'yes', '1'),
(NULL, 'config_links_rate_max', '10', '1'),
(NULL, 'config_links_rate_time_between_rates', '2592000', '1'),
(NULL, 'config_links_thumbs_active', 'no', '1'),
(NULL, 'config_links_thumbs_backlink', '', '1'),
(NULL, 'config_links_thumbs_url', '', '1'),
(NULL, 'config_links_types_report', 'Broken Link\r\nIncorrect category', '1'),
(NULL, 'config_mail_from_email', '', '1'),
(NULL, 'config_mail_from_name', '', '1'),
(NULL, 'config_mail_method', 'mail', '1'),
(NULL, 'config_mail_smtp_host', '', '1'),
(NULL, 'config_mail_smtp_password', '', '1'),
(NULL, 'config_mail_smtp_port', '25', '1'),
(NULL, 'config_mail_smtp_secure', '', '1'),
(NULL, 'config_mail_smtp_username', '', '1'),
(NULL, 'config_redirect_time', '5', '1'),
(NULL, 'config_seo_rewriting_404', 'notfound404/', '1'),
(NULL, 'config_seo_rewriting_accessdenied', 'access/', '1'),
(NULL, 'config_seo_rewriting_account', 'account/', '1'),
(NULL, 'config_seo_rewriting_account_pages', 'account/[->page<-]-[->pagenum<-]/', '1'),
(NULL, 'config_seo_rewriting_activeaccount', 'activeaccount/member-[->mmbrid<-]-[->code<-]/', '1'),
(NULL, 'config_seo_rewriting_addcat', 'addcat/', '1'),
(NULL, 'config_seo_rewriting_addlink', 'addlink/', '1'),
(NULL, 'config_seo_rewriting_captcha', 'captcha-[->code<-]/', '1'),
(NULL, 'config_seo_rewriting_cardlink', '[->parentsnames<-]/[->title<-]-l-[->linkid<-].html', '1'),
(NULL, 'config_seo_rewriting_category', '[->parentsnames<-]-c-[->catid<-].html', '1'),
(NULL, 'config_seo_rewriting_category_pages', '[->parentsnames<-]-c-[->catid<-]-[->page<-]-[->pagenum<-].html', '1'),
(NULL, 'config_seo_rewriting_cat_separator', '/', '1'),
(NULL, 'config_seo_rewriting_changemail', 'changemail/member-[->mmbrid<-]-[->code<-]/', '1'),
(NULL, 'config_seo_rewriting_editlink', 'editlink-[->linkid<-]/', '1'),
(NULL, 'config_seo_rewriting_editprofil', 'editprofil/', '1'),
(NULL, 'config_seo_rewriting_feed', 'feed/', '1'),
(NULL, 'config_seo_rewriting_feedcat', 'feed/category-[->catid<-]/', '1'),
(NULL, 'config_seo_rewriting_forgetpw', 'forgetpw/', '1'),
(NULL, 'config_seo_rewriting_hitoutlink', 'hitout/link-[->linkid<-]/', '1'),
(NULL, 'config_seo_rewriting_htaccess', 'RewriteEngine on\r\n\r\n#RewriteBase  /\r\n\r\nErrorDocument 404 /404.php\r\n\r\n#feed\r\nRewriteRule ^[->feed<-]?$ feed.php\r\n#ratelink\r\nRewriteRule ^[->ratelink<-]?$ rate.php?linkid=$1\r\n#hitout\r\nRewriteRule ^[->hitoutlink<-]?$ hitout.php?linkid=$1\r\n#register\r\nRewriteRule ^[->register<-]?$ register.php\r\n#access denied\r\nRewriteRule ^[->accessdenied<-]?$ access_denied.php\r\n#addlink\r\nRewriteRule ^[->addlink<-]?$ addlink.php\r\n#editlink\r\nRewriteRule ^[->editlink<-]?$ editlink.php?linkid=$1\r\n#addcat\r\nRewriteRule ^[->addcat<-]?$ addcat.php\r\n#newlinks\r\nRewriteRule ^[->newlinks-pages<-]?$ new.php?$1=$2\r\nRewriteRule ^[->newlinks<-]?$ new.php\r\n#search\r\nRewriteRule ^[->search-pages<-]?$ search.php?tags=$1&tags_exact=$2&$3=$4\r\nRewriteRule ^[->search<-]?$ search.php\r\n#login\r\nRewriteRule ^[->login<-]?$ login.php\r\n#logout\r\nRewriteRule ^[->logout<-]?$ logout.php\r\n#forget pw\r\nRewriteRule ^[->forgetpw<-]?$ forget_pw.php\r\n#account\r\nRewriteRule ^[->account-pages<-]?$ account.php?$1=$2\r\nRewriteRule ^[->account<-]?$ account.php\r\n#editprofil\r\nRewriteRule ^[->editprofil<-]?$ editprofil.php\r\n#captcha\r\nRewriteRule ^[->captcha<-]?$ captcha.php?sec=$1\r\n\r\n#feedcat\r\nRewriteRule ^[->feedcat<-]?$ feed.php?catid=$1\r\n#cat\r\nRewriteRule ^[->category-pages<-]?$ index.php?catid=$2&$3=$4\r\nRewriteRule ^[->category<-]?$ index.php?catid=$2\r\n#link card\r\nRewriteRule ^[->cardlink<-]?$ card.php?linkid=$3\r\n#report link\r\nRewriteRule ^[->reportlink<-]?$ report.php?linkid=$1\r\n\r\n#user\r\nRewriteRule ^[->activeaccount<-]?$ active_account.php?userid=$1&activation=$2\r\nRewriteRule ^[->changemail<-]?$ active_mail.php?userid=$1&activation=$2\r\n#404\r\nRewriteRule ^[->404<-]?$ 404.php', '0'),
(NULL, 'config_seo_rewriting_link_separator', '/', '1'),
(NULL, 'config_seo_rewriting_login', 'login/', '1'),
(NULL, 'config_seo_rewriting_logout', 'logout/', '1'),
(NULL, 'config_seo_rewriting_newlinks', 'new/', '1'),
(NULL, 'config_seo_rewriting_newlinks_pages', 'new/[->page<-]-[->pagenum<-]/', '1'),
(NULL, 'config_seo_rewriting_ratelink', 'rate/link-[->linkid<-]/', '1'),
(NULL, 'config_seo_rewriting_register', 'register/', '1'),
(NULL, 'config_seo_rewriting_reportlink', 'report/link-[->linkid<-]/', '1'),
(NULL, 'config_seo_rewriting_search', 'search/', '1'),
(NULL, 'config_seo_rewriting_search_pages', 'search/[->tags<-]-[->tags_exact<-]-[->page<-]-[->pagenum<-]/', '1'),
(NULL, 'config_seo_rewriting_specialschars', '_', '1'),
(NULL, 'config_seo_sitemap_cache_time', '86400', '0'),
(NULL, 'config_seo_sitemap_changefreq_cat', 'daily', '0'),
(NULL, 'config_seo_sitemap_changefreq_card', 'weekly', '0'),
(NULL, 'config_users_antirobot_tentative_max', '5', '1'),
(NULL, 'config_users_antirobot_tentative_wait', '360', '1'),
(NULL, 'config_users_antirobot_tentative_max_addlink', '3', '1'),
(NULL, 'config_users_antirobot_tentative_wait_addlink', '360', '1'),
(NULL, 'config_users_antirobot_tentative_max_addcat', '3', '1'),
(NULL, 'config_users_antirobot_tentative_wait_addcat', '360', '1'),
(NULL, 'config_users_antirobot_tentative_max_adduser', '3', '1'),
(NULL, 'config_users_antirobot_tentative_wait_adduser', '360', '1'),
(NULL, 'config_users_ban_ips', '', '1'),
(NULL, 'config_users_ban_logins', '', '0'),
(NULL, 'config_users_ban_mails', '', '0'),
(NULL, 'config_users_orderby', 'ORDER BY `login` ASC', '1'),
(NULL, 'config_users_stats_cache', 'yes', '1'),
(NULL, 'config_users_valid_account_by_admin', 'no', '1'),
(NULL, 'config_webmaster_mail', '', '1'),
(NULL, 'config_webmaster_name', '', '1'),
(NULL, 'config_website_copyright', '', '1'),
(NULL, 'config_website_description', '', '1'),
(NULL, 'config_website_tags', '', '1'),
(NULL, 'config_website_lang', '', '1'),
(NULL, 'config_website_title', '', '1'),
(NULL, 'install_time', '".time()."', '1'),
(NULL, 'stats_cat_total_cats_all', '0', '1'),
(NULL, 'stats_cat_total_cats_delete', '0', '1'),
(NULL, 'stats_cat_total_cats_hide', '0', '1'),
(NULL, 'stats_cat_total_cats_pend', '0', '1'),
(NULL, 'stats_cat_total_cats_recycle', '0', '1'),
(NULL, 'stats_cat_total_cats_valid', '0', '1'),
(NULL, 'stats_link_total_links_all', '0', '1'),
(NULL, 'stats_link_total_links_dead', '0', '1'),
(NULL, 'stats_link_total_links_delete', '0', '1'),
(NULL, 'stats_link_total_links_hide', '0', '1'),
(NULL, 'stats_link_total_links_pend', '0', '1'),
(NULL, 'stats_link_total_links_recip_valid', '0', '1'),
(NULL, 'stats_link_total_links_recycle', '0', '1'),
(NULL, 'stats_link_total_links_report', '0', '1'),
(NULL, 'stats_link_total_links_update', '0', '1'),
(NULL, 'stats_link_total_links_valid', '0', '1'),
(NULL, 'stats_mmbr_total_mmbrs_all', '0', '1'),
(NULL, 'stats_mmbr_total_mmbrs_delete', '0', '1'),
(NULL, 'stats_mmbr_total_mmbrs_no_check_email', '0', '1'),
(NULL, 'stats_mmbr_total_mmbrs_pend', '0', '1'),
(NULL, 'stats_mmbr_total_mmbrs_recycle', '0', '1'),
(NULL, 'stats_mmbr_total_mmbrs_valid', '0', '1'),
(NULL, 'switch_mail_mmbr_confirm_addaccount_accept', 'no', '1'),
(NULL, 'switch_mail_mmbr_confirm_addaccount_reject', 'no', '1'),
(NULL, 'switch_mail_mmbr_confirm_addlink_accept', 'yes', '1'),
(NULL, 'switch_mail_mmbr_confirm_addlink_reject', 'no', '1'),
(NULL, 'switch_mail_mmbr_confirm_changemail', 'no', '1'),
(NULL, 'switch_mail_mmbr_confirm_editlink_accept', 'no', '1'),
(NULL, 'switch_mail_mmbr_confirm_editlink_reject', 'no', '1'),
(NULL, 'switch_mail_mmbr_inform_addaccount', 'no', '1'),
(NULL, 'switch_mail_mmbr_inform_addlink', 'no', '1'),
(NULL, 'switch_mail_mmbr_inform_editlink', 'no', '1'),
(NULL, 'theme', 'default', '1'),
(NULL, 'version', '', '1')
;";


$ins_tables['crons_datas'] = "
--
-- Contenu de la table `".$ins_prifex."crons`
--

INSERT INTO `".$ins_prifex."crons` 
(`id`, `title`, `frequency`, `nextexecution`, `lastexecution`, `file`, `time`, `active`)
 VALUES
(NULL, 'Backup mysql', 0, 0, 0, 'backupdb.php', 0, '0'),
(NULL, 'vider le cache', 0, 0, 0, 'emptycache.php', 0, '0'),
(NULL, 'Recommencer les hits out', 0, 0, 0, 'emptyhitsout.php', 0, '0'),
(NULL, 'Recommencer les votes', 0, 0, 0, 'emptyrates.php', 0, '0');

";



$ins_tables['checkforms_datas'] = "
--
-- Contenu de la table `".$ins_prifex."checkforms`
--

INSERT INTO `".$ins_prifex."checkforms`
(`id`, `field`, `required`, `maxCars`, `minCars`, `acceptCars`, `formName`, `acceptCarsDefault`)
 VALUES
(NULL, 'name', 'yes', 0, 3, '', 'addCat', ''),
(NULL, 'description', 'no', 0, 0, '', 'addCat', ''),
(NULL, 'tags', 'no', 0, 0, '', 'addCat', ''),
(NULL, 'parentid', 'yes', 0, 0, '', 'addCat', ''),
(NULL, 'icon', 'no', 0, 0, '', 'addCat', ''),
(NULL, 'title', 'yes', 100, 2, '', 'addLink', ''),
(NULL, 'url', 'yes', 0, 0, '#^((http|https):\\\/\\\/(www\\\.)?)(.+)$#', 'addLink', '#^((http|https):\\\/\\\/(www\\\.)?)(.+)$#'),
(NULL, 'description', 'yes', 600, 20, '', 'addLink', ''),
(NULL, 'recip_url', 'no', 0, 0, '', 'addLink', ''),
(NULL, 'feed_url', 'no', 0, 0, '', 'addLink', ''),
(NULL, 'tags', 'no', 150, 10, '', 'addLink', ''),
(NULL, 'firstname', 'no', 0, 0, '', 'addUser', ''),
(NULL, 'login', 'yes', 30, 4, '#^([a-z0-9_]+)$#', 'addUser', '#^([a-z0-9_]+)$#'),
(NULL, 'lastname', 'no', 0, 0, '', 'addUser', ''),
(NULL, 'email', 'yes', 0, 0, '#^(([a-z0-9])([_\\\-\\\.a-z0-9]+)?)@([\\\.\\\-a-z0-9]+)\\\.([a-z]{2,6})#', 'addUser', '#^(([a-z0-9])([_\\\-\\\.a-z0-9]+)?)@([\\\.\\\-a-z0-9]+)\\\.([a-z]{2,6})#'),
(NULL, 'datebirth', 'no', 0, 0, '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#', 'addUser', '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#'),
(NULL, 'emaillive', 'no', 0, 0, '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#', 'addUser', '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#'),
(NULL, 'emailyim', 'no', 0, 0, '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#', 'addUser', '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#'),
(NULL, 'emailgmail', 'no', 0, 0, '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#', 'addUser', '#^(19|20)[0-9]{2}\\\-((0?[1-9])|(1[012]))\\\-((0?[1-9])|([12][0-9])|(3[01]))$#'),
(NULL, 'biographie', 'no', 0, 0, '', 'addUser', ''),
(NULL, 'website', 'no', 0, 0, '#^((http|https):\\\/\\\/(www\\\.)?)(.+)$#', 'addUser', '#^((http|https):\\\/\\\/(www\.)?)(.+)$#'),
(NULL, 'singature', 'no', 0, 0, '', 'addUser', ''),
(NULL, 'zonetime', 'no', 0, 0, '#((\\\-)|(\\\+))?([0-9]{1,2})(\\\.?)#', 'addUser', '#((\\\-)|(\\\+))?([0-9]{1,2})(\\\.?)#'),
(NULL, 'country', 'no', 0, 0, '', 'addUser', ''),
(NULL, 'password', 'yes', 0, 6, '', 'addUser', ''),
(NULL, 'avatar', 'no', 0, 0, '', 'addUser', '');

";
?>